----------------------------------------------------------
--主ui上的头象栏，如主角，选中怪物，npc后在上部出现的头象栏
--都是规则排列的，零碎的请在mainui_smallparts处理
--@author bzw
----------------------------------------------------------
MainuiHeadBar = MainuiHeadBar or BaseClass()
function MainuiHeadBar:__init()
	self.mt_layout_mainrole = nil
	self.mt_layout_otherrole = nil
	self.mt_layout_monster = nil
	self.mt_layout_npc = nil

	self.click_head_callback = nil
	self.hero_relieve_cd = -1
	self.buff_item_list = {}

	self.atk_mode = 0
	self.layout_atk_mode = nil
	self.atk_mode_item_list = {}

	self.target_obj = nil
	self.monster_type = 0
	self.boss_hp_bar_num = 50

	self.low_hp_tip_effect = nil
	self.add_hp_effect = nil

	self.is_lowhp_tiping = false
	self.monster_rewwad_t = {}
	self.mainrole_effect_img_list = {}				-- 主角战斗效果图标
	self.character_effect_img_list = {}				-- 目标战斗效果图标

	self.remind_flag_list = {}

	GlobalEventSystem:Bind(LoginEventType.RECV_MAIN_ROLE_INFO, BindTool.Bind(self.OnRecvMainRoleInfo, self))
	GlobalEventSystem:Bind(ObjectEventType.BE_SELECT, BindTool.Bind(self.OnSelectObj, self))
	GlobalEventSystem:Bind(ObjectEventType.OBJ_DEAD, BindTool.Bind(self.OnObjDead, self))
	GlobalEventSystem:Bind(ObjectEventType.OBJ_DELETE, BindTool.Bind(self.OnObjDel, self))
	GlobalEventSystem:Bind(ObjectEventType.OBJ_ATTR_CHANGE, BindTool.Bind(self.OnObjAttrChange, self))
	GlobalEventSystem:Bind(ObjectEventType.OBJ_BUFF_CHANGE, BindTool.Bind(self.OnObjBuffChange, self))
	GlobalEventSystem:Bind(SceneEventType.SCENE_CHANGE_COMPLETE, BindTool.Bind(self.OnHeadbarSceneChangeComplete, self))
	self.hero_attr_evt = GlobalEventSystem:Bind(HeroDataEvent.HERO_ATTR_CHANGE, BindTool.Bind(self.HeroAttrChange, self))
	RoleData.Instance:NotifyAttrChange(BindTool.Bind(self.OnFlushBuffLayout, self))
	self.hero_relive_evt = GlobalEventSystem:Bind(HeroDataEvent.HERO_RELIVE_CNT, BindTool.Bind(self.HeroReliveChange, self))
	self.hero_attck_state = GlobalEventSystem:Bind(HeroGoldEvent.HeroGoldState, BindTool.Bind(self.HeroAttackState, self))
end

function MainuiHeadBar:__delete()
	self:CancelMainRoleAvatar()
	if self.mode_alert then
		self.mode_alert:DeleteMe()
		self.mode_alert = nil
	end
	for k,v in pairs(self.monster_rewwad_t) do
		v:DeleteMe()
	end

	if self.atk_mode_list then
		self.atk_mode_list:DeleteMe()
		self.atk_mode_list = nil
	end	
	if self.hero_relive_cd_numBar then
		self.hero_relive_cd_numBar:DeleteMe()
		self.hero_relive_cd_numBar = nil
	end

	if self.hero_relive_evt then
		GlobalEventSystem:UnBind(self.hero_relive_evt)
		self.hero_relive_evt = nil
	end	

	self:DelReliveCDTimer()
	if self.hero_attr_evt then
		GlobalEventSystem:UnBind(self.hero_attr_evt)
		self.hero_attr_evt = nil
	end

	if self.hero_attck_state then
		GlobalEventSystem:UnBind(self.hero_attck_state)
		self.hero_attck_state = nil
	end

	self.monster_rewwad_t = {}
	self.remind_flag_list = {}
	if self.time_handler then
		GlobalTimerQuest:CancelQuest(self.time_handler)
		self.time_handler = nil
	end	
end

function MainuiHeadBar:HeadImg()
	return self.img_mainrole_head
end

function MainuiHeadBar:OnRecvMainRoleInfo()
	self:SetAttackMode(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PK_MODE))
	
	self:SetMainRoleName(RoleData.Instance:GetAttr("name"))
	self:UpdateBattle()
	self:SetMainRoleLevel(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CIRCLE).."转"..RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_LEVEL).."级")

	self:UpdateMainRoleAvatar()
	local job = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_JOB_LEVEL)
	if job == 1 then
		self:SetMainRoleProf(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PROF)+3)
	else
		self:SetMainRoleProf(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PROF))
	end
	self:InitMainRoleHpMpBar()
end

function MainuiHeadBar:InitMainRoleHpMpBar()
	local hp_percent = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP) / (RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP) == 0 and 1 or RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP))
	local mp_percent = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP) / (RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP) == 0 and 1 or RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP))
	hp_percent = hp_percent * 100
	mp_percent = mp_percent * 100
	self.main_role_hpbar:setPercent(hp_percent)
	self.main_role_mpbar:setPercent(mp_percent)
	local hp_num = CommonDataManager.ConverHpMp(RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP))
	local mp_num = CommonDataManager.ConverHpMp(RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP))
	local hp_value = math.floor(hp_percent)
	local mp_value = math.floor(mp_percent)
	local txt_hp = string.format(Language.Common.HpMp, hp_value)
	local txt_mp = string.format(Language.Common.HpMp, mp_value)
	self.mainrole_text_hp:setString(hp_num .. txt_hp)
	self.mainrole_text_mp:setString(mp_num .. txt_mp)
	local level = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_VIP_GRADE) or 0
	-- if level>=13 then
		-- self.img_vip_bag:loadTexture(ResPath.GetMainui("role_head_vip2"))
		-- self.img_vip_level:loadTexture(ResPath.GetMainui("vip_num_" .. level-12))
	-- else
		self.img_vip_bag:loadTexture(ResPath.GetMainui("role_head_vip"))
		self.img_vip_level:loadTexture(ResPath.GetMainui("vip_num_" .. level))
	-- end
end

function MainuiHeadBar:Init(mt_layout_root)
	self:InitMainRoleHead(mt_layout_root)
	self:InitOtherRoleHead(mt_layout_root)
	self:InitMonsterHead(mt_layout_root)
	self:InitHeroHead(mt_layout_root)
	-- self:InitNpcHead()
end

function MainuiHeadBar:InitMainRoleHead(mt_layout_root)--角色头像
	local size = cc.size(300, 120)
	self.mt_layout_mainrole = MainuiMultiLayout.CreateMultiLayout(-30+60, HandleRenderUnit:GetHeight() - size.height+4, cc.p(0, 0), size, mt_layout_root)

	local size = self.mt_layout_mainrole:getContentSize()

	-- self.img_bar_bg = XUI.CreateImageView(230, 53, ResPath.GetMainui("loading_bar"), true)--血条底框
	-- self.mt_layout_mainrole:TextureLayout():addChild(self.img_bar_bg)

	-- local remind_flag = XUI.CreateImageView(100, 100, ResPath.GetMainui("remind_flag"), true)
	-- self.mt_layout_mainrole:TextureLayout():addChild(remind_flag)

	self.img_head_bg = XUI.CreateImageView(35, 10, ResPath.GetMainui("mainrole_head_bg"), true)--头像底框
	self.mt_layout_mainrole:TextureLayout():addChild(self.img_head_bg)
	self.img_head_bg:setTouchEnabled(true)
	self.img_head_bg:setIsHittedScale(false)
	self.img_head_bg:setAnchorPoint(0,0)
	self.img_head_bg:addClickEventListener(BindTool.Bind1(self.OnClickMainRoleHead, self))
	
    self.effec = RenderUnit.CreateEffect(1003, self.mt_layout_mainrole:TextureLayout(), 0, nil, nil, 180, 85)
	self.effec:setPositionX(260)
	self.effec:setPositionY(75)
	self.effec:setScale(0.7)
	
	
	self.main_role_hpbar =  XUI.CreateLoadingBar(145, 50, ResPath.GetMainui("loading_hp"), true, nil, true, 190, 15, cc.rect(7,6,3,3))--血条
	self.main_role_hpbar:setPercent(100)
	self.main_role_hpbar:setAnchorPoint(0,0)
	self.mt_layout_mainrole:TextureLayout():addChild(self.main_role_hpbar)

	self.main_role_mpbar =  XUI.CreateLoadingBar(145, 30, ResPath.GetMainui("loading_mp"), true, nil, true, 180, 15, cc.rect(7,6,3,3))--蓝条
	self.main_role_mpbar:setPercent(100)
	self.main_role_mpbar:setAnchorPoint(0,0)
	self.mt_layout_mainrole:TextureLayout():addChild(self.main_role_mpbar)

	self.img_mainrole_head = XUI.CreateImageView(95, 63, ResPath.GetRoleHead("big_1_0"), true)--头像
	self.mt_layout_mainrole:TextureLayout():addChild(self.img_mainrole_head)

	self.mainrole_text_hp = XUI.CreateText(130, 60, 200, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--血数字
	self.mainrole_text_hp:setAnchorPoint(0,0.5)
	self.mt_layout_mainrole:TextLayout():addChild(self.mainrole_text_hp, 2)

	self.mainrole_text_mp = XUI.CreateText(130, 40, 200, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--蓝数字
	self.mainrole_text_mp:setAnchorPoint(0,0.5)
	self.mt_layout_mainrole:TextLayout():addChild(self.mainrole_text_mp, 2)

	local level_bg = XUI.CreateImageView(90, size.height - 90, ResPath.GetMainui("level_bg1"), true)--等级底框
	self.mt_layout_mainrole:TextureLayout():addChild(level_bg,1)

	self.label_mainrole_level = XUI.CreateText(90, size.height - 90, 100, 0, cc.TEXT_ALIGNMENT_CENTER,"",nil,nil,nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--等级数字
	self.label_mainrole_level:setAnchorPoint(0.5, 0.5)
	self.mt_layout_mainrole:TextLayout():addChild(self.label_mainrole_level, 2)

	-- local job_bg = XUI.CreateImageView(148, size.height - 104, ResPath.GetMainui("job_bg"), true)
	-- self.mt_layout_mainrole:TextureLayout():addChild(job_bg, 2)
	self.job_img = XUI.CreateImageView(60, size.height - 30, ResPath.GetSkillIcon("prof_1"), true)--职业
	self.mt_layout_mainrole:TextureLayout():addChild(self.job_img, 2)
	self.label_mainrole_prof = XUI.CreateText(148, size.height - 104, 100, 0, cc.TEXT_ALIGNMENT_CENTER,"",nil,nil,nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	self.label_mainrole_prof:setAnchorPoint(0.5, 0.5)
	self.mt_layout_mainrole:TextLayout():addChild(self.label_mainrole_prof, 1)
	
	local img_zhanli = XUI.CreateImageView(180, 85, ResPath.GetMainui("word_zhanli"), true)--战力标志
	self.mt_layout_mainrole:TextureLayout():addChild(img_zhanli)
	

	self.number_zhanli = self:CreateNumBar(210, 73, 100, 20)--战力数字
	self.mt_layout_mainrole:TextureLayout():addChild(self.number_zhanli:GetView())

	
	-- self.mainrole_name_text = XUI.CreateText(140, 60, 200, 0, cc.TEXT_ALIGNMENT_LEFT,"",nil,nil,nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	-- self.mainrole_name_text:setAnchorPoint(0,0.5)
	-- self.mt_layout_mainrole:TextLayout():addChild(self.mainrole_name_text, 1)

	local level = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_VIP_GRADE) or 0
	local img_vip_bg = XUI.CreateImageView(90, size.height - 111, ResPath.GetMainui("role_vip_bg"), true)--VIP底框
	self.mt_layout_mainrole:TextureLayout():addChild(img_vip_bg)
	self.img_vip_bag = XUI.CreateImageView(80, size.height - 113, ResPath.GetMainui("role_head_vip"), true)--VIP标志
	self.mt_layout_mainrole:TextureLayout():addChild(self.img_vip_bag, 10)
	self.img_vip_level = XUI.CreateImageView(115, size.height - 112, ResPath.GetMainui("vip_num_" .. level))--VIP数字等级
	self.mt_layout_mainrole:TextureLayout():addChild(self.img_vip_level, 11)
	XUI.AddClickEventListener(self.img_vip_bag, function()
		ViewManager.Instance:Open(ViewName.Vip)
	end)
	XUI.AddClickEventListener(self.img_vip_level, function()
		ViewManager.Instance:Open(ViewName.Vip)
	end)
	-- local vip_img_size = self.img_vip_bag:getContentSize()--领取奖励时候的特效
	-- local vip_remind_flag = RenderUnit.CreateEffect(11, self.img_vip_bag, 200, FrameTime.Effect, COMMON_CONSTS.MAX_LOOPS)
	-- -- local vip_remind_flag = XUI.CreateImageView(vip_img_size.width - 3, vip_img_size.height - 3, ResPath.GetMainui("remind_flag"), true)
	-- vip_remind_flag:setVisible(false)
	-- vip_remind_flag:setScale(0.55)
	-- vip_remind_flag:setScaleY(0.8)
	-- self.remind_flag_list[RemindGroupName.VipView] = vip_remind_flag



	self.btn_atk_mode = XUI.CreateButton(188, 8, 79, 34, true, ResPath.GetMainui("zt"), "", "", true)--攻击模式
	self.btn_atk_mode:setTitleText(Language.Mainui.AttackModeCompleteText[0])
	self.btn_atk_mode:setTitleFontSize(20)
	self.btn_atk_mode:setTitleFontName(COMMON_CONSTS.FONT)
	self.btn_atk_mode:setTitleColor(ATTACKMODE_COCOR3B[0])
	self.mt_layout_mainrole:TextureLayout():addChild(self.btn_atk_mode, 1)
	self.btn_atk_mode:addClickEventListener(BindTool.Bind1(self.OnClickAttackMode, self))

	self.btn_buff = XUI.CreateButton(self.btn_atk_mode:getPositionX() + 83, self.btn_atk_mode:getPositionY(), 79, 34, true, ResPath.GetMainui("BUFF"), "", "", true)--buff
	self.btn_buff:setTitleText("BUFF")
	self.btn_buff:setTitleFontSize(20)
	self.btn_buff:setTitleFontName(COMMON_CONSTS.FONT)
	self.mt_layout_mainrole:TextureLayout():addChild(self.btn_buff, 1)
	self.btn_buff:addClickEventListener(BindTool.Bind1(self.OnClickBuff, self))
	
    self.effec1 = RenderUnit.CreateEffect(1002, self.mt_layout_mainrole:TextureLayout(), 0, nil, nil, 180, 85)
	self.effec1:setPosition(90, 85)
	self.effec1:setScale(0.57,1.0)
	
end

function MainuiHeadBar:InitOtherRoleHead(mt_layout_root)--查看他人头像
	local size = cc.size(309, 122)
	self.mt_layout_otherrole = MainuiMultiLayout.CreateMultiLayout(480, HandleRenderUnit:GetHeight() - size.height-11, cc.p(0, 0), size, mt_layout_root)
	self.mt_layout_otherrole:setVisible(false)


	local img_head_bg = XUI.CreateImageView(0, 35, ResPath.GetMainui("target_head_bg"), true)--头像底框
	img_head_bg:setAnchorPoint(0,0)
	self.mt_layout_otherrole:TextureLayout():addChild(img_head_bg)

	self.otherrole_hpbar = XUI.CreateLoadingBar(95, 68, ResPath.GetMainui("loading_hp"), true, nil, true, 200, 15, cc.rect(7,6,3,3))--血条
	self.otherrole_hpbar:setPercent(100)
	self.otherrole_hpbar:setAnchorPoint(0,0)
	self.mt_layout_otherrole:TextureLayout():addChild(self.otherrole_hpbar)

	self.otherrole_mpbar = XUI.CreateLoadingBar(95, 50, ResPath.GetMainui("loading_mp"), true, nil, true, 190, 15, cc.rect(7,6,3,3))--蓝条
	self.otherrole_mpbar:setPercent(100)
	self.otherrole_mpbar:setAnchorPoint(0,0)
	self.mt_layout_otherrole:TextureLayout():addChild(self.otherrole_mpbar)
	

	self.otherrole_close = XUI.CreateImageView(330, size.height - 24, ResPath.GetCommon("btn_132"), true)--退出按钮
	self.mt_layout_otherrole:TextureLayout():addChild(self.otherrole_close)
	XUI.AddClickEventListener(self.otherrole_close, function()
		 Scene.Instance:GetMainRole():DoSelectSceneObj(nil,false)
	end)
	self.otherrole_head = RoleHeadCell.New(false)
	self.otherrole_head:SetPosition(40, size.height - 40)--头像
	self.mt_layout_otherrole:TextureLayout():addChild(self.otherrole_head:GetView())
	self.otherrole_head:AddClickEventListener()

	self.otherrole_text_hp = XUI.CreateText(113, 75, 150, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--血数值
	self.otherrole_text_hp:setAnchorPoint(0,0.5)
	self.mt_layout_otherrole:TextureLayout():addChild(self.otherrole_text_hp, 2)

	self.otherrole_text_mp = XUI.CreateText(113, 57, 150, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--蓝数值
	self.otherrole_text_mp:setAnchorPoint(0,0.5)
	self.mt_layout_otherrole:TextureLayout():addChild(self.otherrole_text_mp, 2)

	local level_bg = XUI.CreateImageView(47, 50, ResPath.GetMainui("target_level_bg"), true)--等级底框
	self.mt_layout_otherrole:TextureLayout():addChild(level_bg)

	self.text_otherrole_level = XUI.CreateText(47, 50, 100, 0, cc.TEXT_ALIGNMENT_CENTER, "",nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--等级
	self.text_otherrole_level:setAnchorPoint(0.5, 0.5)
	self.mt_layout_otherrole:TextureLayout():addChild(self.text_otherrole_level, 2)

	local job_bg = XUI.CreateImageView(110+9999, 34, ResPath.GetMainui("job_bg"), true)--职业底框
	self.mt_layout_otherrole:TextureLayout():addChild(job_bg)

	self.text_otherrole_prof = XUI.CreateText(110+9999, 34, 100, 0, cc.TEXT_ALIGNMENT_CENTER, "")--职业
	self.text_otherrole_prof:setAnchorPoint(0.5, 0.5)
	self.mt_layout_otherrole:TextureLayout():addChild(self.text_otherrole_prof, 2)

	self.text_otherrole_name = XUI.CreateText(127, 100, 200, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 20, COLOR3B.WHITE,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--名字
	self.text_otherrole_name:setAnchorPoint(0,0.5)
	self.mt_layout_otherrole:TextureLayout():addChild(self.text_otherrole_name, 2)
	
    self.effec2 = RenderUnit.CreateEffect(1002, self.mt_layout_otherrole:TextureLayout(), 0, nil, nil, 47, 50)
	self.effec2:setPosition(35, 105)
	self.effec2:setScale(0.57,1.0)
end

function MainuiHeadBar:InitMonsterHead(mt_layout_root)--怪物头像
	local size = cc.size(298, 97)
	self.mt_layout_monster = MainuiMultiLayout.CreateMultiLayout(480, HandleRenderUnit:GetHeight() - size.height+8, cc.p(0, 0), size, mt_layout_root)
	self.mt_layout_monster:setVisible(false)

	self.monster_hp_bg = XUI.CreateImageView(-11, -30, ResPath.GetMainui("monster_head_bg"), true)--头像底框
	self.monster_hp_bg:setAnchorPoint(0, 0)
	self.mt_layout_monster:TextureLayout():addChild(self.monster_hp_bg)
	
	self.monster_hpbar = XUI.CreateLoadingBar(90, 13, ResPath.GetMainui("monster_hp_bar"), true, nil, true, 265, 20,cc.rect(3,3,15,11))--血条
	self.monster_hpbar:setAnchorPoint(0, 0)
	self.monster_hpbar:setPercent(100)
	self.mt_layout_monster:TextureLayout():addChild(self.monster_hpbar)

	self.img_monster_head = XUI.CreateImageView(38,  25, ResPath.GetBossHead("boss_icon_10000"), true)--头像
	self.img_monster_head:setScale(0.9)
	self.mt_layout_monster:TextureLayout():addChild(self.img_monster_head)

	self.monster_close = XUI.CreateImageView(-17, size.height - 43, ResPath.GetCommon("btn_132"), true)--退出按钮
	self.mt_layout_monster:TextureLayout():addChild(self.monster_close)
	XUI.AddClickEventListener(self.monster_close, function()
		 Scene.Instance:GetMainRole():DoSelectSceneObj(nil,false)
	end)
	self.monster_text_hp = XUI.CreateText(100, 25, 200, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--血量数字
	self.monster_text_hp:setAnchorPoint(0, 0.5)
	self.mt_layout_monster:TextureLayout():addChild(self.monster_text_hp, 20)

	self.text_monster_name = XUI.CreateText(100, 50, 200, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 20, COLOR3B.RED,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--怪物名字
	self.text_monster_name:setAnchorPoint(0, 0.5)
	self.mt_layout_monster:TextureLayout():addChild(self.text_monster_name, 20)

	self.text_monster_owner = XUI.CreateText(150, -8, 200, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 20, COLOR3B.RED,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--归宿
	self.text_monster_owner:setAnchorPoint(0, 0.5)
	self.mt_layout_monster:TextureLayout():addChild(self.text_monster_owner, 20)


	self.monster_hp_bar_bg = XUI.CreateImageView(0, -30, ResPath.GetMainui("monster_hp_floor_bar"), true)--等级底框
	self.monster_hp_bar_bg:setAnchorPoint(0, 0)
	self.mt_layout_monster:TextureLayout():addChild(self.monster_hp_bar_bg)
	
	self.text_monster_level = XUI.CreateText(40, -17, 100, 0, nil, "99", nil, 20, COLOR3B.WHITE,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--等级
	self.mt_layout_monster:TextureLayout():addChild(self.text_monster_level, 20)

	

	for i = 1, 5 do
		local cell = BaseCell.New()
		cell:SetPosition(55 + i * 40, -22)
		self.mt_layout_monster:TextureLayout():addChild(cell:GetView(), 2)
		cell:SetVisible(false)
		cell:GetView():setScale(0.5)
		self.monster_rewwad_t[i] = cell
	end
end

function MainuiHeadBar:InitNpcHead()
	self.mt_layout_npc = MainuiMultiLayout.CreateMultiLayout(0, 0, cc.p(0, 0), self.mt_layout_target:getContentSize(), self.mt_layout_target)
	self.mt_layout_npc:setVisible(false)

	local img_hp_bg = XUI.CreateImageView(73, 40, ResPath.GetMainui("monster_hp_bg"), true)
	img_hp_bg:setAnchorPoint(0, 0.5)
	self.mt_layout_npc:TextureLayout():addChild(img_hp_bg)

	local img_hp_bar = XUI.CreateImageView(78, 40, ResPath.GetMainui("monster_hp_bar"), true)
	img_hp_bar:setAnchorPoint(0, 0.5)
	self.mt_layout_npc:TextureLayout():addChild(img_hp_bar)

	local img_head_bg = XUI.CreateImageView(40, 40, ResPath.GetMainui("role_head_bg"), true)
	self.mt_layout_npc:TextureLayout():addChild(img_head_bg)

	local img_npc_head = XUI.CreateImageView(40, 40, ResPath.GetMainui("npc_head"), true)
	self.mt_layout_npc:TextureLayout():addChild(img_npc_head)

	self.text_npc_name = XUI.CreateText(150, 65, 150, 20, nil, "", nil, 20, COLOR3B.YELLOW)
	self.mt_layout_npc:TextLayout():addChild(self.text_npc_name)
end

function MainuiHeadBar:InitHeroHead(mt_layout_root)
	local size = cc.size(280, 80)
	local role_size = self.mt_layout_mainrole:getContentSize()
	self.mt_layout_hero = MainuiMultiLayout.CreateMultiLayout(0, HandleRenderUnit:GetHeight() - 90 - role_size.height, cc.p(0, 0), size, mt_layout_root)

	self.hero_hpbar = XUI.CreateLoadingBar(35, 34, ResPath.GetMainui("loading_hero_up"), true, ResPath.GetMainui("loading_hero_up_bg"), true, 162, 20,cc.rect(7,6,3,3))
	self.hero_hpbar:setAnchorPoint(0, 0)
	self.hero_hpbar:setPercent(100)
	self.mt_layout_hero:TextureLayout():addChild(self.hero_hpbar)

	-- self.hero_mpbar =  XUI.CreateLoadingBar(142, 25, ResPath.GetMainui("loading_mp"), true, nil, true, 172, 20, cc.rect(7,6,3,3))
	-- self.hero_mpbar:setPercent(100)
	-- self.hero_mpbar:setAnchorPoint(0,0)
	-- self.mt_layout_hero:TextureLayout():addChild(self.hero_mpbar)

	self.img_hero_head = XUI.CreateImageView(30, 30, ResPath.GetRoleHead("hero_1"), true)
	self.mt_layout_hero:TextureLayout():addChild(self.img_hero_head,1)

	self.hero_text_hp = XUI.CreateText(64, 45, 200, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	self.hero_text_hp:setAnchorPoint(0,0.5)
	self.mt_layout_hero:TextLayout():addChild(self.hero_text_hp, 2)

	self.hero_text_lv = XUI.CreateText(64, 22, 200, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 20, COLOR3B.YELLOW, cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	self.hero_text_lv:setAnchorPoint(0,0.5)
	self.mt_layout_hero:TextLayout():addChild(self.hero_text_lv, 2)
	-- self.hero_text_mp = XUI.CreateText(115, 35, 200, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 20, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	-- self.hero_text_mp:setAnchorPoint(0,0.5)
	-- self.mt_layout_hero:TextLayout():addChild(self.hero_text_mp, 2)

	self.img_hero_bg = XUI.CreateImageView(0, 0, ResPath.GetMainui("hero_bg"), true)
	self.img_hero_bg:setTouchEnabled(true)
	self.mt_layout_hero:TextureLayout():addChild(self.img_hero_bg)
	self.img_hero_bg:setAnchorPoint(0,0)
	self.mt_layout_hero:setVisible(false)
	XUI.AddClickEventListener(self.img_hero_bg, BindTool.Bind(self.OnHeroHeadClicked, self), false)

	self.btn_hero_attack_state = XUI.CreateImageView(250, 30, ResPath.GetCommon("btn_activate"), true)
	self.mt_layout_hero:TextureLayout():addChild(self.btn_hero_attack_state)
	self.btn_hero_attack_state:setScale(0.65)
	self.mt_layout_hero:setVisible(false)
	XUI.AddClickEventListener(self.btn_hero_attack_state, BindTool.Bind(self.OnHeroCheckState, self), false)

	self.img_hero_attack_state = XUI.CreateImageView(55,58,ResPath.GetMainui2("hero_attack_state"), true)
	self.btn_hero_attack_state:addChild(self.img_hero_attack_state)

	self.hero_text_activa = XUI.CreateText(60, 45, 200, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 18, COLOR3B.YELLOW, cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	self.hero_text_activa:setAnchorPoint(0,0.5)
	self.img_hero_bg:addChild(self.hero_text_activa, 2)

end

function MainuiHeadBar:OnHeroHeadClicked()
	ViewManager.Instance:Open(ViewName.Zhanjiang, TabIndex.hero_intro)
end

function MainuiHeadBar:OnHeroCheckState()
	local cfg = ZhanjiangData.Instance:getHeroGold(ZhanjiangData.TempType.State)
	if cfg and cfg.temp_value  then
		if cfg.temp_value == 0 then
			ZhanjiangCtrl.Instance:SetHeroGoldStateReq(1)
		else
			ZhanjiangCtrl.Instance:SetHeroGoldStateReq(0)
		end
	end
end

function MainuiHeadBar:SetHeroLevel(value)
	self.hero_text_lv:setString(Language.Common.HeroProfName .. "Lv." .. value)
end

function MainuiHeadBar:InitHeroPeoperty()
	if ZhanjiangData.Instance:GetAttr("hero_id") > 0 then --有战将就初始化属性
		local hp_percent = ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP) / (ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP) == 0 and 1 or ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP))
		--local mp_percent = ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP) / (ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP) == 0 and 1 or ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP))
		hp_percent = hp_percent * 100
		--mp_percent = mp_percent * 100
		self.hero_hpbar:setPercent(hp_percent)
		--self.hero_mpbar:setPercent(mp_percent)
		local hp_num = CommonDataManager.ConverHpMp(ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP))
		--local mp_num = CommonDataManager.ConverHpMp(ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP))
		local hp_value = math.floor(hp_percent)
		-- local mp_value = math.floor(mp_percent)
		local txt_hp = string.format(Language.Common.HpMp, hp_value)
		-- local txt_mp = string.format(Language.Common.HpMp, mp_value)
		self.hero_text_hp:setString(hp_num .. txt_hp)
		--self.hero_text_mp:setString(mp_num .. txt_mp)
		self:SetHeroPhoto()
	end
end

function MainuiHeadBar:SetHeroLayoutVis(vis)
	self.mt_layout_hero:setVisible(vis)
end

function MainuiHeadBar:SetHeroHpShow()
	local hp_percent = ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP) / (ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP) == 0 and 1 or ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP))
	hp_percent = hp_percent * 100
	self.hero_hpbar:setPercent(hp_percent)
	local hp_num = CommonDataManager.ConverHpMp(ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP))
	local hp_value = math.floor(hp_percent)
	local txt_hp = string.format(Language.Common.HpMp, hp_value)
	self.hero_text_hp:setString(hp_num .. txt_hp)
	local state = ZhanjiangData.Instance:GetAttr("state")
	if state ~= HERO_STATE.REST then
		local reset_time = ZhanjiangData.Instance:GetUsedResetTimeView()
		if reset_time<= 0 then
			if self.time_handler then
				GlobalTimerQuest:CancelQuest(self.time_handler)
				self.time_handler = nil
			end
		end
		self.hero_text_activa:setString("")
	end
end

function MainuiHeadBar:SetHeroMpShow()
	-- local mp_percent = ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP) / (ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP) == 0 and 1 or ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP))
	-- mp_percent = mp_percent * 100
	-- self.hero_mpbar:setPercent(mp_percent)
	-- local mp_num = CommonDataManager.ConverHpMp(ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP))
	-- local mp_value = math.floor(mp_percent)
	-- local txt_mp = string.format(Language.Common.HpMp, mp_value)
	-- self.hero_text_mp:setString(mp_num .. txt_mp)
end

function MainuiHeadBar:SetHeroPhoto()
	local prof =  ZhanjiangData.Instance:GetAttr(OBJ_ATTR.ACTOR_PROF)
	local path = ResPath.GetRoleHead("hero_" .. prof)
	self.img_hero_head:loadTexture(path)
end

function MainuiHeadBar:HeroAttackState(value)
	local cfg = ZhanjiangData.Instance:getHeroGold(ZhanjiangData.TempType.State)
	if cfg and cfg.temp_value  then
		if cfg.temp_value == 0 then
			self.img_hero_attack_state:loadTexture(ResPath.GetMainui2("hero_attack_state"))
		else
			self.img_hero_attack_state:loadTexture(ResPath.GetMainui2("hero_defense_state"))
		end
	end
end

function MainuiHeadBar:HeroReliveChange()
	local rest_cnt = ZhanjiangData.Instance:GetRestNormalReliveCnt()
	if rest_cnt <= 0 then
		local reset_time = ZhanjiangData.Instance:GetUsedResetTime()
		if reset_time> 0 then
			if self.time_handler then
				GlobalTimerQuest:CancelQuest(self.time_handler)
				self.time_handler = nil
			end
			self.time_handler = GlobalTimerQuest:AddRunQuest(BindTool.Bind(self.FlushReliveNum,self), 1)
			self:FlushReliveNum()
		else
			if self.time_handler then
				GlobalTimerQuest:CancelQuest(self.time_handler)
				self.time_handler = nil
			end
		end
	end	
end

function MainuiHeadBar:HeroAttrChange(key, value)
	if key == "state" then
		if self.mt_layout_hero then
			XUI.SetLayoutImgsGrey(self.mt_layout_hero:TextureLayout(), value == 0, is_set_enabled)
			XUI.SetLayoutImgsGrey(self.btn_hero_attack_state, value==0, true)
			self:HeroAttackState()
			if value == 0 then
				self.hero_hpbar:setPercent(0)
				self.hero_text_hp:setString("")			
			else
				self:SetHeroHpShow()
			end
		end
	elseif key == "hero_id" then
		self.mt_layout_hero:setVisible(value > 0)
		self:InitHeroPeoperty()
	elseif key == OBJ_ATTR.CREATURE_HP or key == OBJ_ATTR.CREATURE_MAX_HP then
		self:SetHeroHpShow()
	elseif key == OBJ_ATTR.CREATURE_LEVEL then
		self:SetHeroLevel(value)
	elseif key == "relive_cd" then
		if value > Status.NowTime then
			self.hero_relieve_cd = (value - Status.NowTime) -- NewHeroConfig.heroReliveCd
			self:CreateReliveCDTimer()
		else
			self.hero_relieve_cd = -1
		end
		self:FlushReliveCD()
	end
end

function MainuiHeadBar:FlushReliveNum()
	local rest_cnt = ZhanjiangData.Instance:GetRestNormalReliveCnt()
	if rest_cnt <= 0 then
		local reset_time = ZhanjiangData.Instance:GetUsedResetTime()
		if reset_time> 0 then			
			self.hero_text_activa:setString(string.format(Language.Zhanjiang.HeroWingTimeCancle2,reset_time))
		else
			self.hero_text_activa:setString("")
			if self.time_handler then
				GlobalTimerQuest:CancelQuest(self.time_handler)
				self.time_handler = nil
			end
		end		
	end
end

function MainuiHeadBar:FlushReliveCD()
	if self.hero_relive_cd_numBar == nil then
		self.hero_relive_cd_numBar = NumberBar.New()
		self.hero_relive_cd_numBar:SetRootPath(ResPath.GetCommonPath("num_100_"))
		self.hero_relive_cd_numBar:SetPosition(26, 18)
		self.hero_relive_cd_numBar:SetSpace(-5)
		self.hero_relive_cd_numBar:SetGravity(NumberBarGravity.Center)
		-- self.hero_relive_cd_numBar:SetScale(2)
		self.mt_layout_hero:TextLayout():addChild(self.hero_relive_cd_numBar:GetView(), 20)
	end
	if self.hero_relieve_cd < 0 then
		self.hero_relive_cd_numBar:SetVisible(false)
		self:DelReliveCDTimer()
		return
	end
	self.hero_relive_cd_numBar:SetVisible(self.hero_relieve_cd >= 0)
	if self.hero_relieve_cd >= 0 then 
		self.hero_relive_cd_numBar:SetNumber(self.hero_relieve_cd)
	end
	self.hero_relieve_cd = self.hero_relieve_cd - 1

end

function MainuiHeadBar:DelReliveCDTimer()
	if self.relive_cd_timer then
		GlobalTimerQuest:CancelQuest(self.relive_cd_timer)
		self.relive_cd_timer = nil
	end
end

function MainuiHeadBar:CreateReliveCDTimer()
	if self.relive_cd_timer == nil then
		self.relive_cd_timer = GlobalTimerQuest:AddRunQuest(BindTool.Bind(self.FlushReliveCD, self), 1)
	end
end

function MainuiHeadBar:CreateNumBar(x, y, w, h)
	local number_bar = NumberBar.New()
	number_bar:SetRootPath(ResPath.GetCommonPath("num_100_"))
	number_bar:SetPosition(x, y)
	number_bar:SetContentSize(w, h)
	number_bar:SetSpace(-5)
	return number_bar
end

function MainuiHeadBar:GetMainRoleBtn()
	return self.img_head_bg
end

function MainuiHeadBar:SetClickHeadCallback(callback)
	self.click_head_callback = callback
end

function MainuiHeadBar:OnClickMainRoleHead()
	if nil ~= self.click_head_callback then
		self.click_head_callback()
	end
end

function MainuiHeadBar:ChangeShowState(show_menu)
end

function MainuiHeadBar:ChangeShowStateComoplete(show_menu)
end

----------------------------------------------------------
-- buff begin
----------------------------------------------------------
function MainuiHeadBar:OnClickBuff()
	if nil == self.layout_buff then
		local x, y = self.btn_buff:getPosition()
		self.layout_buff = XLayout:create()
		self.layout_buff:setAnchorPoint(0, 1)
		self.layout_buff:setPosition(x - 40, y - 20)
		self.mt_layout_mainrole:EffectLayout():addChild(self.layout_buff)

		local layout_touch = XLayout:create(HandleRenderUnit:GetWidth(), HandleRenderUnit:GetHeight())
		local pos = self.layout_buff:convertToNodeSpace(cc.p(0, 0))
		layout_touch:setPosition(pos.x, pos.y)
		self.layout_buff:addChild(layout_touch)
		XUI.AddClickEventListener(layout_touch, function()
			self.layout_buff:setVisible(false)
		end)

		self.img_buff_bg = XUI.CreateImageViewScale9(1, 1, 2, 2, ResPath.GetMainui("common_bg"), true)
		self.layout_buff:addChild(self.img_buff_bg)

		self.img_buff_bg:setTouchEnabled(true)
		self.img_buff_bg:setIsHittedScale(false)
		self.img_buff_bg:addTouchEventListener(BindTool.Bind(self.OnTouchBuffLayout, self))
	else
		self.layout_buff:setVisible(not self.layout_buff:isVisible())
	end

	self:OnFlushBuffLayout()
end

function MainuiHeadBar:OnFlushBuffBar()
	local mainrole_vo = Scene.Instance:GetMainRole():GetVo()
	if nil == mainrole_vo.buff_list or MainuiBuffRender.ColCount <= 0 then
		return
	end

	for i, v in ipairs(self.buff_item_list) do
		v:SetVisible(false)
	end

	local buff_list = {}
	local is_add = false
	for i, v in ipairs(mainrole_vo.buff_list) do
		is_add = false
		for i2, v2 in ipairs(buff_list) do
			if v.buff_group == v2[1].buff_group then
				is_add = true
				table.insert(v2, v)
				break
			end
		end
		if not is_add then
			table.insert(buff_list, {[1] = v})
		end
	end
	local w = MainuiBuffRender.ColCount * MainuiBuffRender.Size
	local h = math.max(math.ceil(#buff_list / MainuiBuffRender.ColCount) * MainuiBuffRender.Size, MainuiBuffRender.Size)
	self.layout_buff:setContentWH(w, h)
	self.img_buff_bg:setPosition(w / 2, h / 2)
	self.img_buff_bg:setContentWH(w, h)

	for i, v in ipairs(buff_list) do
		if nil == self.buff_item_list[i] then
			self.buff_item_list[i] = MainuiBuffRender.New()
			self.layout_buff:addChild(self.buff_item_list[i]:GetView())
		end
		self.buff_item_list[i]:SetVisible(true)
		self.buff_item_list[i]:SetData(v)
		local x = MainuiBuffRender.Size * ((i - 1) % MainuiBuffRender.ColCount) + MainuiBuffRender.Size / 2
		local y = h - MainuiBuffRender.Size * math.floor((i - 1) / MainuiBuffRender.ColCount) - MainuiBuffRender.Size / 2
		self.buff_item_list[i]:SetPosition(x, y)
	end

	if nil ~= self.cur_buff_item then
		if not self.cur_buff_item:GetView():isVisible() then
			self.cur_buff_item = nil
			TipsCtrl.Instance:CloseBuffTip()
		end
	end
end

function MainuiHeadBar:OnTouchBuffLayout(sender, event_type, touch)
	if event_type == XuiTouchEventType.Began or event_type == XuiTouchEventType.Moved then
		local item = nil
		local location = touch:getLocation()
		for k, v in pairs(self.buff_item_list) do
			if v:GetView():isVisible() and v:GetView():isContainsPoint(location) then
				item = v
				break
			end

		end

		if nil ~= item and item ~= self.cur_buff_item then
			self.cur_buff_item = item
			TipsCtrl.Instance:OpenBuffTip(item:GetData())
		end
	else
		self.cur_buff_item = nil
		TipsCtrl.Instance:CloseBuffTip()
	end
end

function MainuiHeadBar:OnObjBuffChange(obj)
	if obj == Scene.Instance:GetMainRole() then
		self:OnFlushBuffLayout()
		local mainrole_vo = Scene.Instance:GetMainRole():GetVo()
		if nil == mainrole_vo.buff_list or MainuiBuffRender.ColCount <= 0 then
			return
		end
		local buff_group_list = {}
		local len = 0
		for i, v in ipairs(mainrole_vo.buff_list) do
			if not buff_group_list[v.buff_group] then
				len = len + 1
			end	
			buff_group_list[v.buff_group] = true
		end
		if len == 0 then
			self.btn_buff:setVisible(false)
		else
			self.btn_buff:setVisible(true)
			self.btn_buff:setTitleText("BUFF".."*"..len)
		end
	end
end

function MainuiHeadBar:OnFlushBuffLayout(key,value)
	if nil ~= self.layout_buff and self.layout_buff:isVisible() then
		self:OnFlushBuffBar()
	end

	-- if key == "name" then
		-- self.mainrole_name_text:setString(RoleData.Instance:GetAttr(key))
	if key == OBJ_ATTR.CREATURE_HP or key == OBJ_ATTR.CREATURE_MAX_HP then
		local hp_percent = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP) / (RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP) == 0 and 1 or RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP))
		hp_percent = hp_percent * 100
		self.main_role_hpbar:setPercent(hp_percent)
		local hp_num = CommonDataManager.ConverHpMp(RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP))
		local hp_value = math.floor(hp_percent)
		local txt_hp = string.format(Language.Common.HpMp, hp_value)
		self.mainrole_text_hp:setString(hp_num .. txt_hp)
		-- self.mainrole_text_hp:setString(RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP).."/"..RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_HP))
	elseif key == OBJ_ATTR.CREATURE_MP or key == OBJ_ATTR.CREATURE_MAX_MP then	
		local mp_percent = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP) / (RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP) == 0 and 1 or RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP))
		mp_percent = mp_percent * 100
		self.main_role_mpbar:setPercent(mp_percent)	
		local mp_num = CommonDataManager.ConverHpMp(RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP))
		local mp_value = math.floor(mp_percent)
		local txt_mp = string.format(Language.Common.HpMp, mp_value)
		self.mainrole_text_mp:setString(mp_num .. txt_mp)
		-- self.mainrole_text_mp:setString(RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MP).."/"..RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MAX_MP))
	elseif key == OBJ_ATTR.ACTOR_VIP_GRADE then
		local level = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_VIP_GRADE) or 0
		-- if level>=13 then
			-- self.img_vip_bag:loadTexture(ResPath.GetMainui("role_head_vip2"))
			-- self.img_vip_level:loadTexture(ResPath.GetMainui("vip_num_" .. level-12))
		-- else
			self.img_vip_bag:loadTexture(ResPath.GetMainui("role_head_vip"))
			self.img_vip_level:loadTexture(ResPath.GetMainui("vip_num_" .. level))
		-- end
	elseif key == OBJ_ATTR.ACTOR_JOB_LEVEL then
		local job  = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_JOB_LEVEL)
		if job == 1 then
			self:SetMainRoleProf(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PROF)+3)
		else
			self:SetMainRoleProf(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PROF))
		end
	end	
end

----------------------------------------------------------
-- buff end
----------------------------------------------------------

function MainuiHeadBar:OnClickAttackMode()
	if nil == self.layout_atk_mode then
		local w, h = 300, 350
		local index = 0
		local x, y = self.btn_atk_mode:getPosition()
		self.layout_atk_mode = XLayout:create(w, h)
		self.layout_atk_mode:setAnchorPoint(0, 1)
		self.layout_atk_mode:setPosition(x-40, y - 10)
		self.mt_layout_mainrole:EffectLayout():addChild(self.layout_atk_mode)

		local layout_touch = XLayout:create(HandleRenderUnit:GetWidth(), HandleRenderUnit:GetHeight())
		local pos = self.layout_atk_mode:convertToNodeSpace(cc.p(0, 0))
		layout_touch:setPosition(pos.x, pos.y)
		self.layout_atk_mode:addChild(layout_touch)
		XUI.AddClickEventListener(layout_touch, function()
			self.layout_atk_mode:setVisible(false)
		end)

		local img_bg = XUI.CreateImageViewScale9(w / 2, h / 2 - 10, w, h , ResPath.GetCommon("bg_145"), true)--底框
		self.layout_atk_mode:addChild(img_bg)
	
	    self.llll = XUI.CreateText(5, 80, 280, 0, cc.TEXT_ALIGNMENT_LEFT, "PK值说明：每次恶意击杀玩家会增加100点PK值,PK值大于200将变成红名,红名死亡将底稿掉落几率\n减少PK值途径：\n1.根据在线时间自动慢慢消除\n2.角色页面购买[洗红药水]清洗", nil, 18, COLOR3B.RED)--模式属性字体
	    self.llll:setAnchorPoint(0, 0.5)
	    self.layout_atk_mode:addChild(self.llll)
	
		self.atk_mode_list = ListView.New()
		self.atk_mode_list:Create(w / 2 + 2, h / 2 - 10, w, h, nil, MainuiAtkModeRender, nil, nil, nil)
		self.atk_mode_list:SetIsUseStepCalc(false)
		self.layout_atk_mode:addChild(self.atk_mode_list:GetView())
		self.atk_mode_list:SetData({{atk_mode = 0, desc = Language.Mainui.AttackModeText[0]},
									{atk_mode = 1, desc = Language.Mainui.AttackModeText[1]},
									{atk_mode = 2, desc = Language.Mainui.AttackModeText[2]},
									{atk_mode = 3, desc = Language.Mainui.AttackModeText[3]},
									{atk_mode = 4, desc = Language.Mainui.AttackModeText[4]}})
		self.atk_mode_list:SetSelectCallBack(BindTool.Bind(self.OnSelectAttackMode, self))
	else
		self.layout_atk_mode:setVisible(not self.layout_atk_mode:isVisible())
	end

	self:FlushAttackSelectState()
end

function MainuiHeadBar:OnSelectAttackMode(item)
	local mainrole_vo = Scene.Instance:GetMainRole():GetVo()
	if mainrole_vo.buff_list then
		for k,v in pairs(mainrole_vo.buff_list) do
			if v.buff_type == 93 and item:GetAtkMode() ~= GameEnum.ATTACK_MODE_PEACE then
				if nil == self.mode_alert then
					self.mode_alert = Alert.New()
					self.mode_alert:SetLableString(Language.Common.XinshouModeChangeTips)
				end
				self.mode_alert:SetOkFunc(function ()
					MainuiCtrl.Instance:SendSetAttackMode(item:GetAtkMode())
					self.layout_atk_mode:setVisible(false)
				end)
				self.mode_alert:Open()
				return
			end
		end
	end
	MainuiCtrl.Instance:SendSetAttackMode(item:GetAtkMode())
	self.layout_atk_mode:setVisible(false)
end

function MainuiHeadBar:SetAttackMode(atk_mode)
	self.atk_mode = atk_mode
	self.btn_atk_mode:setTitleText(Language.Mainui.AttackModeCompleteText[atk_mode])
	self.btn_atk_mode:setTitleColor(ATTACKMODE_COCOR3B[atk_mode])
	self:FlushAttackSelectState()
end

function MainuiHeadBar:FlushAttackSelectState()
	if self.atk_mode_list then
		local items = self.atk_mode_list:GetAllItems()
		for k,v in pairs(items) do
			if v:GetAtkMode() == self.atk_mode then
				self.atk_mode_list:ChangeToIndex(k)
				break
			end	
		end	
	end	
end


-- 更新主角头像
function MainuiHeadBar:UpdateMainRoleAvatar()
	local vo = GameVoManager.Instance:GetMainRoleVo()
	AvatarManager.Instance:UpdateAvatarImg(self.img_mainrole_head, vo[OBJ_ATTR.ENTITY_ID], vo[OBJ_ATTR.ACTOR_PROF], true, false, vo[OBJ_ATTR.ACTOR_SEX])
end

-- 取消更新主角头像
function MainuiHeadBar:CancelMainRoleAvatar()
	AvatarManager.Instance:CancelUpdateAvatar(self.img_mainrole_head)
end

-- 设置主角名字
function MainuiHeadBar:SetMainRoleName(name)
	-- self.mainrole_name:setString(name)
end

function MainuiHeadBar:UpdateBattle()
	self:SetMainRoleCapability(RoleData.Instance:GetBattle())
end

-- 设置主角战力
function MainuiHeadBar:SetMainRoleCapability(value)
	self.number_zhanli:SetNumber(value)
	self.last_capability = value

	if SceneText.CapabilityEffect.old_role_capability < 0 then
		SceneText.CapabilityEffect.old_role_capability = value
		if nil == self.capability_timer then
			self.capability_timer = GlobalTimerQuest:AddDelayTimer(function()
				self.capability_timer = nil
			end, 2)
		end
	else
		if nil == self.capability_timer then
			self.capability_timer = GlobalTimerQuest:AddDelayTimer(function()
				self.capability_timer = nil
				SceneText.PlayCapabilityChangeEffect(self.last_capability)
			end, 0.5)
		end
	end
end

function MainuiHeadBar:SetMainRoleVip()
	local vip_level = VipData.Instance:GetRoleVipLevel()
	-- self.number_vip:SetNumber(vip_level)
end

function MainuiHeadBar:SetMainRoleLevel(value)
	self.label_mainrole_level:setString(value)
end

function MainuiHeadBar:SetMainRoleProf(value)
	local path = ResPath.GetSkillIcon("prof_" .. value)
	self.job_img:loadTexture(path)
	-- self.label_mainrole_prof:setString(Language.Common.ProfName2[value])
end

-- 设置目标
function MainuiHeadBar:OnSelectObj(target_obj, select_type)
	if self.target_obj == target_obj then
		return
	end

	self.mt_layout_otherrole:setVisible(false)
	self.mt_layout_monster:setVisible(false)
	

	local obj_type = -1
	local entity_type = -1
	if nil ~= target_obj then
		obj_type = target_obj:GetType()
		entity_type = target_obj.vo.entity_type
	end

	if obj_type == SceneObjType.Role and not ClientMaskInfoCfg.MaskRoleChangeMonsterNameMap[Scene.Instance:GetSceneId()] or 
	obj_type == SceneObjType.Hero and not ClientMaskInfoCfg.MaskRoleChangeMonsterNameMap[Scene.Instance:GetSceneId()]	then
		self.target_obj = target_obj
		self:ShowOtherRoleHead(target_obj,obj_type)
		GlobalEventSystem:Fire(OtherEventType.TARGET_HEAD_CHANGE, true)
		if self.mt_layout_otherrole:isVisible() == true then
			MainuiCtrl.Instance:SetTopRightToggle(false)
		end 
	elseif IsMonsterByEntityType(entity_type) then
		self.target_obj = target_obj
		self:ShowMonsterHead(target_obj)
		if self.mt_layout_monster:isVisible() == true then
			MainuiCtrl.Instance:SetTopRightToggle(false)
		end 
		GlobalEventSystem:Fire(OtherEventType.TARGET_HEAD_CHANGE, true)
	else
		GlobalEventSystem:Fire(OtherEventType.TARGET_HEAD_CHANGE, false)
		self.target_obj = nil
	end
end

function MainuiHeadBar:OnObjDead(target_obj)
	if self.target_obj == target_obj then
		self:OnSelectObj(nil, "")
	end
end

function MainuiHeadBar:OnObjDel(target_obj)
	if self.target_obj == target_obj then
		self:OnSelectObj(nil, "")
	end
end

function MainuiHeadBar:OnHeadbarSceneChangeComplete(old_scene_type, new_scene_type)
	self:OnSelectObj(nil, "")
	self:UpdateBattle()
end

function MainuiHeadBar:OnObjAttrChange(obj, key, value)
	if self.target_obj ~= obj or nil == self.target_obj then
		return
	end

	if key == OBJ_ATTR.CREATURE_HP or key == OBJ_ATTR.CREATURE_MAX_HP then
		if obj:GetType() == SceneObjType.Role or obj:GetType() == SceneObjType.Hero then
			self:SetOtherRoleHP(obj:GetHp(), obj:GetMaxHp())
		elseif IsMonsterByEntityType(obj.vo.entity_type) then
			self:SetMonsterHP(obj:GetHp(), obj:GetMaxHp())
		end
	elseif key == OBJ_ATTR.ACTOR_INNER or key == OBJ_ATTR.ACTOR_MAX_INNER then
		if obj:GetType() == SceneObjType.Role then
			self:SetOtherRoleMp(obj:GetMp(), obj:GetMaxMp())
		end
	elseif key == "ascription" then
		self.text_monster_owner:setString(value)
	end
end

-- 显示角色头象
function MainuiHeadBar:ShowOtherRoleHead(target_obj,obj_type)
	self.mt_layout_otherrole:setVisible(true)

	local vo = target_obj:GetVo()

	if obj_type == SceneObjType.Role then
		self.text_otherrole_name:setString(vo.name)
		self.otherrole_head:SetRoleInfo(vo[OBJ_ATTR.ENTITY_ID], vo.name, vo[OBJ_ATTR.ACTOR_PROF], true, vo[OBJ_ATTR.ACTOR_SEX])
		self.text_otherrole_prof:setString(Language.Common.ProfName2[vo[OBJ_ATTR.ACTOR_PROF]])
	elseif obj_type == SceneObjType.Hero then
		self.text_otherrole_name:setString(vo.name.."("..vo.owner_name..")")
		self.otherrole_head:SetRoleInfo(vo[OBJ_ATTR.ENTITY_ID],vo.owner_name,vo.hero_prof,true,vo.hero_sex)
		self.text_otherrole_prof:setString(Language.Common.ProfName2[4])
	end
	self.text_otherrole_level:setString(tostring(vo[OBJ_ATTR.ACTOR_CIRCLE]).."转"..tostring(vo[OBJ_ATTR.CREATURE_LEVEL]).."级")
	self:SetOtherRoleHP(target_obj:GetHp(), target_obj:GetMaxHp())
	self:SetOtherRoleMp(target_obj:GetMp(), target_obj:GetMaxMp())
end

-- 设置角色HP
function MainuiHeadBar:SetOtherRoleHP(hp, max_hp)
	if max_hp <= 0 then
		return
	end

	local percent = hp / max_hp * 100
	self.otherrole_hpbar:setPercent(percent)
	local otherrole_hp_num = CommonDataManager.ConverHpMp(hp)
	local otherrole_hp_value = math.floor(percent)
	local otherrole_hp_txt = string.format(Language.Common.HpMp,otherrole_hp_value)
	self.otherrole_text_hp:setString(otherrole_hp_num.. otherrole_hp_txt)
end

-- 设置角色MP
function MainuiHeadBar:SetOtherRoleMp(mp, max_mp)
	if max_mp <= 0 then
		return
	end

	local percent = mp / max_mp * 100
	self.otherrole_mpbar:setPercent(percent)
	local otherrole_mp_num = CommonDataManager.ConverHpMp(mp)
	local otherrole_mp_value = math.floor(percent)
	local otherrole_mp_txt = string.format(Language.Common.HpMp,otherrole_mp_value)
	self.otherrole_text_mp:setString(otherrole_mp_num.. otherrole_mp_txt)
end

-- 显示怪物头象
function MainuiHeadBar:ShowMonsterHead(target_obj)
	self.mt_layout_monster:setVisible(true)
	self.text_monster_name:setString(target_obj:GetName())
	self.text_monster_owner:setString(target_obj:GetVo().ascription)
	self.text_monster_level:setString(tostring(target_obj:GetVo()[OBJ_ATTR.CREATURE_LEVEL]).."阶")
	self:SetMonsterHP(target_obj:GetHp(), target_obj:GetMaxHp())

	local boss_cfg = BossData.GetMosterCfg(target_obj:GetVo().monster_id)
	if boss_cfg then
		local icon = 10000
		if boss_cfg.icon and boss_cfg.icon ~= 0 then
			icon = boss_cfg.icon
		end	
		self.img_monster_head:loadTexture(ResPath.GetBossHead("boss_icon_" .. icon))
	end

	local reward_cfg = MainuiData.Instance:GetMonsterRewardCfg(target_obj:GetVo().monster_id)
	if reward_cfg then
		for i = 1, 5 do
			if self.monster_rewwad_t[i] then
				self.monster_rewwad_t[i]:SetVisible(reward_cfg[i] ~= nil)
				if reward_cfg[i] then
					self.monster_rewwad_t[i]:SetData({item_id = reward_cfg[i].id, is_bind = reward_cfg[i].bind, num = reward_cfg[i].count})
				end
			end
		end
	else
		for k,v in pairs(self.monster_rewwad_t) do
			v:SetVisible(false)
		end
	end
end

-- 设置怪物HP
function MainuiHeadBar:SetMonsterHP(hp, max_hp)
	if max_hp <= 0 then
		return
	end

	local percent = hp / max_hp * 100
	self.monster_hpbar:setPercent(percent)
	local monster_hp_num = CommonDataManager.ConverHpMp(hp)
	local monster_hp_value = math.floor(percent)
	local monster_hp_txt = string.format(Language.Common.HpMp,monster_hp_value)
	self.monster_text_hp:setString(monster_hp_num.. monster_hp_txt)
end

-- 显示npc头象
function MainuiHeadBar:ShowNpcHead(target_obj)
	self.mt_layout_npc:setVisible(true)
	self.text_npc_name:setString(target_obj:GetName())
end

function MainuiHeadBar:HeadbarRemindGroupChange(group_name, num)
	if self.remind_flag_list[group_name] then
		self.remind_flag_list[group_name]:setVisible(num > 0)
	end
end

function MainuiHeadBar.GetBuffCfg(buff_id)
	if not StdBuff then return end
	for k,v in pairs(StdBuff) do
		if v.id == buff_id then return v end
	end
end

----------------------------------------------------
-- 攻击模式
----------------------------------------------------
MainuiAtkModeRender = MainuiAtkModeRender or BaseClass(BaseRender)
function MainuiAtkModeRender:__init()
	self.view:setAnchorPoint(0, 0)
	self.view:setContentWH(300, 40)--模式间隔
end

function MainuiAtkModeRender:__delete()
	
end

function MainuiAtkModeRender:GetAtkMode()
	return self.data.atk_mode
end

function MainuiAtkModeRender:CreateChild()
	BaseRender.CreateChild(self)

	local size = self.view:getContentSize()

	self.img_atk_bg = XUI.CreateImageViewScale9(0, size.height * 0.5, 80, 35,ResPath.GetMainui("zt"),true)--模式按钮
	self.img_atk_bg:setAnchorPoint(0, 0.5)
	self.view:addChild(self.img_atk_bg)

	local img_size = self.img_atk_bg:getContentSize()
	self.img_atk_text = XUI.CreateText(img_size.width * 0.5, size.height * 0.5, 100, 0, cc.TEXT_ALIGNMENT_CENTER, "", nil, 20, nil)--模式字体
	self.view:addChild(self.img_atk_text)

	self.text_desc = XUI.CreateText(img_size.width + 10, size.height * 0.5, 350, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, 20, nil)--模式属性字体
	self.text_desc:setAnchorPoint(0, 0.5)
	self.view:addChild(self.text_desc)
	
	local img_atk_line = XUI.CreateImageView(size.width * 0.5, 0, ResPath.GetMainui("task_line"), true)--分割线
	self.view:addChild(img_atk_line)
	
	self.fore_bg = XUI.CreateImageViewScale9(size.width * 0.5,size.height * 0.5,size.width,size.height - 10,ResPath.GetMainui("fight_model_desc_select"),true,cc.rect(10,10,20,20))--选择模式后出现的框框
	self.view:addChild(self.fore_bg)
	self.fore_bg:setVisible(false)
end

function MainuiAtkModeRender:OnFlush()
	if self.data then
		self.img_atk_text:setString(Language.Mainui.AttackModeCompleteText[self.data.atk_mode])
		self.img_atk_text:setColor(ATTACKMODE_COCOR3B[self.data.atk_mode])
		self.text_desc:setString(self.data.desc)
	end	
end

function MainuiAtkModeRender:SetSelect(is_select)
	BaseRender.SetSelect(self,is_select)
	
	local temp_path = ""
	if not is_select then
		temp_path = "fight_model_bg_normal"
		self.fore_bg:setVisible(false)
	else
		temp_path = "fight_model_bg_select"
		self.fore_bg:setVisible(true)
	end	
	self.img_atk_bg:loadTexture(ResPath.GetMainui(temp_path))
end

function MainuiAtkModeRender:CanSelect()
	return true
end

function MainuiAtkModeRender:CreateSelectEffect()

end

function MainuiAtkModeRender:CompareGuideData(data)
	return self:GetAtkMode() == data
end


----------------------------------------------------
-- buff图标
----------------------------------------------------
MainuiBuffRender = MainuiBuffRender or BaseClass(BaseRender)
MainuiBuffRender.Size = 44
MainuiBuffRender.ColCount = 5
function MainuiBuffRender:__init()
	self.view:setContentWH(MainuiBuffRender.Size, MainuiBuffRender.Size)
	self.view:setAnchorPoint(0.5, 0.5)
end

function MainuiBuffRender:__delete()
	
end

function MainuiBuffRender:CreateChild()
	BaseRender.CreateChild(self)
	self.img_buff_icon = XUI.CreateImageView(22, 22, ResPath.GetBuff(1), false)
	self.view:addChild(self.img_buff_icon)
end

function MainuiBuffRender:OnFlush()
	if not next(self.data) then
		return
	end
	self.img_buff_icon:loadTexture(ResPath.GetBuff(self.data[1].buff_icon))
end
