MainuiJoystick = MainuiJoystick or BaseClass()

function MainuiJoystick:__init()
	self.mt_layout_root = nil
	self.joystick = nil

	self.key_info = {}
	self.check_time = 0
	-- self.toggle_handle = GlobalEventSystem:Bind(MainUIEventType.BOTTOMAREA_TOGGLE,BindTool.Bind(self.OnToggle,self))

	self.key_press_handler = GlobalEventSystem:Bind(LayerEventType.KEYBOARD_PRESS, BindTool.Bind(self.OnKeyPress,self))
	self.key_release_handler = GlobalEventSystem:Bind(LayerEventType.KEYBOARD_RELEASED, BindTool.Bind(self.OnKeyRelease,self))
	Runner.Instance:AddRunObj(self, 4)
end


function MainuiJoystick:__delete()
	Runner.Instance:RemoveRunObj(self)

	if self.key_press_handler then
		GlobalEventSystem:UnBind(self.key_press_handler)
		self.key_press_handler = nil
	end	

	if self.key_release_handler then
		GlobalEventSystem:UnBind(self.key_release_handler)
		self.key_release_handler = nil
	end	

	if self.toggle_handle then
		GlobalEventSystem:UnBind(self.toggle_handle)
		self.toggle_handle = nil
	end

	if self.joystick_new then
		self.joystick_new:DeleteMe()
		self.joystick_new = nil
	end	
end


function MainuiJoystick:Init(mt_layout_root)
	self.mt_layout_root = mt_layout_root

	self.global_x = 200+60
	self.global_y = 200
	-- 摇杆
	-- self.joystick = XUI.CreateJoystick(self.global_x, self.global_y, ResPath.GetMainui("joystick_bg"), ResPath.GetMainui("joystick_ball"), true)
	-- self.joystick:addJoystickEventListener(BindTool.Bind1(self.OnJoystickCallback, self))
	-- self.joystick:setEventInterval(0.1)
	-- self.joystick:setOpacity(127)
	-- self.mt_layout_root:TextureLayout():addChild(self.joystick, -2)
	local screen_w = HandleRenderUnit:GetWidth()/2
	local screen_h = HandleRenderUnit:GetHeight()
	self.event_board = XUI.CreateImageViewScale9(0,0,screen_w,screen_h,ResPath.GetMainui("common_bg"),true)
	self.event_board:setOpacity(0)
	self.event_board:setAnchorPoint(0,0)
	self.event_board:setTouchEnabled(true)
	self.event_board:setSwallowTouches(false)
	self.mt_layout_root:TextureLayout():addChild(self.event_board, -300)

	self.joystick_new = AnyJoystick.New(self.global_x, self.global_y,self.event_board)
	self.joystick_new:Create(ResPath.GetMainui2("joystick_bg"), ResPath.GetMainui2("joystick_ball"))
	self.joystick_new:SetCallback(BindTool.Bind(self.OnJoyCallBack,self))
	self.joystick_new:GetView():setScale(1.4)
	self.mt_layout_root:TextureLayout():addChild(self.joystick_new:GetView(), -2)
	-- self:OnToggle(false)
end	

function MainuiJoystick:OnToggle(visible)

	self.joystick:stopAllActions()
	if not visible then
		self.joystick:setVisible(true)
		local queue = cc.Spawn:create(cc.FadeIn:create(0.2),cc.MoveTo:create(0.1,cc.p(self.global_x,self.global_y)))
		self.joystick:runAction(queue)
	else
		local callback = cc.CallFunc:create(function()
			self.joystick:setVisible(false)
		end)
		local action = cc.Spawn:create(cc.FadeOut:create(0.2),cc.MoveTo:create(0.1,cc.p(self.global_x - 200,self.global_y)))
		local queue = cc.Sequence:create(action,callback)
		self.joystick:runAction(queue)
	end	

end	

function MainuiJoystick:OnKeyPress(keycode)
	self.key_info[keycode] = true
	self:DoKeyCheck()
end	


function MainuiJoystick:OnKeyRelease(keycode)
	self.key_info[keycode] = false
	self:DoKeyCheck()
end	


function MainuiJoystick:Update(now_time, elapse_time)
	if now_time > self.check_time then
		self.check_time = now_time + 0.2
		self:DoKeyCheck()	
	end	
end	

function MainuiJoystick:DoKeyCheck()
	local main_role = Scene.Instance:GetMainRole()
	if not main_role then
		return
	end	

	if self.key_info[KeyBoard.Left] 
		or self.key_info[KeyBoard.Right] 
		or self.key_info[KeyBoard.Up] 
		or self.key_info[KeyBoard.Down] then

		if self.key_info[KeyBoard.Left] and self.key_info[KeyBoard.Up] then
			main_role:SetKeyPressDir(GameMath.DirUpLeft)
		elseif self.key_info[KeyBoard.Up] and self.key_info[KeyBoard.Right] then
			main_role:SetKeyPressDir(GameMath.DirUpRight)
		elseif self.key_info[KeyBoard.Right] and self.key_info[KeyBoard.Down] then
			main_role:SetKeyPressDir(GameMath.DirDownRight)
		elseif self.key_info[KeyBoard.Down] and self.key_info[KeyBoard.Left] then	
			main_role:SetKeyPressDir(GameMath.DirDownLeft)
		elseif self.key_info[KeyBoard.Left] then
			main_role:SetKeyPressDir(GameMath.DirLeft)
		elseif self.key_info[KeyBoard.Up] then	
			main_role:SetKeyPressDir(GameMath.DirUp)
		elseif self.key_info[KeyBoard.Right] then	
			main_role:SetKeyPressDir(GameMath.DirRight)
		elseif self.key_info[KeyBoard.Down] then
			main_role:SetKeyPressDir(GameMath.DirDown)
		else
			main_role:SetIsKeyPressMove(false)
			return
		end	
		main_role:StopMove()
		main_role:SetIsKeyPressMove(true)
	else
		main_role:SetIsKeyPressMove(false)	
	end	
end	

function MainuiJoystick:OnJoyCallBack(event_type, x, y)
	local main_role = Scene.Instance:GetMainRole()
	if event_type ~= JoystickEvent.Ended then
		 	if math.abs(x) < 15 and math.abs(y) < 15 then
				return
			end

			if nil ~= MapLoading.Instance and MapLoading.Instance:IsOpen() then
				return
			end

			
			local dir = GameMath.GetDirectionNumber(x, y)
			main_role:StopMove()
			main_role:SetIsJoyStickMove(true)
			main_role:SetJoyStickDir(dir)
	else
		main_role:SetIsJoyStickMove(false)
		main_role:StopMove()
	end	
end	

----------------------------------------------------
--摇扛控制
----------------------------------------------------
-- 摇杆回调，event_type：0开始，1按住，2结束
-- function MainuiJoystick:OnJoystickCallback(sender, event_type, fx, fy)
-- 	local main_role = Scene.Instance:GetMainRole()

-- 	if 2 == event_type then
-- 		self.joystick:setOpacity(127)
-- 		main_role:SetIsJoyStickMove(false)
-- 		main_role:StopMove()
-- 		return
-- 	end

-- 	local new_opacity = math.min(self.joystick:getOpacity() + 10, 255)
-- 	self.joystick:setOpacity(new_opacity)


-- 	if math.abs(fx) < 15 and math.abs(fy) < 15 then
-- 		return
-- 	end

-- 	if nil ~= MapLoading.Instance and MapLoading.Instance:IsOpen() then
-- 		return
-- 	end

	
-- 	local dir = GameMath.GetDirectionNumber(fx, fy)
-- 	main_role:StopMove()
-- 	main_role:SetIsJoyStickMove(true)
-- 	main_role:SetJoyStickDir(dir)
-- end
