----------------------------------------------------------
-- 主ui上的技能操作区
----------------------------------------------------------
MainuiSkillBar = MainuiSkillBar or BaseClass()
MainuiSkillBar.ANGLE_INTERVAL = 45
MainuiSkillBar.CELL_COUNT = 8

MainuiSkillBar.KeyCellInfo = 
{
	[KeyBoard.NUM_2] = 1,
	[KeyBoard.NUM_3] = 2,
	[KeyBoard.NUM_4] = 3,
	[KeyBoard.NUM_5]= 4,
	[KeyBoard.NUM_6]= 5,
	[KeyBoard.NUM_7] = 6,
	[KeyBoard.NUM_8] = 7,
	[KeyBoard.NUM_9] = 8,
}

MainuiSkillBar.KeyCellCommon = 
{
	[KeyBoard.F1] = 1,
	[KeyBoard.F2] = 2,
	[KeyBoard.NUM_1] = 3,
}

-- 传送物品类型
MainuiSkillBar.TransmitType = {
	1, 		-- 传送回城
	2,		-- 随机传送
}

function MainuiSkillBar:__init()
	self.mt_layout_skill = nil

	self.common_cell = nil
	self.cell_list = {}

	self.img_auto_fight = nil
	self.img_change_job = nil
	--self.sele_player_container = nil
	self.angle = 0
	self.min_angle = -((MainuiSkillBar.CELL_COUNT - 4) * MainuiSkillBar.ANGLE_INTERVAL)--技能轮回显示 4
	self.max_angle = 0
	self.is_first_init = true
	self.select_obj_group_list = {}
	self.is_toggle = false
	self.transmit_item_type = MainuiSkillBar.TransmitType[1]
	self.drug_id_index = 1
	GlobalEventSystem:Bind(LoginEventType.RECV_MAIN_ROLE_INFO, BindTool.Bind(self.OnRecvMainRoleInfo, self))
	GlobalEventSystem:Bind(OtherEventType.INIT_SKILL_LIST, BindTool.Bind(self.OnInitSkillList, self))
	GlobalEventSystem:Bind(ObjectEventType.MAIN_ROLE_USE_SKILL, BindTool.Bind(self.OnMainRoleUseSkill, self))
	GlobalEventSystem:Bind(ObjectEventType.MAIN_ROLE_COMMON_CD_CHANGE,BindTool.Bind(self.OnCommonCdChange, self))
	GlobalEventSystem:Bind(SettingEventType.SKILL_BAR_CHANGE, BindTool.Bind(self.OnSkillBarChange, self))
	GlobalEventSystem:Bind(OtherEventType.GUAJI_TYPE_CHANGE, BindTool.Bind(self.OnGuajiTypeChange, self))
	GlobalEventSystem:Bind(OtherEventType.AREA_SKILL_ID_CHANGE, BindTool.Bind(self.OnAreaSkillIdChange, self))
	GlobalEventSystem:Bind(KnapsackEventType.KNAPSACK_ITEM_CD,BindTool.Bind(self.OnItemCdChange, self))
	ItemData.Instance:NotifyDataChangeCallBack(BindTool.Bind(self.OnItemChange, self))

	self.toggle_handle = GlobalEventSystem:Bind(MainUIEventType.BOTTOMAREA_TOGGLE,BindTool.Bind(self.OnToggle,self))
	self.system_set_handler = GlobalEventSystem:Bind(SettingEventType.SYSTEM_SETTING_CHANGE, BindTool.Bind(self.OnSysSettingChange, self))
	self.change_map_handler = GlobalEventSystem:Bind(SceneEventType.SCENE_CHANGE_COMPLETE, BindTool.Bind(self.OnChangMap, self))
	RoleData.Instance:NotifyAttrChange(BindTool.Bind(self.OnRoleDataChangeBack, self))
	EquipData.Instance:NotifyDataChangeCallBack(BindTool.Bind(self.OnEquipDataChangeBack, self))
	
	self.key_release_handler = GlobalEventSystem:Bind(LayerEventType.KEYBOARD_RELEASED, BindTool.Bind(self.OnKeyRelease,self))
	self.hero_attr_evt = GlobalEventSystem:Bind(HeroDataEvent.HERO_ATTR_CHANGE, BindTool.Bind(self.HeroAttrChange, self))
	self.hero_active_state_evt = GlobalEventSystem:Bind(HeroDataEvent.HERO_ACTIVE_STATE_INFO, BindTool.Bind(self.SetCombineSkillBarVis, self))
end

function MainuiSkillBar:__delete()
	if self.key_release_handler then
		GlobalEventSystem:UnBind(self.key_release_handler)
		self.key_release_handler = nil
	end

	GlobalEventSystem:UnBind(self.toggle_handle)
	self.toggle_handle = nil
	if self.system_set_handler then
		GlobalEventSystem:UnBind(self.system_set_handler)
		self.system_set_handler = nil
	end

	if self.change_map_handler then
		GlobalEventSystem:UnBind(self.change_map_handler)
		self.change_map_handler = nil
	end	

	if self.hero_attr_evt then
		GlobalEventSystem:UnBind(self.hero_attr_evt)
		self.hero_attr_evt = nil
	end
	
	if self.hero_active_state_evt then
		GlobalEventSystem:UnBind(self.hero_active_state_evt)
		self.hero_attr_evt = nil
	end

	for k, v in pairs(self.cell_list) do
		v:DeleteMe()
	end
	self.cell_list = {}

	-- if self.yao_cell then
	-- 	self.yao_cell:DeleteMe()
	-- 	self.yao_cell = nil
	-- end	

	if nil ~= self.common_cell then
		self.common_cell:DeleteMe()
		self.common_cell = nil
	end

	if self.auto_huicheng_btn then
		self.auto_huicheng_btn:DeleteMe()
		self.auto_huicheng_btn = nil
	end	

	if self.auto_suiji_btn then
		self.auto_suiji_btn:DeleteMe()
		self.auto_suiji_btn = nil
	end	

	if self.bag_btn then
		self.bag_btn:DeleteMe()
		self.bag_btn = nil
	end	
	if self.cd_btn then
		self.cd_btn:DeleteMe()
		self.cd_btn = nil 
	end
	if self.combine_hero_skill_bar then
		self.combine_hero_skill_bar:DeleteMe()
		self.combine_hero_skill_bar = nil
	end
	if self.lock_player_btn then
		self.lock_player_btn:DeleteMe()
		self.lock_player_btn = nil 
	end
	if self.show_hero_btn then
		self.show_hero_btn:DeleteMe()
		self.show_hero_btn = nil 
	end

	if self.selet_player_listview then
		self.selet_player_listview:DeleteMe()
		self.selet_player_listview = nil
	end

	if self.delay_play_time_vis then
		GlobalTimerQuest:CancelQuest(self.delay_play_time_vis)
		self.delay_play_time_vis = nil 
	end
	-- if self.timer then
	-- 	GlobalTimerQuest:CancelQuest(self.timer)
	-- 	self.timer = nil
	-- end
end

function MainuiSkillBar:OnKeyRelease(keycode)
	
	local index = MainuiSkillBar.KeyCellInfo[keycode]
	if index then
		local cell = self.cell_list[index]
		self:OnClickSkillCell(cell)
	else
		index = MainuiSkillBar.KeyCellCommon[keycode]
		if index == 1 then
			self:OnClickCommonUp()
		elseif index == 2 then
			self:OnClickCommonDown()
		elseif index == 3 then	
			self:OnClickCommonCell()
		end	
	end	
end	

function MainuiSkillBar:OnChangMap(old_scene_type, new_scene_type)
	local is_finger_show = false
	if Scene.Instance:GetSceneLogic():GetFubenType() == FubenType.ShiMuSaoZhu then
		is_finger_show = false
	else
		if new_scene_type == SceneType.Fubun or new_scene_type == SceneType.Activity then
			is_finger_show = true
		else
			is_finger_show = false
		end
		local main_role_vo = GameVoManager.Instance:GetMainRoleVo()
		if main_role_vo.fb_id == 0 and new_scene_type == SceneType.Fubun then
			is_finger_show = false
		end
	end	
	self:SetFingerEffectVisible(is_finger_show)

	self:checkToggleVisible()
end	

--      90°
--       |
-- 180°-----0°
--       |
--      270°
function MainuiSkillBar:CalcPosByAngle(angle)--技能实际坐标
	local x = 130 * math.cos(math.rad(angle))
	local y = 130 * math.sin(math.rad(angle))
	return math.floor(x * 100) / 100, math.floor(y * 100) / 100
end

function MainuiSkillBar:OnSysSettingChange()
	local data = SettingData.Instance:GetDataByIndex(HOT_KEY.SYS_SETTING)
	if data then
		local set_flag = bit:d2b(data)
		self.OPTION_COUNT =25
		for i = 1, self.OPTION_COUNT do
			if  i == SETTING_TYPE.NEAR_C_SPEECH or  i == SETTING_TYPE.TEAM_C_SPEECH or i == SETTING_TYPE.PRIVATE_C_SPEECH then
				if set_flag[33 - i] ==1 and i == SETTING_TYPE.NEAR_C_SPEECH then
					self.mt_layout_skill:setPositionX(self.global_x - 86)--技能整体坐标
					break
				elseif set_flag[33 - i] ==1 and i == SETTING_TYPE.PRIVATE_C_SPEECH then
					self.mt_layout_skill:setPositionX(self.global_x - 86-130)
					break
				elseif set_flag[33 - i] ==1 and i == SETTING_TYPE.TEAM_C_SPEECH then
					self.mt_layout_skill:setPositionX(self.global_x - 86-240)
					break
				end
			end			
		end
	end
end

function MainuiSkillBar:Init(mt_layout_root)
	self.root_layer = mt_layout_root
	self.global_x = HandleRenderUnit:GetWidth() - 50  --技能整体页面x坐标
	self.global_y = 20                                --技能整体页面y坐标
	self.mt_layout_skill = MainuiMultiLayout.CreateMultiLayout(self.global_x - 86, self.global_y + 115, cc.p(1, 0), cc.size(0, 0), mt_layout_root, 10)
	local angle = MainuiSkillBar.ANGLE_INTERVAL / 2 + 46
	local cell

	for i = 1, MainuiSkillBar.CELL_COUNT do
		cell = MainuiSkillItem.New(self.mt_layout_skill, i)
		cell:SetAngle(angle + MainuiSkillBar.ANGLE_INTERVAL * (i - 1))
		cell:GetMtView():TextureLayout():setTouchEnabled(true)
		cell:GetMtView():TextureLayout():addTouchEventListener(BindTool.Bind(self.OnTouchSkillCell, self, cell))
		self.cell_list[i] = cell
	end
	self:UpdatePos()
	
	self.hejidik = XUI.CreateButton(-224+9999,52,30,30,false,ResPath.GetMainui("cell_bg"),"","",true)--合击技能底框
	self.mt_layout_skill:TextureLayout():addChild(self.hejidik)
	-- 与英雄合击技能按钮
	self.combine_hero_skill_bar = MainUiIcon:CreateSimpleMainuiIcon(self.mt_layout_skill, "icon_01_img")--合击技能图标
	self.combine_hero_skill_bar:SetPosition(-220+9999, 44)
	self.combine_hero_skill_bar:AddClickEventListener(BindTool.Bind(self.OnUseCombineSkill, self))
	self.combine_hero_skill_bar:SetCompleteCdDoHandler(BindTool.Bind(self.CombineSkillCDendCallback, self))
	self.combine_hero_skill_bar:SetVisible(false)
	ClientCommonButtonDic[CommonButtonType.SKILL_BAR_COMMON_CELL] = self.combine_hero_skill_bar.bg_frame_img
	
	

	self.common_cell = MainuiSkillCommonItem.New(self.mt_layout_skill)--普通攻击按钮整体坐标
	self.common_cell:GetMtView():setPosition(20, -18)
	self.common_cell:GetMtView():TextureLayout():setTouchEnabled(true)
	self.common_cell:GetMtView():TextureLayout():addTouchEventListener(BindTool.Bind(self.OnTouchCommonCell, self))
	
--------------------------------------------------------------------------------------------------------------------------------
	-- self.yao_cell = MainuiSkillItem.New(mt_layout_root, 9)
	-- self.yao_cell:GetMtView():setPosition(self.global_x - 345,self.global_y + 330)
	-- self.yao_cell:GetMtView():TextureLayout():setTouchEnabled(true)
	-- self.yao_cell:GetMtView():AddClickEventListener(BindTool.Bind(self.OnClickSkillCell,self,self.yao_cell))
	-- self.yao_cell:SetNormalScale(0.75)
	-- self.yao_cell:SetClickScale(0.8)
	-- self.yao_cell:CreateChangeItemBtn(posx, posy, res_path)
	-- self.yao_cell:SetData({type = SKILL_BAR_TYPE.ITEM, id = SKILL_BAR_ITEM_LIST_2[self.drug_id_index]})
	-- self.yao_cell:SetChangeItemBtnCallback(BindTool.Bind(self.OnChangeSkillItemShow, self))
--------------------------------------------------------------------------------------------------------------------------------

	self.img_auto_fight = XUI.CreateImageView(self.global_x - 30,  self.global_y + 330, ResPath.GetSkillIcon("auto_fight"), true)--挂机按钮
	mt_layout_root:TextureLayout():addChild(self.img_auto_fight)
	XUI.AddClickEventListener(self.img_auto_fight, BindTool.Bind(self.OnClickAutoFight, self))
	ClientCommonButtonDic[CommonButtonType.NAV_GUAJI_BTN] = self.img_auto_fight
	
	effec = RenderUnit.CreateEffect(1005, self.img_auto_fight, 0, nil, nil, 35+9999, 40)
    effec:setOpacity(90)--设置透明度
		

	self.img_change_job = XUI.CreateImageView(-55+9999,215, ResPath.GetMainui2("change_job"), true)--转职按钮  --屏蔽，不需要
	self.mt_layout_skill:TextureLayout():addChild(self.img_change_job)
	XUI.AddClickEventListener(self.img_change_job, BindTool.Bind(self.OnChangeJob, self))
	self.img_change_job:setVisible(false)

	self.auto_huicheng_btn = MainUiIcon:CreateMainuiIcon5(self.mt_layout_skill,"33")--回城快捷键
	self.auto_huicheng_btn:SetPosition(-50,215)
	self.auto_huicheng_btn:AddClickEventListener(BindTool.Bind(self.OnUseHuicheng,self))
	self.auto_huicheng_btn:SetVisible(false)

	self.auto_suiji_btn = MainUiIcon:CreateMainuiIcon5(self.mt_layout_skill,"34")--随机快捷键
	self.auto_suiji_btn:SetPosition(-50,215)
	self.auto_suiji_btn:AddClickEventListener(BindTool.Bind(self.OnUseSuiji,self))
	

	-- 传送物品切换按钮
	self.transmit_type_change = XUI.CreateButton(-110,215,55,40,false,ResPath.GetMainui("s_arrow_3"),"","",true)--切换按钮
	self.mt_layout_skill:TextureLayout():addChild(self.transmit_type_change)
	XUI.AddClickEventListener(self.transmit_type_change, BindTool.Bind(self.ChangeTransmit, self), true)

	self.bag_btn = MainUiIcon:CreateMainuiIcon1(mt_layout_root,"04")--背包
	self.bag_btn:SetPosition(HandleRenderUnit:GetWidth()/2+250,HandleRenderUnit:GetHeight()/2*0.15)
	self.bag_btn:AddClickEventListener(BindTool.Bind(self.OnClickBag,self))
	ClientCommonButtonDic[CommonButtonType.NAV_BAG_BTN] = self.bag_btn

	self.cd_btn = MainUiIcon:CreateMainuiIcon2(mt_layout_root,"45")--复活
	self.cd_btn:SetPosition(380+60,730)
	self.cd_btn:AddClickEventListener(BindTool.Bind(self.OnSpecialRing,self))
	self.cd_btn:SetVisible(false)

	self.lock_player_btn = MainUiIcon:CreateMainuiIcon2(self.mt_layout_skill,"50")--目标
	self.lock_player_btn:SetPosition(-150,130)
	self.lock_player_btn:AddClickEventListener(BindTool.Bind(self.OnLockPlayer,self))
	self.lock_player_btn:SetVisible(true)--true开启 false关闭

	self.sele_player_container = XLayout:create()
	self.sele_player_container:setContentWH(250, 386)
	self.sele_player_container:setAnchorPoint(0.5, 0.5)
	self.sele_player_container:setPosition(-300, 286)
	self.sele_player_container:setVisible(false)
	self.mt_layout_skill:TextureLayout():addChild(self.sele_player_container)

	self.selet_player_listview = ListView.New()
	self.selet_player_listview:Create(125,320, 235, 320, nil, SeletPlayer,nil)
	self.selet_player_listview:SetMargin(1)
	self.selet_player_listview:GetView():setAnchorPoint(0.5, 1)
	self.selet_player_listview:SetJumpDirection(ListView.Top)
	-- self.selet_player_listview:GetView():setVisible(false)
	self.selet_player_listview:SetSelectCallBack(BindTool.Bind(self.OnSeletAtkPlayer,self))
	self.sele_player_container:addChild(self.selet_player_listview:GetView(), 1)
	local sele_bg = XUI.CreateImageViewScale9(125, 180, 250, 380, ResPath.GetCommon("bg_145"), true)--目标功能底框
	self.sele_player_container:addChild(sele_bg)
	local line = XUI.CreateImageView(125, 325, ResPath.GetCommon("line_108"), true)--分割线
	self.sele_player_container:addChild(line)
	
	local line1 = XUI.CreateImageView(20, 350, ResPath.GetCommon("check_box_bg"), true)--分割线
	self.sele_player_container:addChild(line1) 
	
	self.sele_player_toggle = XUI.CreateToggleButton(20, 350, 60, 60, false, ResPath.GetCommon("check_box"), ResPath.GetCommon("check_box_bg"), "", true)--勾勾
	self.sele_player_toggle:setTogglePressed(false)
	XUI.AddClickEventListener(self.sele_player_toggle, BindTool.Bind(self.SetSeletPlayerViewData, self), true)
	self.sele_player_container:addChild(self.sele_player_toggle)
	local sel_player_txt = XUI.CreateText(115,350,0,0,cc.TEXT_ALIGNMENT_CENTER,"是否显示可攻击玩家" ,nil,16,COLOR3B.DEEP_ORANGE)--可攻击
	self.sele_player_container:addChild(sel_player_txt)
	local close_sel_btn = XUI.CreateButton(230, 350, w, h, false, ResPath.GetCommon("btn_141"), "", "", true)--退出按钮
	XUI.AddClickEventListener(close_sel_btn, BindTool.Bind(self.OnCloseSelPlayerView, self), true)
	self.sele_player_container:addChild(close_sel_btn)
	self.sele_player_no_num_txt = XUI.CreateText(130,300,0,0,cc.TEXT_ALIGNMENT_CENTER,"暂无可攻击玩家" ,nil,18,COLOR3B.RED)--没有可攻击目标
	self.sele_player_container:addChild(self.sele_player_no_num_txt)
	self.sele_player_no_num_txt:setVisible(false)
	self:InitSkillCellLayout(mt_layout_root)
	self:OnToggle(false)
	
	
	self.lock_player_btn1 = XUI.CreateImageView(95,-5, ResPath.GetSkillIcon("up_role"), true)--选择玩家
	self.mt_layout_skill:TextureLayout():addChild(self.lock_player_btn1)
	XUI.AddClickEventListener(self.lock_player_btn1, BindTool.Bind(self.OnClickCommonUp, self))
	
	self.lock_player_btn2 = XUI.CreateImageView(5,-90, ResPath.GetSkillIcon("down_monster"), true)--选择怪物
	self.mt_layout_skill:TextureLayout():addChild(self.lock_player_btn2)
	XUI.AddClickEventListener(self.lock_player_btn2, BindTool.Bind(self.OnClickCommonDown, self))

	self.lock_player_btn3 = MainUiIcon:CreateMainuiIcon2(self.mt_layout_skill,"83")--拾取
	self.lock_player_btn3:SetPosition(90,-85)
	self.lock_player_btn3:AddClickEventListener(BindTool.Bind(self.shiqu,self))	
	
	self.bag_btn1 = MainUiIcon:CreateMainuiIcon1(mt_layout_root,"01")--角色
	self.bag_btn1:SetPosition(HandleRenderUnit:GetWidth()/2-250,HandleRenderUnit:GetHeight()/2*0.15)
	self.bag_btn1:AddClickEventListener(BindTool.Bind(self.OnClickBag1,self))
	ClientCommonButtonDic[CommonButtonType.NAV_ROLE_BTN] = self.bag_btn1
	
	self.bag_btn2 = MainUiIcon:CreateMainuiIcon1(mt_layout_root,"89")--攻略
	self.bag_btn2:SetPosition(HandleRenderUnit:GetWidth()/2*0.08+60,HandleRenderUnit:GetHeight()/2*0.15)
	self.bag_btn2:AddClickEventListener(BindTool.Bind(self.OnClickBag2,self))	
	
	self.bag_HB = MainUiIcon:CreateMainuiIcon2(mt_layout_root,"48")--红包
	self.bag_HB:SetPosition(350+60,680)
	self.bag_HB:AddClickEventListener(BindTool.Bind(self.HB,self))
	
	
	self.auto_QC = MainUiIcon:CreateMainuiIcon5(self.mt_layout_skill,"90")--骑乘
	self.auto_QC:SetPosition(-200,10)
	self.auto_QC:AddClickEventListener(BindTool.Bind(self.OnUseSuiji1,self))
	
	self.auto_QCA = MainUiIcon:CreateMainuiIcon5(self.mt_layout_skill,"91")--下马
	self.auto_QCA:SetPosition(9999,9999)
	self.auto_QCA:AddClickEventListener(BindTool.Bind(self.OnUseSuiji2,self))
	
	
	self.show_hero_btn = MainUiIcon:CreateMainuiIcon4(self.mt_layout_skill,"hero_down_fight")--英雄出战/英雄回收
	self.show_hero_btn:SetPosition(-224,-40)
	self.show_hero_btn:SetVisible(false)
	self.show_hero_btn:AddClickEventListener(BindTool.Bind(self.OnShowHero,self))
	
end

function MainuiSkillBar:OnUseSuiji1()--随机按钮功能执行脚本	
RedPackageCtrl.Instance:SendReceiveRedPaper1()
self.auto_QC:SetPosition(-99950,290)
self.auto_QCA:SetPosition(-200,10)
end	

function MainuiSkillBar:OnUseSuiji2()--随机按钮功能执行脚本		
RedPackageCtrl.Instance:SendReceiveRedPaper1()
self.auto_QCA:SetPosition(-99950,290)
self.auto_QC:SetPosition(-200,10)
end	

function MainuiSkillBar:shiqu(target_obj)
	if Scene.Instance:SelectMinRemindFallItem(nil, true) ~= nil then
	
		else
			SysMsgCtrl.Instance:FloatingTopRightText("附件没有可拾取物品")
	end
	
		self:SetFingerEffectVisible(false)
	local mainRole = Scene.Instance:GetMainRole()
	if mainRole:GetIsAutoFight() then
		mainRole:SetIsAutoFight(false)
	else
		mainRole:CalNearAutoPoint()
		mainRole:SetIsAutoFight(true)
	end	
end

function MainuiSkillBar:HB()
	ViewManager.Instance:Open(ViewName.RedPackage, TabIndex.RedPackage)
end

function MainuiSkillBar:InitSkillCellLayout(mt_layout_root) 
	local screen_w = HandleRenderUnit:GetWidth()
	local screen_h = HandleRenderUnit:GetHeight()
	self.skill_cell_layout = XUI.CreateLayout(self.global_x/2, screen_h/2, self.global_x, screen_h)
	mt_layout_root:TextureLayout():addChild(self.skill_cell_layout, 0)
	XUI.AddClickEventListener(self.skill_cell_layout, BindTool.Bind(self.OnBoolShowLayout,self), false)
	self.skill_cell_layout:setVisible(false)
	self.skill_cell_layout:setBackGroundColor(COLOR3B.BLACK)
	self.skill_cell_layout:setBackGroundColorOpacity(80)
	local img = XUI.CreateImageView(screen_w/2, screen_h/2 + 78, ResPath.GetSkillIcon("skill_bg_1"), true)--获得新技能底框
	self.skill_cell_layout:addChild(img)
	local img9_bg = XUI.CreateImageView(screen_w/2, screen_h/2-40 ,ResPath.GetSkillIcon("skiil_bg_2"), true)--获得新技能 技能名 底框
	self.skill_cell_layout:addChild(img9_bg)
	self.fly_icon = XUI.CreateImageView(screen_w/2-4, screen_h/2+81, ResPath.GetSkillIcon(SkillData.Instance:GetSkillIconId(2)), true)
	self.skill_cell_layout:addChild(self.fly_icon, 100)
	local text = XUI.CreateText(screen_w/2, screen_h/2 + 20, 200, 20, cc.TEXT_ALIGNMENT_CENTER, Language.Role.DescSkill, nil, nil, Str2C3b("f1a100"), nil)
	self.skill_cell_layout:addChild(text, 100)
	local act_eff = RenderUnit.CreateEffect(45, self.skill_cell_layout, -1, nil, nil,  screen_w/2-4, screen_h/2+83)
	act_eff:setOpacity(160)
	self.skill_name_path = XUI.CreateImageView(screen_w/2, screen_h/2 -40, ResPath.GetSkillIcon("skill_2_name"), true)--技能名字图片
	self.skill_cell_layout:addChild(self.skill_name_path, 100)
	local text_1 = XUI.CreateText(screen_w/2, screen_h/2 - 103, 200, 20, cc.TEXT_ALIGNMENT_CENTER, Language.Role.TiaoGuo, nil, nil, nil, nil)
	self.skill_cell_layout:addChild(text_1, 100)
end

function MainuiSkillBar:ChangeTransmit()
	self.transmit_item_type = self.transmit_item_type == MainuiSkillBar.TransmitType[1] and MainuiSkillBar.TransmitType[2] or MainuiSkillBar.TransmitType[1]
	self.auto_huicheng_btn:SetVisible(self.transmit_item_type == MainuiSkillBar.TransmitType[1])
	self.auto_suiji_btn:SetVisible(self.transmit_item_type == MainuiSkillBar.TransmitType[2])
end

function MainuiSkillBar:OnChangeSkillItemShow()
	self.drug_id_index = (self.drug_id_index + 1) <= #SKILL_BAR_ITEM_LIST_2 and (self.drug_id_index + 1) or 1
	self.yao_cell:SetData({type = SKILL_BAR_TYPE.ITEM, id = SKILL_BAR_ITEM_LIST_2[self.drug_id_index]})
end

function MainuiSkillBar:OnSeletAtkPlayer(sender, index)
	local data = sender:GetData()

	if data then
		local player = data.obj
		local obj_id = player.vo.obj_id

		player = Scene.Instance:GetObjectByObjId(obj_id)
		if player then
			Scene.Instance:GetMainRole():DoSelectSceneObj(player,false)
		end	
	end
	self.sele_player_container:setVisible(false)
	-- self.selet_player_listview:GetView():setVisible(false)
end	

function MainuiSkillBar:SetSeletPlayerViewData()
	--self.sele_player_container:setVisible(true)
	local is_toggle = self.sele_player_toggle:isTogglePressed()
	local obj_list = Scene.Instance:GetObjListByType(SceneObjType.Role)
	local temp_obj_list = {}
	local select_type = SelectType.ModeSelect
	local x, y = Scene.Instance:GetMainRole():GetLogicPos()
	local target_x, target_y = 0, 0
	local count = 0
	for k, v in pairs(obj_list) do
		if is_toggle then
			if Scene.Instance:IsCanSelecetByMode(v) then
				target_x, target_y = v:GetLogicPos()
				table.insert(temp_obj_list, {obj = v, dis = math.max(math.abs(target_x - x),math.abs(target_y - y))})
				count = count + 1
			end
		else
			target_x, target_y = v:GetLogicPos()
			table.insert(temp_obj_list, {obj = v, dis = math.max(math.abs(target_x - x),math.abs(target_y - y))})
			count = count + 1
		end

		if count >= 6 then
			break
		end	
	end
	self.sele_player_no_num_txt:setVisible(false)
	if not next(temp_obj_list) then
		self.sele_player_no_num_txt:setVisible(true)
		-- SysMsgCtrl.Instance:FloatingTopRightText(Language.Mainui.SelectNoTips[select_type] or "")
		-- return
	end
	Scene.Instance:GetMainRole():PlaySlectAreaEffect(ResPath.GetBigPainting("select_area_red", false))
	table.sort(temp_obj_list, function(a, b) return a.dis < b.dis end)
	self.selet_player_listview:SetDataList(temp_obj_list)	
	if #temp_obj_list >= 1 then
	end
		
end	

function MainuiSkillBar:OnCloseSelPlayerView()
	self.sele_player_container:setVisible(false)
end

function MainuiSkillBar:OnUseHuicheng()--回城按钮功能执行脚本
	local item = ItemData.Instance:GetOneItem(SettingData.DELIVERY_T[1])
	if item then
	 	BagCtrl.Instance:SendUseItemByItem(item)
	else	
		ViewManager.Instance:Open(ViewName.Bag)
		ViewManager.Instance:FlushView(ViewName.Bag, 0, "change_shop")
	end	
end	

function MainuiSkillBar:FlushTime()
	self.cd_btn:SetEndTime(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_DIERRFRESHCD), nil, BindTool.Bind(self.setBottomContentSetVisible, self))
	local size = self.cd_btn:GetContentSize()
	self.cd_btn:SetBottomContentColor(COLOR3B.GREEN)
	self.cd_btn:SetBuTTomTextPos(size.width/2, size.height/2-17)
	self.cd_btn:SetBottomContentSetVisible(true)
end

function MainuiSkillBar:setBottomContentSetVisible()
	self.cd_btn:SetBottomContentSetVisible(false)
end

function MainuiSkillBar:OnClickBag()
	ViewManager.Instance:Open(ViewName.Bag)
end	
function MainuiSkillBar:OnClickBag1()
	ViewManager.Instance:Open(ViewName.Role)
end	
function MainuiSkillBar:OnClickBag2()
	ViewManager.Instance:Open(ViewName.Help)
end	

function MainuiSkillBar:OnSpecialRing()
	ViewManager.Instance:Open(ViewName.Compose, TabIndex.compose_new_fh)
end

function MainuiSkillBar:OnLockPlayer()
	self.sele_player_container:setVisible(true)
	self:SetSeletPlayerViewData()
end

function MainuiSkillBar:OnShowHero()
	local hero_id = ZhanjiangData.Instance:GetAttr("hero_id")
	if  hero_id> 0 then
		local state = ZhanjiangData.Instance:GetAttr("state")
		if state == HERO_STATE.SHOW then
			ZhanjiangCtrl.Instance:SetHeroStateReq(hero_id, HERO_STATE.REST)
		elseif state == HERO_STATE.REST then
			ZhanjiangCtrl.Instance:SetHeroStateReq(hero_id, HERO_STATE.SHOW)
		end
	end
end

function MainuiSkillBar:OnUseSuiji()--随机按钮功能执行脚本
	local item = ItemData.Instance:GetOneItem(SettingData.DELIVERY_T[2])
	if item then
	 	BagCtrl.Instance:SendUseItemByItem(item)
	else
		ViewManager.Instance:Open(ViewName.Bag)	
		ViewManager.Instance:FlushView(ViewName.Bag, 0, "change_shop")
	end
end	

function MainuiSkillBar:OnToggle(visible)
	self.is_toggle = not visible
	self:checkToggleVisible()
end	

function MainuiSkillBar:checkToggleVisible()
	if Scene.Instance:GetSceneLogic():GetFubenType() == FubenType.ShiMuSaoZhu then
		self.mt_layout_skill:setVisible(false)
		self.img_auto_fight:setVisible(false)
		self.auto_huicheng_btn:SetVisible(false)
		self.auto_suiji_btn:SetVisible(false)
		self.transmit_type_change:setVisible(false)
	else
		self.auto_huicheng_btn:SetVisible(self.is_toggle and self.transmit_item_type == MainuiSkillBar.TransmitType[1])
		self.auto_suiji_btn:SetVisible(self.is_toggle and self.transmit_item_type == MainuiSkillBar.TransmitType[2])
		self.transmit_type_change:setVisible(true)
		self.img_auto_fight:setVisible(true)
		self.mt_layout_skill:setVisible(self.is_toggle)
	end	
	local circle = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CIRCLE)
	local level = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_LEVEL)
	local job=  RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_JOB_LEVEL)
	local flag = false
	if circle<= 0 then
		if level >= 60 and job ==0 then
			flag = true
		end
	else
		if job == 0 then
			flag = true
		end
	end
	if not IS_ON_CROSSSERVER then
		self.img_change_job:setVisible(flag)
	end	
end	


function MainuiSkillBar:getLayoutContainer()
	return self.mt_layout_skill
end	

function MainuiSkillBar:ActAutoFightRemindEffect()
	if self.img_auto_fight then
		UiInstanceMgr.AddCircleEffect(self.img_auto_fight)
	end
end

function MainuiSkillBar:CancelAutoFightRemindEffect()
	if self.img_auto_fight then
		UiInstanceMgr.DelCircleEffect(self.img_auto_fight)
	end
end

function MainuiSkillBar:UpdatePos()--技能显示范围 40 230
	local angle = 0
	for k, v in pairs(self.cell_list) do
		angle = GameMath.NormalizeAngle(self.angle + v:GetAngle())
		v:GetMtView():setPosition(self:CalcPosByAngle(angle))
		v:GetMtView():setVisible(angle >= 40 and angle <= 230)
	end
end

function MainuiSkillBar:OnTouchSkillCell(cell, sender, event_type, touch)
	if event_type == XuiTouchEventType.Began then
		if nil == self.touch_id then
			self.touch_id = touch:getId()
			self.touch_began_point = touch:getLocation()
			self.began_x, self.began_y = cell:GetMtView():getPosition()
			self.began_angle = self.angle
			self.is_touch_moved = false

			cell:GetMtView():setScale(cell.click_scale)
		end
		return
	end

	if self.touch_id ~= touch:getId() then
		return
	end

	if event_type == XuiTouchEventType.Moved then
		local location = touch:getLocation()
		local old_angle = math.deg(math.atan2(self.began_y, self.began_x))
		local new_angle = math.deg(math.atan2(self.began_y + (location.y - self.touch_began_point.y),
			self.began_x + (location.x - self.touch_began_point.x)))

		if new_angle < 0 then
			new_angle = new_angle + 360
		end	
		if old_angle < 0 then
			old_angle = old_angle + 360
		end	

		self.angle = self.began_angle + new_angle - old_angle
		if self.angle <= self.min_angle then self.angle = self.min_angle end
		if self.angle >= self.max_angle then self.angle = self.max_angle end

		-- 移动3度就不触发点击事件
		if not self.is_touch_moved and math.abs(self.angle - self.began_angle) >= 3 then
			cell:GetMtView():setScale(cell.normal_scale)
			self.is_touch_moved = true
		end

		self:UpdatePos()
	elseif event_type == XuiTouchEventType.Ended then
		self.touch_id = nil
		if not self.is_touch_moved then
			self:OnClickSkillCell(cell)
		end
	else
		self.touch_id = nil
	end

	if nil == self.touch_id then
		cell:GetMtView():setScale(cell.normal_scale)
		local angle_mod = self.angle % MainuiSkillBar.ANGLE_INTERVAL
		if angle_mod > MainuiSkillBar.ANGLE_INTERVAL / 2 then
			self.angle = self.angle + MainuiSkillBar.ANGLE_INTERVAL - angle_mod
		else
			self.angle = self.angle - angle_mod
		end
		self:UpdatePos()
	end
end

function MainuiSkillBar:OnTouchCommonCell(sender, event_type, touch)
	if event_type == XuiTouchEventType.Began then
		if nil == self.touch_id then
			self.touch_id = touch:getId()
			self.touch_began_point = touch:getLocation()
			self.is_touch_moved = false
			self.common_cell:PlayInsideEffect()
		end
		return
	end

	if self.touch_id ~= touch:getId() then
		return
	end

	local location = touch:getLocation()

	if event_type == XuiTouchEventType.Moved then
		if not self.is_touch_moved and math.abs(location.y - self.touch_began_point.y) >= 20 then
			self.is_touch_moved = true
		end
	elseif event_type == XuiTouchEventType.Ended then
		self.touch_id = nil
		if not self.is_touch_moved then
			self:OnClickCommonCell()
		end
		self.common_cell:StopInsideEffect()
	else
		self.touch_id = nil
		self.common_cell:StopInsideEffect()
	end

	local move_dis = 50
	if nil == self.touch_id then
		self.common_cell:GetMtView():setScale(1)
		if location.y - self.touch_began_point.y >= move_dis then
			self:OnClickCommonUp()
		elseif location.y - self.touch_began_point.y <= -move_dis then
			self:OnClickCommonDown()
		end
	end
end

function MainuiSkillBar:OnRoleDataChangeBack(key, value)
	if key == OBJ_ATTR.ACTOR_DIERRFRESHCD then
		-- self.cd_btn:SetCDTime(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_DIERRFRESHCD))
		self:FlushTime()
	elseif key == OBJ_ATTR.ACTOR_CIRCLE or key == OBJ_ATTR.CREATURE_LEVEL then
		local circle_level = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CIRCLE)		-- 人物转生等级
		if circle_level >= BoolShowImgBtn[1].levelLimit[1] then
			self.cd_btn:SetVisible(true)
		end
		local circle = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CIRCLE)
		local level = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_LEVEL)
		local job=  RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_JOB_LEVEL)
		local flag = false
		if circle<= 0 then
			if level >= 60 and job==0 then
				flag = true
			end
		else
			if job == 0 then
				flag = true
			end
		end
		if not IS_ON_CROSSSERVER then
			self.img_change_job:setVisible(flag)
		end	
	elseif key == OBJ_ATTR.ACTOR_PK_MODE then
		self.tempMode =  RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PK_MODE)
	elseif key  == OBJ_ATTR.ACTOR_JOB_LEVEL then		
		local circle = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CIRCLE)
		local level = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_LEVEL)
		local job=  RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_JOB_LEVEL)
		local flag = false
		if circle<= 0 then
			if level >= 60 and job==0 then
				flag = true
			end
		else
			if job == 0 then
				flag = true
			end
		end
		if not IS_ON_CROSSSERVER then
			self.img_change_job:setVisible(flag)
		end	
	end
end

function MainuiSkillBar:OnClickSkillCell(cell)
	cell:OnClick()
	local data = cell:GetData()
	if nil == data then
		return
	end

	if data.type == SKILL_BAR_TYPE.SKILL then
		if data.id == SKILL_ID_DIC.FS_SKILL_2 
			or data.id == SKILL_ID_DIC.FS_SKILL_7 then
			if SkillData.is_select_skill ~= data.id then
				if SkillData.is_select_skill ~= 0 then --清理上一次选择的
					for k, v in pairs(self.cell_list) do
						if nil ~= v:GetData() and v:GetData().type == SKILL_BAR_TYPE.SKILL and v:GetData().id == SkillData.is_select_skill then
							v:SetFixEffect(false)
							break
						end
					end
				end	
				cell:SetFixEffect(true)
				SkillData.is_select_skill = data.id
			else
				cell:SetFixEffect(false)
				SkillData.is_select_skill = 0
			end	
		else
			self:OnUseSkill(data.id)
		end
	elseif data.type == SKILL_BAR_TYPE.ITEM then
		if not GuideCtrl.Instance:IsFuncGuideing() and not  MovieGuideCtrl.Instance:IsGuiding() then
			MainuiCtrl.Instance:PushMainuiNavBtnToggle(false)
		end	
		local item = ItemData.Instance:GetItem(data.id)
		if nil ~= item then
			BagCtrl.Instance:SendUseItemByItem(item)
		else
			ViewManager.Instance:Open(ViewName.Shop, TabIndex.shop_yaoshui)
		end
	end
end

function MainuiSkillBar:OnUseSkill(skill_id)
	local skill = SkillData.Instance:GetSkill(skill_id)
	if nil == skill then return false end

	local can_use, range = SkillData.Instance:CanUseSkill(skill_id,true)
	if not can_use then return false end

	Scene.Instance:GetMainRole():SetPrepareSkill(skill_id)

	local skill_cfg = SkillData.GetSkillCfg(skill_id)
	if nil == skill_cfg then return false end
	local target_obj = nil
	if skill_cfg.skillSpellType == SKILL_SPELL_TYPE.AREA 
		or skill_cfg.skillSpellType == SKILL_SPELL_TYPE.SELF 
		or skill_cfg.skillSpellType == SKILL_SPELL_TYPE.NONE then
		return true
	else
		target_obj = Scene.Instance:GetMainRole():GetCanAtkTarget()
		if nil == target_obj then
			--SystemHint.Instance:FloatingTopRightText(Language.Mainui.NotAttackTarget)
			return false
		end
	end
    --停止所有动作使用技能
	Scene.Instance:GetMainRole():ClearPathInfo()
	Scene.Instance:GetMainRole():SetIsAutoFight(false)
	Scene.Instance:GetMainRole():DoSelectSceneObj(target_obj,true)
	return true
end

-- 使用合击技能
function MainuiSkillBar:OnUseCombineSkill()
	if not self.combine_skill_id then return end

	local hp = ZhanjiangData.Instance:GetAttr(OBJ_ATTR.CREATURE_HP) or 0
	if not ZhanjiangData.Instance:IsHeroFighting() or hp <= 0 then
		SystemHint.Instance:FloatingTopRightText(Language.Common.NotHeroNotUseSkill)
		return
	end	

	local can_use, range = SkillData.Instance:CanUseSkill(self.combine_skill_id,true,true)
	-- print("can_use", can_use)
	if not can_use then return false end

	Scene.Instance:GetMainRole():SetPrepareSkill(self.combine_skill_id)

	local target_obj = Scene.Instance:GetMainRole():GetCanAtkTarget()
	if nil == target_obj then
		-- SystemHint.Instance:FloatingTopRightText(Language.Mainui.NotAttackTarget)
		return false
	end
    --停止所有动作使用技能
	--Scene.Instance:GetMainRole():ClearPathInfo()
	--Scene.Instance:GetMainRole():SetIsAutoFight(false)
	Scene.Instance:GetMainRole():DoSelectSceneObj(target_obj,true)
	return true
end

function MainuiSkillBar:HeroAttrChange(key, value)
	if key == "state" then
		self.show_hero_btn:SetVisible(false)
		local hero_id = ZhanjiangData.Instance:GetAttr("hero_id")
		if hero_id > 0 then
			self.show_hero_btn:SetVisible(true)
			if ZhanjiangData.Instance:IsHeroFighting() then
				self.show_hero_btn:SetIconPath(ResPath.GetMainui2("hero_down_fight"))--英雄收回
			else
				self.show_hero_btn:SetIconPath(ResPath.GetMainui2("hero_up_fight"))--英雄出战
			end
		end

		if value == 1 and not self.combine_hero_skill_bar:IsInCD() then --and can_use
			-- self.common_cell:PlayUseCombSkillEff()
			self.combine_hero_skill_bar:PlayIconEffect(ResPath.SkillFixEffect, anim_pos, loop, true)
		else
			self.combine_hero_skill_bar:RemoveIconEffect(ResPath.SkillFixEffect)
			-- self.common_cell:StopUseCombSkillEff()
		end
	end
end

function MainuiSkillBar:CombineSkillCDendCallback()
	local state = ZhanjiangData.Instance:GetAttr("state")
	if state == 1 then
		self.combine_hero_skill_bar:PlayIconEffect(ResPath.SkillFixEffect, anim_pos, loop, true)
		-- self.common_cell:PlayUseCombSkillEff()
	else
		self.combine_hero_skill_bar:RemoveIconEffect(ResPath.SkillFixEffect)
		-- self.common_cell:StopUseCombSkillEff()
	end
end

function MainuiSkillBar:OnClickCommonCell()
	if not self.common_cell:IsInCD() then
		self.common_cell:PlayExteriorEffect()
		Scene.Instance:GetMainRole():SetPrepareSkill(Scene.Instance:GetMainRole():GetDefaultSkill())
		local target_obj = Scene.Instance:GetMainRole():GetCanAtkTarget()
		if target_obj then
			Scene.Instance:GetMainRole():ClearPathInfo()
			Scene.Instance:GetMainRole():SetIsAutoFight(false)
			Scene.Instance:GetMainRole():DoSelectSceneObj(target_obj,true)
		end	
	end	
end

function MainuiSkillBar:OnClickAutoFight()
	self:SetFingerEffectVisible(false)
	local mainRole = Scene.Instance:GetMainRole()
	if mainRole:GetIsAutoFight() then
		mainRole:SetIsAutoFight(false)
	else
		mainRole:CalNearAutoPoint()
		mainRole:SetIsAutoFight(true)
	end	
end

function MainuiSkillBar:OnChangeJob()
	ViewManager.Instance:Open(ViewName.ChangeJob)
end

function MainuiSkillBar:OnGuajiTypeChange(guaji_type)
	local mainRole = Scene.Instance:GetMainRole()
	if mainRole:GetIsAutoFight() then
		self:SetFingerEffectVisible(false)
		self.img_auto_fight:loadTexture(ResPath.GetSkillIcon("auto_fight_cancel"))--挂机
		effec:setPosition(45, 40)
	else
		self.img_auto_fight:loadTexture(ResPath.GetSkillIcon("auto_fight"))--停止挂机
		effec:setPosition(35+9999, 40)
	end	
	self:CancelAutoFightRemindEffect()
	if not GuideCtrl.Instance:IsFuncGuideing() and not  MovieGuideCtrl.Instance:IsGuiding() then
		MainuiCtrl.Instance:PushMainuiNavBtnToggle(false)
	end	
end


function MainuiSkillBar:SetFingerEffectVisible(v)
	if self.is_finger_visible == v then
		return
	end 

	self.is_finger_visible = v

	if self.is_finger_visible then
		if not self.arrow_point then
			self.arrow_point = XUI.CreateImageView(0, 0, ResPath.GetGuide("figer_point"))
			self.arrow_point:setAnchorPoint(0, 1)
			self.root_layer:TextureLayout():addChild(self.arrow_point,100)
			self.arrow_point:loadTexture(ResPath.GetGuide("figer_point"))
		end	

		local callback = cc.CallFunc:create(function()
			self.arrow_point:loadTexture(ResPath.GetGuide("figer_point1"))
		end)
		local callback1 = cc.CallFunc:create(function()
			self.arrow_point:loadTexture(ResPath.GetGuide("figer_point"))
		end)
		self.arrow_point:setPosition(self.img_auto_fight:getPositionX(), self.img_auto_fight:getPositionY())
		local action = cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.5),callback,cc.DelayTime:create(0.5),callback1))
		self.arrow_point:runAction(action)
		self.arrow_point:setVisible(true)
	else
		if self.arrow_point then
			self.arrow_point:stopAllActions()
			self.arrow_point:setVisible(false)
		end	
	end	
end	

function MainuiSkillBar:OnAreaSkillIdChange(skill_id)
	for k,v in pairs(self.cell_list) do
		if skill_id ~= 0 then
			if v:GetData() and v:GetData().id == skill_id then
				v:SetGrey(false)
			else
				v:SetGrey(true)
			end
		else
			v:SetGrey(false)
		end
	end
end

function MainuiSkillBar:OnClickCommonUp()--选怪执行
	self.common_cell:PlayUpEffect()
	if nil == self:SelectObj(SceneObjType.Role, SelectType.ModeSelect) then
		Scene.Instance:GetMainRole():PlaySlectAreaEffect(ResPath.GetBigPainting("select_area_yellow", false))
	end
end

function MainuiSkillBar:OnClickCommonDown()--选人执行
	self.common_cell:PlayDownEffect()
	if nil == self:SelectObj(SceneObjType.Monster, SelectType.Enemy) then
		Scene.Instance:GetMainRole():PlaySlectAreaEffect(ResPath.GetBigPainting("select_area_red", false))
	end
end

function MainuiSkillBar:OnGetUiNode(node_name)
	if node_name == ViewName.Bag then
		return self.bag_btn:GetView(), true
	end
	return nil, nil
end

function MainuiSkillBar:SelectObj(obj_type, select_type)
	-- 获取所有可选对象
	local obj_list
	if obj_type == SceneObjType.Role then
		obj_list = Scene.Instance:GetRoleList()
		local voData = GameVoManager.Instance:GetMainRoleVo()
		local temp = Scene.Instance:GetHeroList()
		if not self.tempMode then
			self.tempMode = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PK_MODE)
		end
		local roleobjList = obj_list
		obj_list = {}
		for k,v in pairs(roleobjList) do
			if self.tempMode == 6  then
				if RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CAMP) ~= v.vo[OBJ_ATTR.ACTOR_CAMP]then
					obj_list[k]=v
				end
			elseif self.tempMode == 1 then
				if RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_TEAM_ID) ~= v.vo[OBJ_ATTR.ACTOR_TEAM_ID]then
					obj_list[k]=v
				end
			elseif self.tempMode == 2 then
				if RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_GUILD_ID) ~= v.vo[OBJ_ATTR.ACTOR_GUILD_ID]then
					obj_list[k]=v
				end
			else
					obj_list[k]=v
			end
		end

		for u,g in pairs(temp) do
			if self.tempMode == 6  then 
				if RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CAMP) ~= g.vo.hero_camp and g.vo.owner_name ~=voData.name  then
					obj_list[u]=g
				end
			elseif self.tempMode == 1 then
				if  RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_TEAM_ID) ~= g.vo.hero_team and g.vo.owner_name ~=voData.name then
					obj_list[u]=g
				end
			elseif self.tempMode == 2 then
				if  RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_GUILD_ID) ~= g.vo.hero_guild and g.vo.owner_name ~=voData.name then
					obj_list[u]=g
				end
			else					
				if g.vo.owner_name ~=voData.name then
					obj_list[u]=g
				end
			end
		end
	else
		obj_list = Scene.Instance:GetObjListByType(obj_type)
	end
	if not next(obj_list) then
		SysMsgCtrl.Instance:FloatingTopRightText(Language.Mainui.SelectNoTips[select_type] or "")--选人模式没有目标的提示
		return
	end

	local temp_obj_list = {}
	local x, y = Scene.Instance:GetMainRole():GetLogicPos()
	local target_x, target_y = 0, 0
	local can_select = true
	for k, v in pairs(obj_list) do
		can_select = true
		if SelectType.Friend == select_type then
			can_select = Scene.Instance:IsFriend(v)
		elseif SelectType.Enemy == select_type then
			can_select = Scene.Instance:IsEnemy(v)
		elseif SelectType.ModeSelect == select_type then
			can_select = Scene.Instance:IsCanSelecetByMode(v)
		elseif SelectType.Alive == select_type then
			can_select = not v:IsDead()
		elseif SelectType.Hero == select_type then	
			can_select = Scene.Instance:IsCanSelectHero(v)
		end	

		if can_select then
			target_x, target_y = v:GetLogicPos()
			table.insert(temp_obj_list, {obj = v, dis = math.max(math.abs(target_x - x),math.abs(target_y - y))})
		end
	end
	if not next(temp_obj_list) then
		SysMsgCtrl.Instance:FloatingTopRightText(Language.Mainui.SelectNoTips[select_type] or "")--选怪模式没有目标的提示
		return
	end
	table.sort(temp_obj_list, function(a, b) return a.dis < b.dis end)
	-- 排除已选过的
	local select_obj_list = self.select_obj_group_list[obj_type]
	if nil == select_obj_list then
		select_obj_list = {}
		self.select_obj_group_list[obj_type] = select_obj_list
	end
	local select_obj = nil
	for i, v in ipairs(temp_obj_list) do
		if nil == select_obj_list[v.obj:GetObjId()] then
			select_obj = v.obj
			break
		end
	end
	-- 如果没有选中，选第一个，并清空已选列表
	if nil == select_obj then
		select_obj = temp_obj_list[1].obj
		select_obj_list = {}
		self.select_obj_group_list[obj_type] = select_obj_list
	end
	if nil == select_obj then
		return
	end
	select_obj_list[select_obj:GetObjId()] = select_obj

	Scene.Instance:GetMainRole():DoSelectSceneObj(select_obj,false)
	return select_obj
end

function MainuiSkillBar:OnRecvMainRoleInfo()
	local prof = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PROF)
	self.combine_skill_id = COMBINE_SKILL_LIST[prof]
	if self.combine_hero_skill_bar then
		local path = ResPath.GetSkillIcon(SkillData.Instance:GetSkillIconId(self.combine_skill_id))
		self.combine_hero_skill_bar:SetIconPath(path)
	end
	if nil ~= self.common_cell then
		self.common_cell:FlushIcon()
	end
	local circle_level = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_CIRCLE)		-- 人物转生等级
	if circle_level >= BoolShowImgBtn[1].levelLimit[1] then
		self.cd_btn:SetVisible(true)
		self:FlushTime()
	end	
end

function MainuiSkillBar:SetCombineSkillBarVis(visible)
	-- if self.common_cell then
	-- 	self.common_cell:SetDownImageShowState(not visible)
	-- end
	if not self.combine_hero_skill_bar:IsVisible() then
		self.combine_hero_skill_bar:SetVisible(visible)
	end
end

function MainuiSkillBar:OnInitSkillList()
	self:FlushSkillCd()
end

function MainuiSkillBar:OnMainRoleUseSkill(skill_id)
	self:FlushCDBySkillid(skill_id)
end

function MainuiSkillBar:OnCommonCdChange()
	self.common_cell:SetCDTime(SkillData.Instance:GetGlobalCD())
	self:FlushSkillCd()
end

function MainuiSkillBar:OnBoolShowLayout()
	if self.delay_play_time_vis then
		GlobalTimerQuest:CancelQuest(self.delay_play_time_vis)
		self.delay_play_time_vis = nil 
	end
	if self.skill_id ~=nil and self.cell ~= nil and SKILL_NEW_GET_FLY_EFFECT_LIST[self.skill_id] then
		self:FlyNewSkillIcon(self.cell, self.skill_id)
	end
	self.skill_cell_layout:setVisible(false)
end	

function MainuiSkillBar:OnSkillBarChange()
	-- for k, v in pairs(self.cell_list) do
	-- 	v:SetData(SettingData.Instance:GetOneShowSkill(HOT_KEY["SKILL_BAR_" .. k]))
	-- 	v:SetFixEffect(false)
	-- end
	self.cell = nil
	for k, v in pairs(self.cell_list) do
		local data_1 = v:GetData()
		v:SetData(SettingData.Instance:GetOneShowSkill(HOT_KEY["SKILL_BAR_" .. k]))
		local data_2 = v:GetData()
		v:SetFixEffect(false)
		if data_1 == nil and data_2 and data_2.type == SKILL_BAR_TYPE.SKILL and 
			SKILL_NEW_GET_FLY_EFFECT_LIST[data_2.id] and not SkillData.Instance:GetSkill(data_2.id) and self.is_first_init == false then
			self.skill_id = data_2.id 
			self.skill_cell_layout:setVisible(true)
			local skill_name_id = data_2.id
			self.fly_icon:loadTexture(ResPath.GetSkillIcon(SkillData.Instance:GetSkillIconId(data_2.id)))
			self.skill_name_path:loadTexture(ResPath.GetSkillIcon("skill_"..skill_name_id.."_name"))
			self.cell = v
			if self.delay_play_time_vis then
				GlobalTimerQuest:CancelQuest(self.delay_play_time_vis)
				self.delay_play_time_vis = nil 
			end
			self.delay_play_time_vis = GlobalTimerQuest:AddDelayTimer(function() 
				if self.skill_cell_layout:isVisible() then
					self.skill_cell_layout:setVisible(false)
					self:FlyNewSkillIcon(v, data_2.id)
				end
			end, 5)
		end
	end
	self.is_first_init = false

	-- self.yao_cell:SetData(SettingData.Instance:GetOneShowSkill(HOT_KEY["SKILL_BAR_9"]))
	SkillData.is_select_skill = 0
	self:FlushSkillCd()
end

function MainuiSkillBar:FlyNewSkillIcon(cell, id)
	local path = ResPath.GetSkillIcon(SkillData.Instance:GetSkillIconId(id))
	local screen_w = HandleRenderUnit:GetWidth()
	local screen_h = HandleRenderUnit:GetHeight()
	local fly_icon = XUI.CreateImageView(0, 0, path, true)
	-- fly_icon:setAnchorPoint(0, 0)
	HandleRenderUnit:AddUi(fly_icon, COMMON_CONSTS.ZORDER_SYSTEM_EFFECT, COMMON_CONSTS.ZORDER_SYSTEM_EFFECT)
	local world_pos = fly_icon:convertToWorldSpace(cc.p(0,0))
	fly_icon:setPosition(screen_w / 2, screen_h / 2)

	local fly_to_pos = cc.p(screen_w - 40, 0)
	local move_to =cc.MoveTo:create(1.6, cc.p(screen_w - 66, 88))
	local spawn = cc.Spawn:create(move_to)
	local callback = cc.CallFunc:create(function()
		if cell then
			cell:SetFixEffect(true, 2)
		end
		fly_icon:removeFromParent()
		end)

	local action = cc.Sequence:create(spawn, callback)
	fly_icon:runAction(action)
end

function MainuiSkillBar:FlushSkillCd()
	for k, v in pairs(self.cell_list) do
		if nil ~= v:GetData() and v:GetData().type == SKILL_BAR_TYPE.SKILL then
			v:SetCDTime(SkillData.Instance:GetSkillCD(v:GetData().id))
		end
	end

end


function MainuiSkillBar:FlushCDBySkillid(skill_id)
	if skill_id == self.combine_skill_id then
		local cd_time = SkillData.Instance:GetSkillCD(self.combine_skill_id)
		self.combine_hero_skill_bar:RemoveIconEffect(ResPath.SkillFixEffect)
		self.combine_hero_skill_bar:SetCDTime(cd_time, 1.1)
		-- self.common_cell:SetCDTime2(cd_time)
	else
		for k, v in pairs(self.cell_list) do
		if nil ~= v:GetData() and v:GetData().type == SKILL_BAR_TYPE.SKILL and v:GetData().id == skill_id then
			v:SetCDTime(SkillData.Instance:GetSkillCD(v:GetData().id))
			if skill_id == SKILL_ID_DIC.FS_SKILL_2 
				or skill_id == SKILL_ID_DIC.FS_SKILL_7 then
				v:SetFixEffect(false)
				if SkillData.is_select_skill == skill_id then
					SkillData.is_select_skill = 0
				end	
			end
		end
	end
	end
end	

function MainuiSkillBar:FlushCDByItem()
	for k, v in pairs(self.cell_list) do
		if nil ~= v:GetData() and v:GetData().type == SKILL_BAR_TYPE.ITEM then
			v:SetCDTime(BagCtrl.Instance:GetCdTargetTimeByItemId(v:GetData().id))
		end
	end
	-- local item = self.yao_cell:GetData()
	-- if item then
	-- 	self.yao_cell:SetCDTime(BagCtrl.Instance:GetCdTargetTimeByItemId(item.id))
	-- end	
end	

function MainuiSkillBar:OnItemChange(change_type, change_item_id, change_item_index, series)
	for k, v in pairs(self.cell_list) do
		if nil ~= v:GetData() and v:GetData().type == SKILL_BAR_TYPE.ITEM then
			v:FlushByItemId(v:GetData().id)
		end	
	end

	-- local item = self.yao_cell:GetData()
	-- if item then
	-- 	self.yao_cell:FlushByItemId(item.id)
	-- end

	local num = ItemData.Instance:GetItemNumInBagById(SettingData.DELIVERY_T[1])
	self.auto_huicheng_btn:SetRemindNumTxt(num,70,70,0)
	self.auto_huicheng_btn:SetGrey(num > 0)
	num = ItemData.Instance:GetItemNumInBagById(SettingData.DELIVERY_T[2])
	self.auto_suiji_btn:SetRemindNumTxt(num,70,70,0)
	self.auto_suiji_btn:SetGrey(num > 0)
	
	num = ItemData.Instance:GetEmptyNum()
	if num == 0 then
		num = Language.Common.Man
	elseif num > 4 then
		num = 0
	end
	self.bag_btn:SetRemindNumTxt(num,70,70,0)
end


function MainuiSkillBar:OnEquipDataChangeBack()
	local equip = EquipData.Instance:GetEquipByType(ItemData.ItemType.itSpecialRing, 1)
	-- self.cd_btn:SetVisible(equip and true or false)
	self.cd_btn:SetGrey(equip and true or false)
end

function MainuiSkillBar:OnItemCdChange(item_id)
	if item_id == SettingData.DELIVERY_T[1] then
		self.auto_huicheng_btn:SetCDTime(BagCtrl.Instance:GetCdTargetTimeByItemId(item_id), 0.8)
	elseif item_id == SettingData.DELIVERY_T[2] then
		self.auto_suiji_btn:SetCDTime(BagCtrl.Instance:GetCdTargetTimeByItemId(item_id), 0.8)
	end	

	self:FlushCDByItem()
end	

function MainuiSkillBar:SetVisible(visible)
	self.mt_layout_skill:setVisible(visible)
end

------------------------------------------------------------------------
MainuiSkillItem = MainuiSkillItem or BaseClass()
MainuiSkillItem.Size = cc.size(80, 80)
function MainuiSkillItem:__init(parent, index)
	self.mt_view = MainuiMultiLayout.New()
	self.mt_view:CreateByMultiLayout(parent)
	self.mt_view:setContentSize(MainuiSkillItem.Size)

	self.index = index
	self.angle = 0

	self.data = nil
	self.cd_end_time = 0
	self.last_click_time = 0

	self.click_scale = 1.1
	self.normal_scale = 1

	self:CreateUi()
end

function MainuiSkillItem:__delete()
	self.cell_fix_effect:setStop()
end

function MainuiSkillItem:SetNormalScale(normal_scale)
	self.normal_scale = normal_scale
	self.mt_view:setScale(self.normal_scale)
end	

function MainuiSkillItem:SetClickScale(click_scale)
	self.click_scale = click_scale
end	

function MainuiSkillItem:CreateUi()--技能显示位置
	local x, y = MainuiSkillItem.Size.width / 2, MainuiSkillItem.Size.height / 2

	self.img_skill_light = XUI.CreateImageView(x, y, ResPath.GetSkillIcon("skill_light"), true)--技能底框显示坐标
	self.mt_view:TextureLayout():addChild(self.img_skill_light)

	self.img_skill = XUI.CreateImageView(x, y, ResPath.GetSkillIcon("double_setting"), true)--技能与物品图标显示 和 没有放技能或物品时出现的+号底框 显示坐标
	--self.img_skill:setScale(0.9)
	self.mt_view:TextureLayout():addChild(self.img_skill)

	self.text_num = XUI.CreateText(x, 20, 60, 20, nil, "", nil, 24)--放置道具时显示的数量 坐标
	self.mt_view:TextLayout():addChild(self.text_num)
	XUI.EnableOutline(self.text_num)
	self.text_num:setVisible(false)

	local sprite = XUI.CreateSprite(ResPath.GetSkillIcon("skill_mask"))--技能冷却是展现的圆圈冷却 坐标
	self.cd_bar = cc.ProgressTimer:create(sprite)
	self.cd_bar:setScale(1.1)
	self.cd_bar:setType(0)
	self.cd_bar:setPercentage(0)
	self.cd_bar:setReverseDirection(true)
	self.cd_bar:setPosition(x, y)
	self.cd_bar:setVisible(false)
	self.mt_view:EffectLayout():addChild(self.cd_bar)

	self.cell_fix_effect = AnimateSprite:create()
	self.cell_fix_effect:setPosition(x,y)
	self.cell_fix_effect:setScale(1.3)
	self.mt_view:EffectLayout():addChild(self.cell_fix_effect)
end

function MainuiSkillItem:CreateChangeItemBtn(x, y, path)
	-- 物品切换按钮
	if self.item_type_change == nil then
		self.item_type_change = XUI.CreateButton(x or -32, y or 34,50,50,false, path or ResPath.GetMainui("s_arrow_1"),"","",true)
		self.item_type_change:setScale(1 / self.mt_view:getScale())
		self.mt_view:EffectLayout():addChild(self.item_type_change)
		self.img_skill:setScale(1 / self.mt_view:getScale())
		XUI.AddClickEventListener(self.item_type_change, BindTool.Bind(self.ChangeItemShow, self), true)
	end
end

function MainuiSkillItem:ChangeItemShow()
	if self.change_item_callback then
		self.change_item_callback()
	end
end

function MainuiSkillItem:SetChangeItemBtnCallback(func)
	self.change_item_callback = func
end

function MainuiSkillItem:GetMtView()
	return self.mt_view
end

function MainuiSkillItem:GetAngle()
	return self.angle
end

function MainuiSkillItem:SetAngle(angle)
	self.angle = angle
end

function MainuiSkillItem:SetData(data)
	self.data = data
	self.text_num:setVisible(false)

	if nil == data then
		self:SetCDTime(0)
		self.img_skill:loadTexture(ResPath.GetSkillIcon("double_setting"))
		return
	end

	if self.data.type == SKILL_BAR_TYPE.SKILL then
		self.img_skill:loadTexture(ResPath.GetSkillIcon(SkillData.Instance:GetSkillIconId(self.data.id)))
		self.img_skill:setGrey(false)
	elseif self.data.type == SKILL_BAR_TYPE.ITEM then
		self:FlushByItemId(self.data.id)
	end
end

function MainuiSkillItem:GetData()
	return self.data
end

function MainuiSkillItem:FlushByItemId(item_id)
	if nil ~= self.data and self.data.type == SKILL_BAR_TYPE.ITEM and self.data.id == item_id then
		local item_config = ItemData.Instance:GetItemConfig(item_id)
		if nil ~= item_config then
			local item_num = ItemData.Instance:GetItemNumInBagById(item_id)
			if ItemData.GetIsTransferStone(item_id) then
				item_num = ItemData.Instance:GetItemDurabilityInBagById(item_id) / 1000
			end
			self.text_num:setVisible(true)
			self.text_num:setString("X" .. tonumber(item_num))
			local path = ResPath.GetItem(item_config.icon)
			self.img_skill:loadTexture(path)
			self.img_skill:setGrey(item_num <= 0)
		end
	end
end

function MainuiSkillItem:OnClick()
	if nil == self.data then
		ViewManager.Instance:Open(ViewName.Role, TabIndex.role_skill_select)
		-- if Status.NowTime - self.last_click_time <= 0.5 then
		-- 	self.last_click_time = 0
		-- 	ViewManager.Instance:Open(ViewName.Role, TabIndex.role_skill_select)
		-- else
		-- 	self.last_click_time = Status.NowTime
		-- end
	else
		self.last_click_time = 0
	end
end

function MainuiSkillItem:SetGrey(value)
	self.img_skill:setGrey(value)
end


function MainuiSkillItem:SetFixEffect(v, loops)
	if v then
		local anim_path, anim_name = ResPath.GetEffectUiAnimPath(ResPath.SkillFixEffect)
		self.cell_fix_effect:setAnimate(anim_path,anim_name,loops or COMMON_CONSTS.MAX_LOOPS,FrameTime.Effect,false)
	else
		self.cell_fix_effect:setStop()
	end	
end	

function MainuiSkillItem:IsInCD()
	return self.cd_bar:isVisible()
end

function MainuiSkillItem:SetCDTime(cd_time)--技能冷却时间展示的黑光圈
	if cd_time == self.cd_end_time then
		return
	end
	self.cd_end_time = cd_time

	if cd_time > Status.NowTime then
		self.cd_bar:setVisible(true)
		cd_time = cd_time - Status.NowTime
		CountDownManager.Instance:AddCountDown("mainui_skill_" .. self.index, BindTool.Bind(self.UpdateCD, self), 
			BindTool.Bind(self.CompleteCd, self), nil, cd_time, 0.05)
	else
		self.cd_bar:setVisible(false)
		CountDownManager.Instance:RemoveCountDown("mainui_skill_" .. self.index)
	end
end

function MainuiSkillItem:UpdateCD(elapse_time, total_time)
	self.cd_bar:setPercentage((1 - elapse_time / total_time) * 100)
end

function MainuiSkillItem:CompleteCd()
	self.cd_bar:setVisible(false)
	self.cd_bar:setPercentage(0)
end

------------------------------------------------------------------------
MainuiSkillCommonItem = MainuiSkillCommonItem or BaseClass()
MainuiSkillCommonItem.Size = cc.size(130, 130)
function MainuiSkillCommonItem:__init(parent)
	self.last_click_time = 0

	self.mt_view = MainuiMultiLayout.New()
	self.mt_view:CreateByMultiLayout(parent)
	self.mt_view:setContentSize(MainuiSkillCommonItem.Size)

	self:CreateUi()
end

function MainuiSkillCommonItem:__delete()
end

function MainuiSkillCommonItem:CreateUi()
	local x, y = MainuiSkillCommonItem.Size.width / 2, MainuiSkillCommonItem.Size.height / 2

	-- self.img_skill_light = XUI.CreateImageView(x, y, ResPath.GetSkillIcon("common_light"), true)--攻击按钮底框
	-- self.mt_view:TextureLayout():addChild(self.img_skill_light)

	self.img_skill = XUI.CreateImageView(x, y, "", true)--攻击按钮的图标
	-- self.img_skill:setScale(0.9)
	self.mt_view:TextureLayout():addChild(self.img_skill)
	self:FlushIcon()
	
	local sprite = XUI.CreateSprite(ResPath.GetSkillIcon("skill_mask"))
	self.cd_bar = cc.ProgressTimer:create(sprite)
	self.cd_bar:setScale(1.6)
	self.cd_bar:setType(0)
	self.cd_bar:setPercentage(0)
	self.cd_bar:setReverseDirection(true)
	self.cd_bar:setPosition(x, y)
	self.cd_bar:setVisible(false)
	self.mt_view:EffectLayout():addChild(self.cd_bar)

	
	-- self.img_up = XUI.CreateImageView(x, MainuiSkillCommonItem.Size.height, ResPath.GetSkillIcon("up_role"), true)--选择玩家
	-- self.mt_view:TextureLayout():addChild(self.img_up)

	-- self.img_down = XUI.CreateImageView(x, -2, ResPath.GetSkillIcon("down_monster"), true)--选择怪物
	-- self.mt_view:TextureLayout():addChild(self.img_down)

	self.up_effect = XUI.CreateImageView(x, y, ResPath.GetSkillIcon("common_up_effect"), true)---选择怪物或角色技能上出现的半圆光圈
	self.mt_view:TextureLayout():addChild(self.up_effect)
	self.up_effect:setVisible(false)

	self.inside_effect = XUI.CreateImageView(x, y, ResPath.GetSkillIcon("common_inside_effect"), true)--点击普通攻击出现的 全圆光圈
	self.mt_view:TextureLayout():addChild(self.inside_effect)
	self.inside_effect:setVisible(false)

	local sprite_2 = XUI.CreateSprite(ResPath.GetSkillIcon("common_down"))--释放合击字体
	self.cd_bar_2 = cc.ProgressTimer:create(sprite_2)
	-- self.cd_bar_2:setScale(1.6)
	self.cd_bar_2:setType(1)
	self.cd_bar_2:setPercentage(0)
	self.cd_bar_2:setMidpoint(cc.p(0,1))
	self.cd_bar_2:setBarChangeRate(cc.p(0,1))
	-- self.cd_bar_2:setReverseDirection(true)
	self.cd_bar_2:setPosition(x, 2)
	self.cd_bar_2:setVisible(false)
	self.mt_view:EffectLayout():addChild(self.cd_bar_2)

	-- local arrow_up = XUI.CreateImageView(x, y * 2 - 15, ResPath.GetSkillIcon("arrow"), true)--向上三角
	-- self.mt_view:TextureLayout():addChild(arrow_up, 99)

	-- local arrow_down = XUI.CreateImageView(x, 15, ResPath.GetSkillIcon("arrow"), true)--向下三角
	-- arrow_down:setScaleY(-1)
	-- self.mt_view:TextureLayout():addChild(arrow_down, 99)

end

function MainuiSkillCommonItem:GetMtView()
	return self.mt_view
end

function MainuiSkillCommonItem:FlushIcon()--技能图标
	local prof = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_PROF) or GameEnum.ROLE_PROF_1
	if prof ~= 0 and prof ~= nil then
		self.img_skill:loadTexture(ResPath.GetSkillIcon("100" .. prof), true)
	end
end

function MainuiSkillCommonItem:OnClick()
	self.last_click_time = Status.NowTime
end

function MainuiSkillCommonItem:IsInCD()
	return self.cd_bar:isVisible()
end

function MainuiSkillCommonItem:SetCDTime(cd_time)
	if cd_time > Status.NowTime then
		self.cd_bar:setVisible(true)
		cd_time = cd_time - Status.NowTime
		CountDownManager.Instance:AddCountDown("mainui_skill_common", BindTool.Bind(self.UpdateCD, self), 
			BindTool.Bind(self.CompleteCd, self), nil, cd_time, 0.05)
	else
		self.cd_bar:setVisible(false)
		CountDownManager.Instance:RemoveCountDown("mainui_skill_common")
	end
end

function MainuiSkillCommonItem:UpdateCD(elapse_time, total_time)
	self.cd_bar:setPercentage((1 - elapse_time / total_time) * 100)
end

function MainuiSkillCommonItem:CompleteCd()
	self.cd_bar:setVisible(false)
	self.cd_bar:setPercentage(0)
end


function MainuiSkillCommonItem:IsInCD2()
	return self.cd_bar_2:isVisible()
end

function MainuiSkillCommonItem:SetCDTime2(cd_time)
	if cd_time > Status.NowTime then
		self.cd_bar_2:setVisible(true)
		self:StopUseCombSkillEff()
		cd_time = cd_time - Status.NowTime
		CountDownManager.Instance:AddCountDown("mainui_skill_common2", BindTool.Bind(self.UpdateCD2, self), 
			BindTool.Bind(self.CompleteCd2, self), nil, cd_time, 0.05)
	else
		self.cd_bar_2:setVisible(false)
		CountDownManager.Instance:RemoveCountDown("mainui_skill_common2")
	end
end

function MainuiSkillCommonItem:UpdateCD2(elapse_time, total_time)
	self.cd_bar_2:setPercentage((1 - elapse_time / total_time) * 100)
end

function MainuiSkillCommonItem:CompleteCd2()
	self.cd_bar_2:setVisible(false)
	self.cd_bar_2:setPercentage(0)
	-- local hero_state = ZhanjiangData.Instance:GetAttr("state")
	-- if hero_state == 1 then
	-- 	self:PlayUseCombSkillEff()
	-- else
	-- 	self:StopUseCombSkillEff()
	-- end
end

function MainuiSkillCommonItem:PlayUpEffect()--选人执行脚本
	self.up_effect:setVisible(true)
	self.up_effect:setScaleY(1)
	self.up_effect:setOpacity(255)

	self.up_effect:stopAllActions()
	local action_complete_callback = function()
		self.up_effect:setVisible(false)
	end
	local action = cc.Sequence:create(cc.FadeOut:create(0.5), cc.CallFunc:create(action_complete_callback))
	self.up_effect:runAction(action)
end

function MainuiSkillCommonItem:PlayDownEffect()--选怪执行脚本
	self.up_effect:setVisible(true)
	self.up_effect:setScaleY(-1)
	self.up_effect:setOpacity(255)

	self.up_effect:stopAllActions()
	local action_complete_callback = function()
		self.up_effect:setVisible(false)
	end
	local action = cc.Sequence:create(cc.FadeOut:create(0.5), cc.CallFunc:create(action_complete_callback))
	self.up_effect:runAction(action)
end

function MainuiSkillCommonItem:PlayInsideEffect()
	self.inside_effect:setVisible(true)
end

function MainuiSkillCommonItem:StopInsideEffect()
	self.inside_effect:setVisible(false)
end

function MainuiSkillCommonItem:PlayExteriorEffect()
	RedPackageCtrl.Instance:SendReceiveRedPaper2()
	
		local item = ItemData.Instance:GetOneItem(SettingData.DELIVERY_T[3])
	    if item then
	 	BagCtrl.Instance:SendUseItemByItem(item)
	    end
		
	local x, y = MainuiSkillCommonItem.Size.width / 2, MainuiSkillCommonItem.Size.height / 2
	local effect = XUI.CreateImageView(x, y, ResPath.GetSkillIcon("common_exterior_effect"), true)--点击普通攻击出现的金色描边圆圈动画
	effect:setScale(0.83)
	self.mt_view:TextureLayout():addChild(effect)

	local scale_to = cc.ScaleTo:create(0.3, 1)
	local action_complete_callback = function()
		effect:removeFromParent()
	end
	local action = cc.Sequence:create(scale_to, cc.CallFunc:create(action_complete_callback))
	effect:runAction(action)
end

function MainuiSkillCommonItem:PlayUseCombSkillEff(effect_id, zorder, loops, x, y)
	effect_id = effect_id or 100
	loops = loops or COMMON_CONSTS.MAX_LOOPS
	if loops >= 10 then loops = COMMON_CONSTS.MAX_LOOPS end
	if self.use_comb_skill_eff == nil then
		zorder = zorder or 99
		x = x or MainuiSkillCommonItem.Size.width / 2
		y = y or 2
		self.use_comb_skill_eff = AnimateSprite:create()
		self.use_comb_skill_eff:setPosition(x, y)
		self.mt_view:EffectLayout():addChild(self.use_comb_skill_eff, zorder)
	end
	local anim_path, anim_name = ResPath.GetEffectAnimPath(effect_id)
	self.use_comb_skill_eff:setAnimate(anim_path,anim_name, loops, FrameTime.Effect,false)
end

function MainuiSkillCommonItem:StopUseCombSkillEff()
	if self.use_comb_skill_eff then
		self.use_comb_skill_eff:setStop()
	end
end

function MainuiSkillCommonItem:SetDownImageShowState(is_gray)
	if self.img_down then
		self.img_down:setGrey(is_gray)
	end
end


SeletPlayer = SeletPlayer or BaseClass(BaseRender)
function SeletPlayer:__init()
	self.view:setAnchorPoint(0,0)
	self.view:setContentSize(cc.size(235,66))
end

function SeletPlayer:__delete()
end	

function SeletPlayer:CreateChild()--目标功能框框
	BaseRender.CreateChild(self)
	local size = self.view:getContentSize()
	self.img_bg = XUI.CreateImageView(0,0,ResPath.GetCommon("lock_player_bg_1"),true)--职业头像
	self.img_bg:setAnchorPoint(0,0)
	self.view:addChild(self.img_bg)
	self.label = XUI.CreateText(size.width * 0.3,size.height * 0.8,0,0,cc.TEXT_ALIGNMENT_CENTER,nil,nil,16,COLOR3B.G_Y)--角色名
	self.label:setAnchorPoint(0.0,1.0)--文字扩展方向
	self.view:addChild(self.label)

	self.role_lv_txt = XUI.CreateText(size.width * 0.3,size.height * 0.5,0,0,cc.TEXT_ALIGNMENT_CENTER,nil,nil,16,COLOR3B.G_Y)--等级
	self.role_lv_txt:setAnchorPoint(0.0,1.0)--文字扩展方向
	self.view:addChild(self.role_lv_txt)
end
	
function SeletPlayer:OnFlush()--目标功能选择目标属性
	if self.data then
		local player = self.data.obj
		local prof = player.vo[OBJ_ATTR.ACTOR_PROF]
		local lv = player.vo[OBJ_ATTR.CREATURE_LEVEL] or 0
		local zs = player.vo[OBJ_ATTR.ACTOR_CIRCLE] or 0
		local ZL = player.vo[OBJ_ATTR.ACTOR_BATTLE_POWER]
		local bg_path = ResPath.GetCommon("lock_player_bg_" .. prof)
		self.img_bg:loadTexture(bg_path)
		self.label:setString(player.vo.name.."   " .. zs.."转"..lv.."级")

		self.role_lv_txt:setString("战力:" .. ZL)
	end	
end	

-- 创建选中特效
function SeletPlayer:CreateSelectEffect()
end
