MainuiTask = MainuiTask or BaseClass()
MainuiTask.Size = cc.size(266, 350)--任务显示范围
MainuiTask.TaskRenderHeight = 55
MainuiTask.TeamRenderHeight = 80

MainuiTask.TaskFinishAnimParams = {0.15, 300}

MainuiTask.SHOW_TYPE = {LEFT = 1, RIGHT = 2}
MainuiTask.MainuiHasGuide = {}

-- 导航的内容标识
MainuiTask.GUIDE_NAME = {
	NUll = "null",
	TASK = "task",
	TEAM = "team",

	FB_PERSONAL_BOSS = "fb_personal_boss",
	FB_MATERIAL = "fb_material",
	FB_TAFANG = "fb_tafang",
	FB_STRENGTH = "fb_strength",

	ACT_BI_GUAN = "act_bi_guan",
	ACT_JU_MO = "act_ju_mo",
	ACT_YA_SONG = "act_ya_song",
	ACT_MO_BAI = "act_mo_bai",
	ACT_WULIN_ZHENG_BA = "act_wulin_zheng_ba",
	ACT_YUAN_BAO = "act_yuan_bao",
	ACT_ZHEN_YING = "act_zhen_ying",
	ACT_WANG_CHENG = "act_wang_cheng",
	ACT_HANG_HUI = "act_hang_hui",
	ACT_GONG_CHENG = "act_gong_cheng",
}

function MainuiTask:__init()
	self.mt_layout_root = nil

	self.btn_task = nil
	self.text_task = nil
	self.btn_team = nil
	self.text_team = nil

	self.img_arrow_left = nil
	self.img_arrow_right = nil
	self.img_list_bg = nil

	self.task_listview = nil
	self.team_listview = nil
	self.is_click_type = 1
	self.showing_type = MainuiTask.SHOW_TYPE.LEFT

	self.task_callback = BindTool.Bind(self.OnTaskChange, self)
	GlobalEventSystem:Bind(OtherEventType.TEAM_INFO_CHANGE, BindTool.Bind(self.OnTeamChange, self))

	GlobalEventSystem:Bind(FumoEventType.FUMO_INFO_CHANGE_BACK,self.task_callback)

	self.role_attr_change_callback = BindTool.Bind(self.OnRoleDataChangeCallback, self)
	RoleData.Instance:NotifyAttrChange(self.role_attr_change_callback)

	GlobalEventSystem:Bind(MainUIEventType.TASK_SHOW_TYPE_CHANGE, BindTool.Bind(self.OnTaskShowChange, self))
	-- GlobalEventSystem:Bind(MainUIEventType.MAINUI_FUNNOTE_VISIBLE,BindTool.Bind(self.OnFunNoteVisibleChange, self))
	if not self.carnivalBoss then
		self.carnivalBoss = GlobalEventSystem:Bind(HeroGoldEvent.CarnivalBoss, BindTool.Bind(self.OnCarnivalCallback, self))
	end

	GlobalEventSystem:Bind(HeroGoldEvent.CarnivalBoss, BindTool.Bind(self.OnRecvMainRoleInfo, self))
end


function MainuiTask:OnRecvMainRoleInfo()
self:SetMainRoleLevel1("-"..(500-RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_ATTACK_SPEED)))--攻击间隔
self:SetMainRoleLevel2("-"..(500-RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_MOVE_SPEED)))--移动间隔
self:SetMainRoleLevel3("+"..(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_AAAAA)).."%")--鞭尸几率
self:SetMainRoleLevel4(RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_AAAAB).."次")--必鞭次数
self:SetMainRoleLevel5("+"..RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_AAAAC))--切割伤害
self:SetMainRoleLevel6("+"..RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_AAAAD)*1000)--刀刀吸血
end

function MainuiTask:SetMainRoleLevel1(value)
	sxdk1_txt:setString(value)
end
function MainuiTask:SetMainRoleLevel2(value)
	sxdk2_txt:setString(value)
end
function MainuiTask:SetMainRoleLevel3(value)
	sxdk3_txt:setString(value)
end
function MainuiTask:SetMainRoleLevel4(value)
	sxdk4_txt:setString(value)
end
function MainuiTask:SetMainRoleLevel5(value)
	sxdk5_txt:setString(value)
end
function MainuiTask:SetMainRoleLevel6(value)
	sxdk6_txt:setString(value)
end


function MainuiTask:__delete()

	if self.carnivalBoss then
		GlobalEventSystem:UnBind(self.carnivalBoss)
		self.carnivalBoss = nil
	end

	if TaskData.Instance then
		TaskData.Instance:UnListenerTaskChange(self.task_callback)
	end
	if RoleData.Instance then
		RoleData.Instance:UnNotifyAttrChange(self.role_attr_change_callback)
	end

	self.task_callback = nil

	if self.task_listview then
		self.task_listview:DeleteMe()
		self.task_listview = nil
	end

	if self.team_listview then
		self.team_listview:DeleteMe()
		self.team_listview = nil
	end

	if nil ~= self.arrow_point then
		self:RemoveTaskCompleteAnim()
	end

	MainuiTask.MainuiHasGuide = {}

end

function MainuiTask:Init(mt_layout_root)--任务页面
	local screen_w, screen_h = HandleRenderUnit:GetWidth(), HandleRenderUnit:GetHeight()
	self.global_y = screen_h - 240	


	self.mt_layout_root = MainuiMultiLayout.CreateMultiLayout(20+60, self.global_y+80 , cc.p(0, 1), MainuiTask.Size, mt_layout_root, 0)
	
	self.mt_layout_root1 = MainuiMultiLayout.CreateMultiLayout(-15, self.global_y-160 , cc.p(0, 1), MainuiTask.Size, self.mt_layout_root, 0)
	local y = MainuiTask.Size.height - 11

	self.img_arrow_left = XUI.CreateImageView(20, y-260, ResPath.GetMainui("task_arrow_left"), true)--缩放三角
	self.mt_layout_root:TextureLayout():addChild(self.img_arrow_left)
	XUI.AddClickEventListener(self.img_arrow_left, BindTool.Bind(self.OnClickArrawLeft, self), true)

	self.img_arrow_right = XUI.CreateImageView(360, y-260, ResPath.GetMainui("task_arrow_left"), true)--缩放三角
	self.img_arrow_right:setScaleX(-1)
	self.img_arrow_right:setVisible(false)
	self.mt_layout_root:TextureLayout():addChild(self.img_arrow_right)
	XUI.AddClickEventListener(self.img_arrow_right, BindTool.Bind(self.OnClickArrawRight, self), true)
	
	self.img_arrow_dk = XUI.CreateImageView(32, y-155, ResPath.GetMainui("task_bg3"), true)--左侧任务下底框
	self.mt_layout_root1:TextureLayout():addChild(self.img_arrow_dk)
	
	self.btn_task = XUI.CreateImageView(30,y-60,ResPath.GetMainui("task_btn_bg1"),true)--任务按钮
	self.mt_layout_root1:TextureLayout():addChild(self.btn_task)
	XUI.AddClickEventListener(self.btn_task, BindTool.Bind(self.OnClickTask, self), true)

	self.text_task = XUI.CreateText(30,y-60,130,0,cc.TEXT_ALIGNMENT_CENTER,"",nil,24,COLOR3B.WHITE)
	self.text_task:setAnchorPoint(0.5, 0.5)
	self.text_task:setString(Language.Mainui.TaskTitle)
	self.mt_layout_root1:TextLayout():addChild(self.text_task)

	self.btn_team = XUI.CreateImageView(30,y-183,ResPath.GetMainui("task_btn_bg"),true)--组队按钮
	self.mt_layout_root1:TextureLayout():addChild(self.btn_team)
	XUI.AddClickEventListener(self.btn_team, BindTool.Bind(self.OnClickTeam, self), true)

	self.text_team = XUI.CreateText(30,y-173 ,130,0,cc.TEXT_ALIGNMENT_CENTER,"",nil,24,COLOR3B.WHITE)--任务字体
	self.text_team:setAnchorPoint(0.5, 0.5)
	self.text_team:setString(Language.Mainui.TeamTitle)
	self.mt_layout_root1:TextLayout():addChild(self.text_team)

	self.img_to_boss = XUI.CreateImageView(285+99999, y-60, ResPath.GetMainui2("main_ui_canival_boss"), true)--神转盛宴
	self.img_to_boss:setAnchorPoint(0,0.5)
	self.img_to_boss:setVisible(false)
	self.mt_layout_root:TextureLayout():addChild(self.img_to_boss)
	XUI.AddClickEventListener(self.img_to_boss, BindTool.Bind(self.OnClickToCarnival, self), true)



	y = MainuiTask.Size.height +10
	local list_size = cc.size(MainuiTask.Size.width, MainuiTask.Size.height - 23 )

	local task_h_shift = 60--331
	self.img_list_bg = XUI.CreateImageViewScale9(53+99999, y, list_size.width, list_size.height - task_h_shift + 4, ResPath.GetMainui("task_bg"), true)--任务底框
	self.img_list_bg:setAnchorPoint(0, 1)
	self.img_list_bg.base_size = list_size
	self.img_list_bg.task_h_shift = task_h_shift
	self.mt_layout_root:TextureLayout():addChild(self.img_list_bg)

	self.task_listview = ListView.New()
	self.task_listview:Create(53, y - 2, list_size.width, list_size.height - task_h_shift, nil, MainuiTaskItemReander,nil,true)
	self.task_listview:GetView():setAnchorPoint(0, 1)
	self.task_listview:SetItemsInterval(1)
	self.task_listview:SetJumpDirection(ListView.Top)
	self.task_listview:GetView():addScrollEventListener(BindTool.Bind(self.OnFlushEffectPos, self))
	self.mt_layout_root:TextLayout():addChild(self.task_listview:GetView(), 1)

	TaskData.Instance:ListenerTaskChange(self.task_callback)

	self.team_listview = ListView.New()
	self.team_listview:Create(53, y, list_size.width, list_size.height - task_h_shift, nil, MainuiTeamItemReander)
	self.team_listview:SetMargin(1)
	self.team_listview:GetView():setAnchorPoint(0, 1)
	self.team_listview:GetView():setVisible(false)
	self.team_listview:SetJumpDirection(ListView.Top)
	self.mt_layout_root:TextLayout():addChild(self.team_listview:GetView(), 1)



	self:OnTaskChange()
	self:OnTeamChange()
	if IS_ON_CROSSSERVER then
		self:OnClickTeam()
	end
	
	
	self.mt_layout_root2 = MainuiMultiLayout.CreateMultiLayout(190, self.global_y-100 , cc.p(0, 1), MainuiTask.Size, self.mt_layout_root, 0)
	sxdk1 = XUI.CreateImageView(0, 0, ResPath.GetMainui("task_bg2"), true)--左侧任务下底框
	self.mt_layout_root2:TextureLayout():addChild(sxdk1)
	sxdk2 = XUI.CreateImageView(0, 50, ResPath.GetMainui("task_bg4"), true)--左侧任务下底框
	self.mt_layout_root2:TextureLayout():addChild(sxdk2)
	sxdk3 = XUI.CreateImageView(0, 100, ResPath.GetMainui("task_bg2"), true)--左侧任务下底框
	self.mt_layout_root2:TextureLayout():addChild(sxdk3)
	sxdk4 = XUI.CreateImageView(0, 150, ResPath.GetMainui("task_bg4"), true)--左侧任务下底框
	self.mt_layout_root2:TextureLayout():addChild(sxdk4)
	sxdk5 = XUI.CreateImageView(0, 200, ResPath.GetMainui("task_bg2"), true)--左侧任务下底框
	self.mt_layout_root2:TextureLayout():addChild(sxdk5)
	sxdk6 = XUI.CreateImageView(0, 250, ResPath.GetMainui("task_bg4"), true)--左侧任务下底框
	self.mt_layout_root2:TextureLayout():addChild(sxdk6)
	sxdk1_txt = XUI.CreateText(50,0 ,130,0,cc.TEXT_ALIGNMENT_LEFT,"",nil,22,cc.c3b(0x00, 0xff, 0x00))--任务字体
	sxdk1_txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk1_txt)
	sxdk1_1txt = XUI.CreateText(-80,0 ,130,0,cc.TEXT_ALIGNMENT_CENTER,"攻击间隔",nil,22,cc.c3b(0xad, 0x90, 0x3c))--任务字体
	sxdk1_1txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk1_1txt)
	sxdk2_txt = XUI.CreateText(50,50 ,130,0,cc.TEXT_ALIGNMENT_LEFT,"",nil,22,cc.c3b(0x00, 0xff, 0x00))--任务字体
	sxdk2_txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk2_txt)
	sxdk1_2txt = XUI.CreateText(-80,50 ,130,0,cc.TEXT_ALIGNMENT_CENTER,"移动间隔",nil,22,cc.c3b(0xad, 0x90, 0x3c))--任务字体
	sxdk1_2txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk1_2txt)
	sxdk3_txt = XUI.CreateText(50,100 ,130,0,cc.TEXT_ALIGNMENT_LEFT,"",nil,22,cc.c3b(0x00, 0xff, 0x00))--任务字体
	sxdk3_txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk3_txt)
	sxdk1_3txt = XUI.CreateText(-80,100 ,130,0,cc.TEXT_ALIGNMENT_CENTER,"鞭尸概率",nil,22,cc.c3b(0xad, 0x90, 0x3c))--任务字体
	sxdk1_3txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk1_3txt)
	sxdk4_txt = XUI.CreateText(50,150 ,130,0,cc.TEXT_ALIGNMENT_LEFT,"",nil,22,cc.c3b(0x00, 0xff, 0x00))--任务字体
	sxdk4_txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk4_txt)
	sxdk1_4txt = XUI.CreateText(-80,150 ,130,0,cc.TEXT_ALIGNMENT_CENTER,"必鞭次数",nil,22,cc.c3b(0xad, 0x90, 0x3c))--任务字体
	sxdk1_4txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk1_4txt)
	sxdk5_txt = XUI.CreateText(50,200 ,130,0,cc.TEXT_ALIGNMENT_LEFT,"",nil,22,cc.c3b(0x00, 0xff, 0x00))--任务字体
	sxdk5_txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk5_txt)
	sxdk1_4txt = XUI.CreateText(-80,200 ,130,0,cc.TEXT_ALIGNMENT_CENTER,"刀刀切割",nil,22,cc.c3b(0xad, 0x90, 0x3c))--任务字体
	sxdk1_4txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk1_4txt)
	sxdk6_txt = XUI.CreateText(50,250 ,130,0,cc.TEXT_ALIGNMENT_LEFT,"",nil,22,cc.c3b(0x00, 0xff, 0x00))--任务字体
	sxdk6_txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk6_txt)
	sxdk1_4txt = XUI.CreateText(-80,250 ,130,0,cc.TEXT_ALIGNMENT_CENTER,"刀刀吸血",nil,22,cc.c3b(0xad, 0x90, 0x3c))--任务字体
	sxdk1_4txt:setAnchorPoint(0.5, 0.5)
	self.mt_layout_root2:TextLayout():addChild(sxdk1_4txt)
	
	shiywenzi = XUI.CreateText(90,150 ,80,0,cc.TEXT_ALIGNMENT_CENTER,"[使用]",nil,22,cc.c3b(0x00, 0xff, 0x00))
	self.mt_layout_root2:TextLayout():addChild(shiywenzi)
	XUI.AddClickEventListener(shiywenzi, BindTool.Bind(self.BianshiSHIY, self), true)
	
	
end

function MainuiTask:BianshiSHIY(show_menu)
	local BScs = RoleData.Instance:GetAttr(OBJ_ATTR.ACTOR_AAAAB)
if BScs >= 1 then
		RedPackageCtrl.Instance:SendBS()
else		
		SystemHint.Instance:FloatingTopRightText(Language.Xin.bbCS)
end
	XUI.AddClickEventListener(shiywenzi, BindTool.Bind(self.OnRecvMainRoleInfo, self))--刷新下面板
end


function MainuiTask:ChangeShowState(show_menu)
end

function MainuiTask:OnCarnivalCallback(protocol)
	local isopen = CarnivalData.Instance:BossIsOpen()
	local flag = false
	if isopen then
		local at_state,boss_state =  CarnivalData.Instance:getBossData()
		local server_time = TimeCtrl.Instance:GetServerTime() or os.time()
		local format_time = os.date("*t", server_time)		--获取年月日时分秒的表
		if format_time.hour == 20  then
			if format_time.min >= 0 and format_time.min <30 and boss_state<= 0 and at_state>0 then
				flag = true				
			else
				flag = false
			end
		else
			flag = false
		end		 
	end
	self.img_to_boss:setVisible(flag)
end

function MainuiTask:ChangeShowStateComoplete(show_menu)
end

function MainuiTask:OnTaskShowChange(show_type)
	--self:SetShowContent(show_type)
end
--自动上移
function MainuiTask:OnFunNoteVisibleChange(visible)
	if visible then
		self.mt_layout_root:setPosition(self.mt_layout_root:getPositionX(),self.global_y - 100)
	else
		self.mt_layout_root:setPosition(self.mt_layout_root:getPositionX(),self.global_y)
	end	
end	


function MainuiTask:OnClickTask()
	if IS_ON_CROSSSERVER then
		SysMsgCtrl.Instance:ErrorRemind(Language.Common.OnCrossServerTip)
		return 
	end

	self.showing_type = MainuiTask.SHOW_TYPE.LEFT
	
	self.global_y = HandleRenderUnit:GetHeight() - 240	
	self.mt_layout_root2:setPosition(190, self.global_y-100)
		
	self.task_listview:GetView():setVisible(true)
	self.team_listview:GetView():setVisible(false)
	self:OnFlushViewSize()
	self:CheckTaskListEffectVisible()

	self.is_click_type = 1
	self:UpdateNavBtnState()
end

function MainuiTask:OnClickTeam()
	self.showing_type = MainuiTask.SHOW_TYPE.RIGHT
	
	if self.team_listview:GetView():isVisible() then
		ViewManager.Instance:Open(ViewName.Team, TabIndex.team_info)
		return
	end
	self.global_y = HandleRenderUnit:GetHeight() - 240	
	self.mt_layout_root2:setPosition(-1000, self.global_y-100)
	
	self.task_listview:GetView():setVisible(false)
	self.team_listview:GetView():setVisible(true) 
	self:OnFlushViewSize()
	self:CheckTaskListEffectVisible()

	self.is_click_type = 2
	self:UpdateNavBtnState()
end

function MainuiTask:UpdateNavBtnState()
	if self.is_click_type == 1 then
		self.btn_team:loadTexture(ResPath.GetMainui("task_btn_bg"))
		self.btn_task:loadTexture(ResPath.GetMainui("task_btn_bg1"))
	else
		self.btn_team:loadTexture(ResPath.GetMainui("task_btn_bg1"))
		self.btn_task:loadTexture(ResPath.GetMainui("task_btn_bg"))
	end	
end	

function MainuiTask:OnClickArrawLeft()
	XUI.AddClickEventListener(shiywenzi, BindTool.Bind(self.OnRecvMainRoleInfo, self))--刷新下面板

	self.mt_layout_root1:setPositionX(330)--设置目标坐标x
	self.mt_layout_root2:setPositionX(-190)--设置目标坐标x
	
	self.mt_layout_root:MoveTo(0.3, - MainuiTask.Size.width-60+60, self.mt_layout_root:getPositionY())
	GlobalTimerQuest:AddDelayTimer(BindTool.Bind1(self.OnMoveComoplete, self), 0.3)
end

function MainuiTask:OnClickToCarnival()
	ViewManager.Instance:Open(ViewName.Carnival,TabIndex.carnival_goldBoss)
	ViewManager.Instance:FlushView(ViewName.Carnival,0,"type")
end

function MainuiTask:OnClickArrawRight()
	XUI.AddClickEventListener(shiywenzi, BindTool.Bind(self.OnRecvMainRoleInfo, self))--刷新下面板
	self.mt_layout_root1:setPositionX(-15)--设置目标坐标x
	self.mt_layout_root2:setPositionX(190)--设置目标坐标x
	self.mt_layout_root:MoveTo(0.3, 15+60, self.mt_layout_root:getPositionY())
	self.img_arrow_right:setVisible(false)
	self:CheckTaskListEffectVisible()
end

function MainuiTask:OnMoveComoplete()
	self.img_arrow_right:setVisible(true)
	self:CheckTaskListEffectVisible()
end

function MainuiTask:OnFlushViewSize()
	if nil == self.task_listview or nil == self.team_listview or nil == self.img_list_bg then return end
	if self.task_listview:GetView():isVisible() then
		local offset_height = 6
		local now_task_count = self.task_listview:GetCount()
		if now_task_count >= 3 then
			self.img_list_bg:setContentSize(cc.size(self.img_list_bg.base_size.width, self.img_list_bg.base_size.height - self.img_list_bg.task_h_shift + offset_height))
        else
			local error = 0
			if now_task_count > 0 then
				error = offset_height
			end	
			self.img_list_bg:setContentSize(cc.size(self.img_list_bg.base_size.width, now_task_count * MainuiTask.TaskRenderHeight + error))
		end
		local size = self.img_list_bg:getContentSize()
		if size.height > offset_height then
			size.height = size.height - offset_height
		end
		self.task_listview:GetView():setContentSize(size)
		
	elseif self.team_listview:GetView():isVisible() then
		local now_task_count = self.team_listview:GetCount()
		if now_task_count >= 2 then
			self.img_list_bg:setContentSize(cc.size(self.img_list_bg.base_size.width, self.img_list_bg.base_size.height - self.img_list_bg.task_h_shift))
		else
			self.img_list_bg:setContentSize(cc.size(self.img_list_bg.base_size.width, now_task_count * 90))
		end
	elseif self.left_content and self.left_content:GetView():isVisible() then
		self.img_list_bg:setContentSize(cc.size(self.img_list_bg.base_size.width, MainuiTask.Size.height - 60))
	elseif self.right_content and self.right_content:GetView():isVisible() then
		self.img_list_bg:setContentSize(cc.size(self.img_list_bg.base_size.width, MainuiTask.Size.height - 60))
	end  
end



-- 获取排序过的任务列表
function MainuiTask:GetSortTaskDataList()
	local task_list = TaskData.Instance:GetTaskList()
	local accept_task_list = TaskData.Instance:GetAcceptTaskList()

	local task_item_list = {}
	for k, v in pairs(task_list) do
		if not ClientMaskInfoCfg.TaskNotShow[v.task_id] 
			or v.task_state ~= TaskState.NotComplete then
			table.insert(task_item_list, v)
		end	
	end

	for k, v in pairs(accept_task_list) do
		if not ClientMaskInfoCfg.TaskNotShow[v.task_id] then
			table.insert(task_item_list, v)
		end	
	end

	-- 任务排序
	table.sort(task_item_list, function(a, b)
		-- 按类型排序
		local a_index = TaskTypeSortIndex[a.std_task.type] or 100
		local b_index = TaskTypeSortIndex[b.std_task.type] or 100
		if a_index < b_index then
			return true
		elseif a_index > b_index then
			return false
		end

		-- 按状态排序
		return a.task_state > b.task_state
	end)

	return task_item_list
end
	
function MainuiTask:OnTaskChange(reason, task_id)
	if reason == "finish" then
		MainuiTask.MainuiHasGuide[task_id] = nil
		self:RefreshTaskList()
	elseif reason == "add" 
		or reason == "giveup" 
		or reason == "task_list"
		or reason == "accept_list"
		or reason == "add_accept_list"  then	
		self:RefreshTaskList()
	else
		self:RefreshTaskList(true)	
	end	
end

function MainuiTask:RefreshTaskList(is_not_reset)
	if not is_not_reset then
		self:CheckTaskCompleteAnimRemove()    --检测当前指引特效是否需要删除

		local task_item_list = self:GetSortTaskDataList()
		self.task_listview:SetDataList(task_item_list)

		self:OnFlushViewSize()
		

		if task_item_list and #task_item_list > 0 then
			-- self.text_task:setString("任\n务" .. "\n(" .. #task_item_list .. ")")
			self.text_task:setString("属\n性")
		else
			self.text_task:setString("属\n性")
		end
	else
		self.task_listview:RefreshCurItems()	
	end
end	

function MainuiTask:OnTeamChange()
	local data_list = {}
	for i, v in ipairs(TeamData.Instance:GetMemberList()) do
		if v.role_id == TeamData.Instance:GetLeaderId() then
			table.insert(data_list, 1, {reander_type = "role", info = v})
		else
			table.insert(data_list, {reander_type = "role", info = v})
		end
	end
	
	local data_count = #data_list
	if data_count == 0 then
		table.insert(data_list, {reander_type = "create", info = nil})
	elseif data_count < TeamData.MaxMemberCount then
		table.insert(data_list, {reander_type = "invite", info = nil})
	end
	self.team_listview:SetDataList(data_list)
	if data_count > 0 then
		self.text_team:setString("组\n队" .. "\n(" .. data_count .. ")")
	else	
		self.text_team:setString("组\n队")
	end
	self:OnFlushViewSize()
end

function MainuiTask:OnRoleDataChangeCallback(key, value, old_value)
	if key == OBJ_ATTR.CREATURE_LEVEL then
		self:OnTaskChange()
	end
end

function MainuiTask:SetVisible(vis)
	if self.mt_layout_root then
		self.mt_layout_root:setVisible(vis)
	end
end

---------------------------------
-- 任务导航特效

function MainuiTask:CheckTaskListEffectVisible()
	local is_visible = true
	if not self.task_listview or not self.task_listview:GetView():isVisible()
		or (self.img_arrow_right and self.img_arrow_right:isVisible()) then
		is_visible = false
	end

	if nil ~= self.arrow_point then self.arrow_point:setVisible(is_visible) end
end

-- 主线&除魔任务可完成特效
function MainuiTask:ShowTaskCompleteAnim(item, is_anim_on)

	if not is_anim_on then
		if nil ~= self.arrow_point then
			self:RemoveTaskCompleteAnim()
		end
		return
	end

	if nil == self.task_listview or not self.task_listview:GetView():isVisible() then
		if nil ~= self.arrow_point then
			self:RemoveTaskCompleteAnim()
		end
		return
	end

	local index = self.task_listview:GetItemIndex(item)
	local task_id = item:GetData() and item:GetData().task_id
	if nil == index or MainuiTask.MainuiHasGuide[task_id] then return end
	MainuiTask.MainuiHasGuide[task_id] = true

	if nil == self.arrow_point then
		self:CreateFingerEffec()
	end
		
	self.arrow_point.task_id = task_id
	self.arrow_point.task_index = index
	self:OnFlushTaskCompleteAnimPos()
	
end

function MainuiTask:OnFlushTaskCompleteAnimPos()
	if nil == self.task_listview or nil == self.arrow_point or nil == self.arrow_point.task_index then return end

	local index = self.arrow_point.task_index
	local list_y = self.task_listview:GetView():getPositionY()
	local list_container = self.task_listview:GetView():getInnerContainer()
	if nil == list_container then return end
	local con_x, con_y = list_container:getPosition()
	local con_size = list_container:getContentSize()
	local list_size = self.task_listview:GetView():getContentSize()
	local item_con_y = - index * MainuiTask.TaskRenderHeight + MainuiTask.TaskRenderHeight / 2
	local real_y = item_con_y + (con_size.height - list_size.height + con_y)
	if real_y > 0 or real_y < - list_size.height then
		self.arrow_point:setVisible(false)
	else
		self.arrow_point:setVisible(true)
		self.arrow_point:setPosition(200, list_y + real_y)
	end
end

function MainuiTask:CreateFingerEffec()	
	if nil == self.arrow_point then	
		self.arrow_point = XUI.CreateImageView(0, 0, ResPath.GetGuide("figer_point"))
		self.arrow_point:setAnchorPoint(0, 1)
		self.mt_layout_root:TextLayout():addChild(self.arrow_point, 100)

		self.arrow_point:loadTexture(ResPath.GetGuide("figer_point"))
		local callback = cc.CallFunc:create(function()
			self.arrow_point:loadTexture(ResPath.GetGuide("figer_point1"))
		end)
		local callback1 = cc.CallFunc:create(function()
			self.arrow_point:loadTexture(ResPath.GetGuide("figer_point"))
		end)

		local action = cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.5),callback,cc.DelayTime:create(0.5),callback1))
		self.arrow_point:runAction(action)
	end
end

function MainuiTask:CheckTaskCompleteAnimRemove()
	if nil == self.arrow_point then return end
	if nil == self.task_listview or nil == self.arrow_point.task_id
		or nil == self.arrow_point.task_index then
		self:RemoveTaskCompleteAnim()
		return
	end

	local item = self.task_listview:GetItemAt(self.arrow_point.task_index)
	if nil == item then
		self:RemoveTaskCompleteAnim()
		return
	end

	if not item:GetData() or item:GetData().task_id ~= self.arrow_point.task_id then
		self:RemoveTaskCompleteAnim()
		return
	end
end

function MainuiTask:RemoveTaskCompleteAnim()
	self.arrow_point:removeFromParent()
	self.arrow_point = nil
end



function MainuiTask:OnFlushEffectPos()
	self:OnFlushTaskCompleteAnimPos()
end

------------------------------------------------------------------------
-- 任务Reander
MainuiTaskItemReander = MainuiTaskItemReander or BaseClass(BaseRender)
function MainuiTaskItemReander:__init()
	self.view:setContentWH(MainuiTask.Size.width, MainuiTask.TaskRenderHeight)

	self.text_title = nil
	self.text_state = nil
	self.rich_desc = nil

	self.task_id = 0
	self.task_state = 0
	self.cur_value = 0
end

function MainuiTaskItemReander:__delete()
	
	if nil ~= self.anim_sprite then
		self.anim_sprite:removeFromParent()
		self.anim_sprite = nil
	end

	self.rich_desc_mark_t = nil
end

function MainuiTaskItemReander:CreateChild()
	BaseRender.CreateChild(self)

	self:AddClickEventListener(nil, true)

	local img_line = XUI.CreateImageView(MainuiTask.Size.width / 2+99999, 0, ResPath.GetMainui("task_line"), true)--分割线
	self.view:addChild(img_line, -1)

	self.title_bg = XUI.CreateImageView(4+99999,MainuiTask.TaskRenderHeight - 37,ResPath.GetMainui("main_task_title_bg"), true)--任务标志
	self.title_bg:setAnchorPoint(0, 0)
	self.view:addChild(self.title_bg)

	self.text_title = XUI.CreateText(15+99999, MainuiTask.TaskRenderHeight - 15, MainuiTask.Size.width - 70, 0, cc.TEXT_ALIGNMENT_LEFT, "", nil, nil, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--任务标题
	self.text_title:setAnchorPoint(0, 0.5)
	self.view:addChild(self.text_title)

	self.text_state = XUI.CreateText(self.text_title:getPositionX()+100+99999, self.text_title:getPositionY(), 80, 0, cc.TEXT_ALIGNMENT_RIGHT, "", nil, nil, nil,cc.VERTICAL_TEXT_ALIGNMENT_CENTER)--可交可接提示
	self.text_state:setAnchorPoint(0, 0.5)
	self.view:addChild(self.text_state)

	self.rich_desc = XUI.CreateRichText(165+99999, 15, MainuiTask.Size.width - 6, 24)--任务内容
	self.rich_desc:setHorizontalAlignment(RichHAlignment.HA_LEFT)
	self.rich_desc:setVerticalAlignment(RichVAlignment.VA_CENTER)
	self.rich_desc:setMaxLine(1)
	XUI.SetRichTextVerticalSpace(self.rich_desc,0)
	self.view:addChild(self.rich_desc)

	self.rich_desc_mark_t = {}
end

function MainuiTaskItemReander:OnFlush()
	
	self.task_id = self.data.task_id
	self.task_state = self.data.task_state
	self.cur_value = (nil ~= self.data.target) and self.data.target.cur_value or 0

	if self.data.std_task.type == TaskType.Main then
		self.title_bg:loadTexture(ResPath.GetMainui("main_task_title_bg"))
	else
		self.title_bg:loadTexture(ResPath.GetMainui("other_task_title_bg"))
	end	

	-- self.text_title:setString(string.format("[%s]    %s", Language.Task.SpTypeName[self.task_id] or Language.Task.TypeName[self.data.std_task.type or 0], self.data.std_task.name))
	self.text_title:setString(string.format("%s    %s", Language.Task.SpTypeName[self.task_id] or Language.Task.TypeName[self.data.std_task.type or 0], self.data.std_task.name))
	self.text_title:setColor(COLOR3B.GOLD)

	self.text_state:setVisible(true)
	self.text_state:setString(string.format("(%s)", Language.Task.State[self.data.task_state]))
	if self.data.task_state == TaskState.Complete then
		self.text_state:setColor(COLOR3B.GREEN)
	elseif self.data.task_state == TaskState.Accept then
		self.text_state:setColor(COLOR3B.WHITE)
	else	
		self.text_state:setColor(COLOR3B.RED)
	end

	self:ParseDesc()
	
	self:OnFlushAcceptProcessEffect(self.task_state)
	self:OnFlushAcceptPromptEffect(self.task_state)
	self:OnFlushCompleteEffect(self.task_state)

	self:ShowFumoEffect()
end

function MainuiTaskItemReander:ShowFumoEffect()
	local level = RoleData.Instance:GetAttr(OBJ_ATTR.CREATURE_LEVEL)
	if level <= 80 then
		if self.data and self.data.std_task.type == TaskType.Book 
			and self.data.task_state == TaskState.Complete then
			if not self.fumo_effect then
				self.fumo_effect = RenderUnit.CreateEffect(10, self.view, 0, FrameTime.Effect, COMMON_CONSTS.MAX_LOOPS, MainuiTask.Size.width * 0.5, MainuiTask.TaskRenderHeight * 0.5)
				self.fumo_effect:setScaleX(1.2)
			end
		else
			if self.fumo_effect then
				self.fumo_effect:removeFromParent()
				self.fumo_effect = nil
			end	
		end	
	end
end	

----------------------------------
-- 特效
function MainuiTaskItemReander:OnFlushAcceptProcessEffect(state)
	if nil == self.data or nil == self.data.task_id or nil == self.data.std_task.type
		or state ~= 1 or not (self.data.std_task.type == 0 or self.data.std_task.type == 3)
		or self.data.std_task.type == 3 and not (self.data.task_id == 4000)
		or (self.data.target and self.data.target.target_type == TaskTarget.ActorLevel) then
		-- self.accept_process_effect:setVisible(false)
		self:SetAcceptProcessEffectVisible(false)
		return
	end

	-- self.accept_process_effect:setVisible(true)
	self:SetAcceptProcessEffectVisible(true)
end

function MainuiTaskItemReander:OnFlushAcceptPromptEffect(state)
	if not self.data or state ~= TaskState.Accept then return end
	if self.data.is_show_accept_effect then
		self:SetAcceptProcessEffectVisible(true)
		self.data.is_show_accept_effect = nil
	end
end

function MainuiTaskItemReander:SetAcceptProcessEffectVisible(is_visible)
	-- if nil == self.accept_process_effect then
	-- 	local size = self.view:getContentSize()
	-- 	self.accept_process_effect = XUI.CreateImageViewScale9(size.width / 2, size.height / 2, size.width, size.height, ResPath.GetCommon("cell_select_bg"), true,cc.rect(40,40,70,70))
	-- 	if nil == self.accept_process_effect then
	-- 		ErrorLog("MainuiTaskItemReander:Create accept_process_effect fail")
	-- 		return
	-- 	end
	-- 	self.accept_process_effect:setVisible(false)
	-- 	self.view:addChild(self.accept_process_effect, 999)
	-- end

	-- self.accept_process_effect:setVisible(is_visible)
end

function MainuiTaskItemReander:OnFlushCompleteEffect(state)
	if nil == self.data or nil == self.data.task_id or state ~= TaskState.Complete
		or not (self.data.std_task.type == TaskType.Main or self.data.std_task.type == TaskType.Book) then return end

	if TaskData.Instance:GetTaskIsJustComplete(self.data.task_id) then
		local main_ui_view = MainuiCtrl.Instance and MainuiCtrl.Instance.view
		local main_ui_task_view = main_ui_view and main_ui_view.mainui_task
		if nil ~= main_ui_task_view then
			main_ui_task_view:ShowTaskCompleteAnim(self, true)
		end
	end
end

function MainuiTaskItemReander:OnCloseCompleteEffect()
	local main_ui_view = MainuiCtrl.Instance and MainuiCtrl.Instance.view
	local main_ui_task_view = main_ui_view and main_ui_view.mainui_task
	if nil ~= main_ui_task_view then
		main_ui_task_view:ShowTaskCompleteAnim(self, false)
	end
end

function MainuiTaskItemReander:OnShowAddTaskEffect()
	if nil ~= self.view then
		
		local old_x = MainuiTask.Size.width / 2

		local action_time = MainuiTask.TaskFinishAnimParams[1]
		local callback_start = cc.CallFunc:create(function()
				if self.view then
					self.view:setOpacity(1)
					self.view:setPositionX(old_x - MainuiTask.TaskFinishAnimParams[2])
				end
			end)
		local move_action = cc.MoveBy:create(action_time, cc.p(MainuiTask.TaskFinishAnimParams[2], 0))
		local fadein_action = cc.FadeIn:create(action_time)
		local spawn_action = cc.Spawn:create(move_action, fadein_action)
		local callback_end = cc.CallFunc:create(function()
				if self.view then
					self.view:setPositionX(old_x)
				end
			end)
		local action = cc.Sequence:create(callback_start, spawn_action, callback_end)
		self.view:stopAllActions()
		self.view:runAction(action)
	end
end

----------------------------------

function MainuiTaskItemReander:ParseDesc()
	self.rich_desc:removeAllElements()
	self.rich_desc_mark_t = {}

	if self.data.task_state == TaskState.Accept then
		if nil ~= self.data.npc then
			self:SetMyRichDesc(string.format(Language.Task.Accept, self.data.npc.name))
			-- RichTextUtil.ParseRichText(self.rich_desc, string.format(Language.Task.Accept, self.data.npc.name))
		end

		if self.data.std_task.type == TaskType.Day then
			if nil ~= TaskData.GetSpecialQuestsOpenView(self.data.task_id) then
				self:SetMyRichDesc(string.format(Language.Task.OpenView, self.data.title))
				-- RichTextUtil.ParseRichText(self.rich_desc, string.format(Language.Task.OpenView, self.data.title))
			end
		elseif self.data.std_task.type == TaskType.Book then --伏魔任务
			FuMoData.Instance:SetFumoFinishMaxCount()
			self:SetMyRichDesc(string.format(Language.Task.FumoAcceptFormat,FuMoData.Instance.finish_count,FuMoData.Instance.finish_max_count))
			--print("可接的伏魔任务")
		end
	elseif self.data.task_state == TaskState.Complete then
		if nil ~= self.data.npc then
			self:SetMyRichDesc(string.format(Language.Task.Complete, self.data.npc.name))
			-- RichTextUtil.ParseRichText(self.rich_desc, string.format(Language.Task.Complete, self.data.npc.name))
		end
	else
		
		if #self.data.progress_list <= 0 then
			return
		end	

		local progress_info = self.data.progress_list[1] --当前进度值
		local target = self.data.std_task.target[progress_info.target_index] --配置目标值


		if target.type == TaskTarget.Monster then
			local monster_info = ConfigManager.Instance:GetMonsterConfig(target.id)
			self:SetMyRichDesc(string.format(Language.Task.Target.Monster,  DelNumByString(monster_info.name)))
			-- RichTextUtil.ParseRichText(self.rich_desc, 
			-- 	string.format(Language.Task.Target.Monster, self.data.target.name))
			self:FormatValue(progress_info.cur_value,target.count)

		elseif target.type == TaskTarget.Collect then
			local monster_info = ConfigManager.Instance:GetMonsterConfig(target.id)
			self:SetMyRichDesc(string.format(Language.Task.Target.Collect,  DelNumByString(monster_info.name)))
			-- RichTextUtil.ParseRichText(self.rich_desc, 
			-- 	string.format(Language.Task.Target.Collect, self.data.target.name))
			self:FormatValue(progress_info.cur_value,target.count)

		elseif target.type == TaskTarget.Consume then
			--self:SetMyRichDesc(string.format(Language.Task.Target.Consume, self.data.target.name))
			-- RichTextUtil.ParseRichText(self.rich_desc, 
			-- 	string.format(Language.Task.Target.Consume, self.data.target.name))
			--self:FormatValue(progress_info.cur_value,target.count)

		elseif target.type == TaskTarget.Dialog then
			--self:SetMyRichDesc(string.format(Language.Task.Target.Dialog, self.data.target.name))
			-- RichTextUtil.ParseRichText(self.rich_desc, 
			-- 	string.format(Language.Task.Target.Dialog, self.data.target.name))

		elseif target.type == TaskTarget.Send then
			--self:SetMyRichDesc(string.format(Language.Task.Target.Send, self.data.target.id, self.data.target.name))
			-- RichTextUtil.ParseRichText(self.rich_desc, 
			-- 	string.format(Language.Task.Target.Send, self.data.target.id, self.data.target.name))

		elseif target.type == TaskTarget.ActorLevel then
			--self.text_state:setVisible(false)
			self:SetMyRichDesc(string.format(Language.Task.Target.ActorLevel, target.count))
			
		elseif target.type == TaskTarget.KillBoss then
			if target.id ~= 0 then
				local monster_info = ConfigManager.Instance:GetMonsterConfig(target.id)
				self:SetMyRichDesc(string.format(Language.Task.Target.Monster, self.data.target.name))
				-- RichTextUtil.ParseRichText(self.rich_desc, 
				-- 	string.format(Language.Task.Target.Monster, self.data.target.name))
			else
				self:SetMyRichDesc(string.format(Language.Task.Target.KillBoss))
				-- RichTextUtil.ParseRichText(self.rich_desc, string.format(Language.Task.Target.KillBoss))
			end
			self:FormatValue(progress_info.cur_value,target.count)
		elseif target.type == TaskTarget.SceneKillAnyMon then
			local scene_info = ConfigManager.Instance:GetSceneConfig(target.id)	
			self:SetMyRichDesc(string.format(Language.Task.Target.Monster, string.format(Language.Task.KillAnyMon,scene_info.name)))
			self:FormatValue(progress_info.cur_value,target.count)
		elseif target.type == TaskTarget.KillLevelMonster then	
			
			self:SetMyRichDesc(string.format(Language.Task.Target.Monster,  string.format(Language.Task.KillLevelMon,target.id)))
			self:FormatValue(progress_info.cur_value,target.count)
		elseif target.type == TaskTarget.CountEquipTakeOn then
			self:SetMyRichDesc(string.format(Language.Task.Target.CountEquipTake,  target.count,target.id,progress_info.cur_value, target.count))
		elseif target.type == TaskTarget.CountCircleEquipTakeOn then
			self:SetMyRichDesc(string.format(Language.Task.Target.CountCircleEquipTake,  target.count,target.id,progress_info.cur_value, target.count))
		elseif target.type == TaskTarget.FinishFumoTick then
			self:SetMyRichDesc(string.format(Language.Task.Target.FinishFumoTick,  target.count))	
		elseif target.type == TaskTarget.SearchScene then
			local scene_info = ConfigManager.Instance:GetSceneConfig(target.id)	
			self:SetMyRichDesc(string.format(Language.Task.Target.SearchScene,  scene_info.name))	
		elseif target.type == TaskTarget.Acitivity then	
			self:SetMyRichDesc(string.format(Language.Task.Target.ActivityTips[target.id]))	
			self:FormatValue(progress_info.cur_value,target.count)
		elseif target.type == TaskTarget.EnterGuild then
			self:SetMyRichDesc(string.format(Language.Task.Target.JoinGuild))	
		elseif target.type == TaskTarget.ComposeEquipUpgrade then
			local tar_step,tar_star = ComposeData.Instance:GetStepStar(target.count)
			local cur_step,cur_star = ComposeData.Instance:GetStepStar(progress_info.cur_value)
			self:SetMyRichDesc(string.format(Language.Task.Target.ComposeEquipUpgrade,Language.Task.Target.ComposeEquipUpgradeType[target.id],tar_step,tar_star,cur_step,cur_star))	
		elseif target.type == TaskTarget.EquipOperation then
			self:SetMyRichDesc(string.format(Language.Task.Target.EquipOperation,Language.Task.Target.EquipOperationType[target.id]))
		elseif target.type == TaskTarget.CountEquipStrengthen then	
			self:SetMyRichDesc(string.format(Language.Task.Target.CountEquipStrengthen, target.count, target.id, progress_info.cur_value, target.count))	
		end
	end
end

function MainuiTaskItemReander:FormatValue(cur_value,target_value)
	if cur_value >= target_value then
		-- XUI.RichTextAddText(self.rich_desc, string.format("(%d/%d)", self.data.target.target_value, 
		-- 	self.data.target.target_value), nil, 20, COLOR3B.GREEN)
		self:AddMyRichDesc(string.format("(%d/%d)", target_value, 
			target_value), nil, 20, COLOR3B.GREEN)
	else
		-- XUI.RichTextAddText(self.rich_desc, string.format("(%d/%d)", self.data.target.cur_value, 
		-- 	self.data.target.target_value), nil, 20, COLOR3B.WHITE)
		self:AddMyRichDesc(string.format("(%d/%d)", cur_value, 
			target_value), nil, 20, COLOR3B.GREEN)
	end
end



function MainuiTaskItemReander:OnClick()
	BaseRender.OnClick(self)
	TaskCtrl.ExeTask(self.data)
	self:OnCloseCompleteEffect()
end

function MainuiTaskItemReander.OnClickTask(data)
	if Story.Instance:GetIsStoring() then
		return false
	end
	
end


function MainuiTaskItemReander:CreateSelectEffect()
end

function MainuiTaskItemReander:SetMyRichDesc(text)
	if nil == self.rich_desc then return end
	RichTextUtil.ParseRichText(self.rich_desc, text)
	self:SetRichDescMarkTable("text", text)
end

function MainuiTaskItemReander:AddMyRichDesc(text, font, font_size, color)
	if nil == self.rich_desc then return end
	XUI.RichTextAddText(self.rich_desc, text, font, font_size, color)
	
	self:SetRichDescMarkTable("add_text", text)
	self:SetRichDescMarkTable("add_font", font)
	self:SetRichDescMarkTable("add_font_size", font_size)
	self:SetRichDescMarkTable("add_color", color)
end

-- index 	"text"/"add_text"/"add_font"/"add_font_size"/"add_color"
function MainuiTaskItemReander:SetRichDescMarkTable(index, value)
	if nil == index then return end
	value = value or ""
	if not self.rich_desc_mark_t then self.rich_desc_mark_t = {} end
	self.rich_desc_mark_t[index] = value
end

------------------------------------------------------------------------
-- 队伍Reander
MainuiTeamItemReander = MainuiTeamItemReander or BaseClass(BaseRender)
function MainuiTeamItemReander:__init()
	self.view:setContentWH(MainuiTask.Size.width, MainuiTask.TeamRenderHeight)

	self.img_icon = nil
	self.text_name = nil
end

function MainuiTeamItemReander:__delete()
	AvatarManager.Instance:CancelUpdateAvatar(self.img_head)
end

function MainuiTeamItemReander:CreateChild()
	BaseRender.CreateChild(self)

	self:AddClickEventListener(nil, true)
	
	local img_DK = XUI.CreateImageViewScale9(53, 40, 420, 80, ResPath.GetMainui("task_bg"), true)--信息底框
	img_DK:setOpacity(150)--设置透明度
	self.view:addChild(img_DK, -1)
	
	self.img_icon = XUI.CreateImageView(40, 40, ResPath.GetMainui("team_add"), true)--创建队伍前图标
	self.view:addChild(self.img_icon)

	self.img_head = XUI.CreateImageView(50, 40, ResPath.GetRoleHead("big_1_0"), true)--头像
	self.img_head:setScale(0.7)
	self.view:addChild(self.img_head)

	self.header_ident_img = XUI.CreateImageView(242, 60, ResPath.GetMainui("team_header"), true)--队长标志
	self.view:addChild(self.header_ident_img)

	self.text_name = XUI.CreateText(95, 70, MainuiTask.Size.width - 60, 20, cc.TEXT_ALIGNMENT_LEFT, "",nil,18, COLOR3B.DEEP_R_Y)--角色名
	self.text_name:setAnchorPoint(0, 0.5)
	self.view:addChild(self.text_name)

	self.level_text = XUI.CreateText(95, 40, 100, 20, cc.TEXT_ALIGNMENT_LEFT, "",nil,18, COLOR3B.DEEP_R_Y)--等级
	self.level_text:setAnchorPoint(0, 0.5)
	self.view:addChild(self.level_text)

	self.zhanli_text = XUI.CreateText(95, 20, 300, 20, cc.TEXT_ALIGNMENT_LEFT, "",nil,18, COLOR3B.DEEP_R_Y)--战力
	self.zhanli_text:setAnchorPoint(0, 0.5)
	self.view:addChild(self.zhanli_text)
end

function MainuiTeamItemReander:OnFlush()
	if not self.data then
		return
	end	
	self.header_ident_img:setVisible(false)
	self.img_icon:setVisible(false)
	self.level_text:setVisible(false)
	self.zhanli_text:setVisible(false)
	self.text_name:setPositionY(40)
	if "create" == self.data.reander_type then
		self:SetStyle(false, Language.Team.Create)--创建队伍
		self.img_icon:setVisible(true)
	elseif "invite" == self.data.reander_type then
		self:SetStyle(false, Language.Team.Invite)--邀请组队
		self.img_icon:setVisible(true)
	elseif "role" == self.data.reander_type then
		self.text_name:setPositionY(57)
		local info = self.data.info
		self:SetStyle(true, info.name)
		if self.index == 1 then
			self.header_ident_img:setVisible(true)
		end
		self.level_text:setString(info.level.."级战士")
		self.level_text:setVisible(true)
		
		self.zhanli_text:setString("战力："..info.capacity)
		self.zhanli_text:setVisible(true)
		
		AvatarManager.Instance:UpdateAvatarImg(self.img_head, info.role_id, info.prof, true, false, info.sex)


	end

	if self.data.info and self.data.info.is_online == 0 then
		self.img_head:setGrey(true)
	else
		self.img_head:setGrey(false)
	end	
end

function MainuiTeamItemReander:SetStyle(is_visible, name)
	self.img_head:setVisible(is_visible)
	self.text_name:setString(name)
end

function MainuiTeamItemReander:OnClick()
	if "create" == self.data.reander_type then
		TeamCtrl:SendCreateTeamReq()
		ViewManager.Instance:Open(ViewName.Team, TabIndex.team_info)
	elseif "invite" == self.data.reander_type then
		ViewManager.Instance:Open(ViewName.Team, TabIndex.team_friend)
	else
		ViewManager.Instance:Open(ViewName.Team, TabIndex.team_info)
	end
end

function MainuiTeamItemReander:CreateSelectEffect()
end
