
-- 可以在任意位置出现的摇杆

AnyJoystick = AnyJoystick or BaseClass()

JoystickEvent = {
	Began = 0,
	Update = 1,
	Ended = 2,
}

function AnyJoystick:__init(x,y,event_node)
	self.view = XLayout:create()
	--self.view:setVisible(false)

	self.img_bg = nil
	self.img_ball = nil
	self.radius = 0

	self.is_start = false
	self.touch_id = nil
	
	self.fix_point = cc.p(x,y)
	self.began_point = cc.p(0, 0)
	self.last_event_time = 0
	self.touch_timer = nil
	self.timeFlag = 0

	self.callback = nil
	self.view:setPosition(self.fix_point.x,self.fix_point.y)
	self.event_board = event_node
	self:RegisterAllEvents()
end

function AnyJoystick:__delete()
	self.view = nil
	self:UnRegisterAllEvents()
	self:EndTimer()
end

function AnyJoystick:RegisterAllEvents()
	-- self.eh_began = GlobalEventSystem:Bind(LayerEventType.TOUCH_BEGAN, BindTool.Bind(self.OnTouchBegan, self))
	-- self.eh_moved = GlobalEventSystem:Bind(LayerEventType.TOUCH_MOVED, BindTool.Bind(self.OnTouchMoved, self))
	-- self.eh_ended = GlobalEventSystem:Bind(LayerEventType.TOUCH_ENDED, BindTool.Bind(self.OnTouchEnded, self))
	-- self.eh_cancelled = GlobalEventSystem:Bind(LayerEventType.TOUCH_CANCELLED, BindTool.Bind(self.OnTouchCancelled, self))
	self.event_board:addTouchEventListener(BindTool.Bind(self.OnTouchEvent, self))
end

function AnyJoystick:UnRegisterAllEvents()
	-- GlobalEventSystem:UnBind(self.eh_began)
	-- GlobalEventSystem:UnBind(self.eh_moved)
	-- GlobalEventSystem:UnBind(self.eh_ended)
	-- GlobalEventSystem:UnBind(self.eh_cancelled)
end

function AnyJoystick:OnTouchEvent(sender, event_type, touch)
	if event_type == XuiTouchEventType.Began then
		self:OnTouchBegan(touch,event_type)
		if not GuideCtrl.Instance:IsFuncGuideing() and not  MovieGuideCtrl.Instance:IsGuiding() then
			MainuiCtrl.Instance:PushMainuiNavBtnToggle(false)
		end	
	elseif event_type == XuiTouchEventType.Moved then
		self:OnTouchMoved(touch,event_type)
	else
		self:OnTouchEnded(touch,event_type)
	end	
end	

function AnyJoystick:GetView()
	return self.view
end

function AnyJoystick:Create(bg_path, ball_path)
	self.img_bg = XUI.CreateImageView(0, 0, bg_path, is_plist)
	self.view:addChild(self.img_bg)
	self.radius = self.img_bg:getContentSize().width / 2

	self.img_ball = XUI.CreateImageView(0, 0, ball_path, is_plist)
	self.view:addChild(self.img_ball)
end

function AnyJoystick:SetCallback(callback)
	self.callback = callback
end

function AnyJoystick:OnTouchBegan(touch, event)
	if nil ~= self.touch_id then
		return
	end
	self.touch_id = touch:getId()
	local now_point = touch:getLocation()
	self.began_point.x = now_point.x
	self.began_point.y = now_point.y
		
	local screen_w = HandleRenderUnit:GetWidth()/2
	local screen_h = HandleRenderUnit:GetHeight()
	if self.began_point.x < screen_w and self.began_point.y < screen_h then
		if self.began_point.x>=95 and self.began_point.x<=360 and self.began_point.y>= 105 and self.began_point.y<= 300 then
			self.timeFlag = 17
		end
		self:StartTimer()
		
	end
end

function AnyJoystick:OnTouchMoved(touch, event)
	if self.touch_id ~= touch:getId() then
		return
	end
	if self.is_start then
		local now_point = touch:getLocation()
		self:MoveBall(now_point.x - self.began_point.x, now_point.y - self.began_point.y)
	end
end

function AnyJoystick:OnTouchEnded(touch, event)
	if self.touch_id ~= touch:getId() then
		return
	end
	self.touch_id = nil

	self:EndTimer()
	self:MoveBall(0, 0, true)
	self.timeFlag = 0
	if self.is_start then
		self.is_start = false
		self:PushEvent(JoystickEvent.Ended)
		self.view:setPosition(self.fix_point.x,self.fix_point.y)
		-- local fadeout = cc.FadeOut:create(0.2)
		-- local callback = cc.CallFunc:create(function()
		-- 	if nil ~= self.view then
		-- 		self.view:setVisible(false)
		-- 	end
		-- end)
		-- local action = cc.Sequence:create(fadeout, callback)
		-- self.view:stopAllActions()
		-- self.view:runAction(action)
	end
end

function AnyJoystick:OnTouchCancelled(touch, event)
	self:OnTouchEnded(touch, event)
end

function AnyJoystick:StartTimer()
	if nil == self.touch_timer then
		self.touch_timer = GlobalTimerQuest:AddRunQuest(BindTool.Bind1(self.OnTimerUpdate, self), 0.05)
		self:OnTimerUpdate()
	end
end

function AnyJoystick:OnTimerUpdate()
	if self.timeFlag >= 17 then
		if self.timeFlag == 17 then
			self.timeFlag = self.timeFlag +1
			local nowlibX,nowlibY = self.began_point.x,self.began_point.y
			local dir_vec = cc.p(self.began_point.x - self.fix_point.x,self.began_point.y - self.fix_point.y)
			local len = cc.pGetLength(dir_vec)
			if len > 75 then
				dir_vec = cc.pNormalize(dir_vec)
				dir_vec = cc.pMul(dir_vec,len - 75)
				self.began_point.x = self.fix_point.x + dir_vec.x
				self.began_point.y = self.fix_point.y + dir_vec.y
			else
				self.began_point.x = self.fix_point.x
				self.began_point.y = self.fix_point.y
			end	
			
			self.is_start = false
			self:MoveBall(nowlibX - self.began_point.x, nowlibY - self.began_point.y)
		end

		if not self.is_start then
			self.is_start = true

			local parent = self.view:getParent()
			if nil ~= parent then
				local node_pos = parent:convertToNodeSpace(self.began_point)
				self.view:setPosition(node_pos)
			end

			--self.view:setVisible(true)
			--self.view:setOpacity(64)
			self:PushEvent(JoystickEvent.Began)
		else
			local opacity = math.min(self.view:getOpacity() + 32, 255)
			--self.view:setOpacity(opacity)
			self:PushEvent(JoystickEvent.Update)
			
		end
	else
		self.timeFlag = self.timeFlag +1
	end
end

function AnyJoystick:EndTimer()
	if nil ~= self.touch_timer then
		GlobalTimerQuest:CancelQuest(self.touch_timer)
		self.touch_timer = nil
	end
end

function AnyJoystick:MoveBall(x, y, is_animation)
	self.img_ball:stopAllActions()

	local real_x, real_y = x, y
	local dis = GameMath.GetDistance(x, y, 0, 0, true)
	if dis > self.radius then
		real_x = x / dis * self.radius
		real_y = y / dis * self.radius
	end

	if is_animation then
		local move_to = cc.MoveTo:create(0.2, cc.p(real_x, real_y))
		self.img_ball:runAction(move_to)
	else
		self.img_ball:setPosition(real_x, real_y)
	end
end

function AnyJoystick:PushEvent(event_type)
	if nil ~= self.callback then
		local x, y = self.img_ball:getPosition()
		self.callback(event_type, x, y)
	end
end
